var Ns = Object.defineProperty;
var Hs = (t, e, s) => e in t ? Ns(t, e, { enumerable: !0, configurable: !0, writable: !0, value: s }) : t[e] = s;
var Ee = (t, e, s) => (Hs(t, typeof e != "symbol" ? e + "" : e, s), s);
import { fromCodePoint as Ot, StateField as xs, RangeSetBuilder as bt, Facet as qe, EditorState as Ye, StateEffect as Gs, Prec as fs } from "@codemirror/state";
import { ViewPlugin as Xe, EditorView as ue, Decoration as Z, WidgetType as Ws, Direction as Ae, logException as zs } from "@codemirror/view";
const ps = 1024;
let Us = 0;
class Qe {
  constructor(e, s) {
    this.from = e, this.to = s;
  }
}
class k {
  /**
  Create a new node prop type.
  */
  constructor(e = {}) {
    this.id = Us++, this.perNode = !!e.perNode, this.deserialize = e.deserialize || (() => {
      throw new Error("This node type doesn't define a deserialize function");
    });
  }
  /**
  This is meant to be used with
  [`NodeSet.extend`](#common.NodeSet.extend) or
  [`LRParser.configure`](#lr.ParserConfig.props) to compute
  prop values for each node type in the set. Takes a [match
  object](#common.NodeType^match) or function that returns undefined
  if the node type doesn't get this prop, and the prop's value if
  it does.
  */
  add(e) {
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof e != "function" && (e = W.match(e)), (s) => {
      let i = e(s);
      return i === void 0 ? null : [this, i];
    };
  }
}
k.closedBy = new k({ deserialize: (t) => t.split(" ") });
k.openedBy = new k({ deserialize: (t) => t.split(" ") });
k.group = new k({ deserialize: (t) => t.split(" ") });
k.isolate = new k({ deserialize: (t) => {
  if (t && t != "rtl" && t != "ltr" && t != "auto")
    throw new RangeError("Invalid value for isolate: " + t);
  return t || "auto";
} });
k.contextHash = new k({ perNode: !0 });
k.lookAhead = new k({ perNode: !0 });
k.mounted = new k({ perNode: !0 });
class Ne {
  constructor(e, s, i) {
    this.tree = e, this.overlay = s, this.parser = i;
  }
  /**
  @internal
  */
  static get(e) {
    return e && e.props && e.props[k.mounted.id];
  }
}
const Vs = /* @__PURE__ */ Object.create(null);
class W {
  /**
  @internal
  */
  constructor(e, s, i, r = 0) {
    this.name = e, this.props = s, this.id = i, this.flags = r;
  }
  /**
  Define a node type.
  */
  static define(e) {
    let s = e.props && e.props.length ? /* @__PURE__ */ Object.create(null) : Vs, i = (e.top ? 1 : 0) | (e.skipped ? 2 : 0) | (e.error ? 4 : 0) | (e.name == null ? 8 : 0), r = new W(e.name || "", s, e.id, i);
    if (e.props) {
      for (let n of e.props)
        if (Array.isArray(n) || (n = n(r)), n) {
          if (n[0].perNode)
            throw new RangeError("Can't store a per-node prop on a node type");
          s[n[0].id] = n[1];
        }
    }
    return r;
  }
  /**
  Retrieves a node prop for this type. Will return `undefined` if
  the prop isn't present on this node.
  */
  prop(e) {
    return this.props[e.id];
  }
  /**
  True when this is the top node of a grammar.
  */
  get isTop() {
    return (this.flags & 1) > 0;
  }
  /**
  True when this node is produced by a skip rule.
  */
  get isSkipped() {
    return (this.flags & 2) > 0;
  }
  /**
  Indicates whether this is an error node.
  */
  get isError() {
    return (this.flags & 4) > 0;
  }
  /**
  When true, this node type doesn't correspond to a user-declared
  named node, for example because it is used to cache repetition.
  */
  get isAnonymous() {
    return (this.flags & 8) > 0;
  }
  /**
  Returns true when this node's name or one of its
  [groups](#common.NodeProp^group) matches the given string.
  */
  is(e) {
    if (typeof e == "string") {
      if (this.name == e)
        return !0;
      let s = this.prop(k.group);
      return s ? s.indexOf(e) > -1 : !1;
    }
    return this.id == e;
  }
  /**
  Create a function from node types to arbitrary values by
  specifying an object whose property names are node or
  [group](#common.NodeProp^group) names. Often useful with
  [`NodeProp.add`](#common.NodeProp.add). You can put multiple
  names, separated by spaces, in a single property name to map
  multiple node names to a single value.
  */
  static match(e) {
    let s = /* @__PURE__ */ Object.create(null);
    for (let i in e)
      for (let r of i.split(" "))
        s[r] = e[i];
    return (i) => {
      for (let r = i.prop(k.group), n = -1; n < (r ? r.length : 0); n++) {
        let o = s[n < 0 ? i.name : r[n]];
        if (o)
          return o;
      }
    };
  }
}
W.none = new W(
  "",
  /* @__PURE__ */ Object.create(null),
  0,
  8
  /* NodeFlag.Anonymous */
);
class mt {
  /**
  Create a set with the given types. The `id` property of each
  type should correspond to its position within the array.
  */
  constructor(e) {
    this.types = e;
    for (let s = 0; s < e.length; s++)
      if (e[s].id != s)
        throw new RangeError("Node type ids should correspond to array positions when creating a node set");
  }
  /**
  Create a copy of this set with some node properties added. The
  arguments to this method can be created with
  [`NodeProp.add`](#common.NodeProp.add).
  */
  extend(...e) {
    let s = [];
    for (let i of this.types) {
      let r = null;
      for (let n of e) {
        let o = n(i);
        o && (r || (r = Object.assign({}, i.props)), r[o[0].id] = o[1]);
      }
      s.push(r ? new W(i.name, r, i.id, i.flags) : i);
    }
    return new mt(s);
  }
}
const ke = /* @__PURE__ */ new WeakMap(), Ft = /* @__PURE__ */ new WeakMap();
var N;
(function(t) {
  t[t.ExcludeBuffers = 1] = "ExcludeBuffers", t[t.IncludeAnonymous = 2] = "IncludeAnonymous", t[t.IgnoreMounts = 4] = "IgnoreMounts", t[t.IgnoreOverlays = 8] = "IgnoreOverlays";
})(N || (N = {}));
class _ {
  /**
  Construct a new tree. See also [`Tree.build`](#common.Tree^build).
  */
  constructor(e, s, i, r, n) {
    if (this.type = e, this.children = s, this.positions = i, this.length = r, this.props = null, n && n.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      for (let [o, h] of n)
        this.props[typeof o == "number" ? o : o.id] = h;
    }
  }
  /**
  @internal
  */
  toString() {
    let e = Ne.get(this);
    if (e && !e.overlay)
      return e.tree.toString();
    let s = "";
    for (let i of this.children) {
      let r = i.toString();
      r && (s && (s += ","), s += r);
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (s.length ? "(" + s + ")" : "") : s;
  }
  /**
  Get a [tree cursor](#common.TreeCursor) positioned at the top of
  the tree. Mode can be used to [control](#common.IterMode) which
  nodes the cursor visits.
  */
  cursor(e = 0) {
    return new at(this.topNode, e);
  }
  /**
  Get a [tree cursor](#common.TreeCursor) pointing into this tree
  at the given position and side (see
  [`moveTo`](#common.TreeCursor.moveTo).
  */
  cursorAt(e, s = 0, i = 0) {
    let r = ke.get(this) || this.topNode, n = new at(r);
    return n.moveTo(e, s), ke.set(this, n._tree), n;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) object for the top of the
  tree.
  */
  get topNode() {
    return new V(this, 0, 0, null);
  }
  /**
  Get the [syntax node](#common.SyntaxNode) at the given position.
  If `side` is -1, this will move into nodes that end at the
  position. If 1, it'll move into nodes that start at the
  position. With 0, it'll only enter nodes that cover the position
  from both sides.
  
  Note that this will not enter
  [overlays](#common.MountedTree.overlay), and you often want
  [`resolveInner`](#common.Tree.resolveInner) instead.
  */
  resolve(e, s = 0) {
    let i = ve(ke.get(this) || this.topNode, e, s, !1);
    return ke.set(this, i), i;
  }
  /**
  Like [`resolve`](#common.Tree.resolve), but will enter
  [overlaid](#common.MountedTree.overlay) nodes, producing a syntax node
  pointing into the innermost overlaid tree at the given position
  (with parent links going through all parent structure, including
  the host trees).
  */
  resolveInner(e, s = 0) {
    let i = ve(Ft.get(this) || this.topNode, e, s, !0);
    return Ft.set(this, i), i;
  }
  /**
  In some situations, it can be useful to iterate through all
  nodes around a position, including those in overlays that don't
  directly cover the position. This method gives you an iterator
  that will produce all nodes, from small to big, around the given
  position.
  */
  resolveStack(e, s = 0) {
    return Xs(this, e, s);
  }
  /**
  Iterate over the tree and its children, calling `enter` for any
  node that touches the `from`/`to` region (if given) before
  running over such a node's children, and `leave` (if given) when
  leaving the node. When `enter` returns `false`, that node will
  not have its children iterated over (or `leave` called).
  */
  iterate(e) {
    let { enter: s, leave: i, from: r = 0, to: n = this.length } = e, o = e.mode || 0, h = (o & N.IncludeAnonymous) > 0;
    for (let a = this.cursor(o | N.IncludeAnonymous); ; ) {
      let l = !1;
      if (a.from <= n && a.to >= r && (!h && a.type.isAnonymous || s(a) !== !1)) {
        if (a.firstChild())
          continue;
        l = !0;
      }
      for (; l && i && (h || !a.type.isAnonymous) && i(a), !a.nextSibling(); ) {
        if (!a.parent())
          return;
        l = !0;
      }
    }
  }
  /**
  Get the value of the given [node prop](#common.NodeProp) for this
  node. Works with both per-node and per-type props.
  */
  prop(e) {
    return e.perNode ? this.props ? this.props[e.id] : void 0 : this.type.prop(e);
  }
  /**
  Returns the node's [per-node props](#common.NodeProp.perNode) in a
  format that can be passed to the [`Tree`](#common.Tree)
  constructor.
  */
  get propValues() {
    let e = [];
    if (this.props)
      for (let s in this.props)
        e.push([+s, this.props[s]]);
    return e;
  }
  /**
  Balance the direct children of this tree, producing a copy of
  which may have children grouped into subtrees with type
  [`NodeType.none`](#common.NodeType^none).
  */
  balance(e = {}) {
    return this.children.length <= 8 ? this : vt(W.none, this.children, this.positions, 0, this.children.length, 0, this.length, (s, i, r) => new _(this.type, s, i, r, this.propValues), e.makeTree || ((s, i, r) => new _(W.none, s, i, r)));
  }
  /**
  Build a tree from a postfix-ordered buffer of node information,
  or a cursor over such a buffer.
  */
  static build(e) {
    return Ms(e);
  }
}
_.empty = new _(W.none, [], [], 0);
class St {
  constructor(e, s) {
    this.buffer = e, this.index = s;
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  get pos() {
    return this.index;
  }
  next() {
    this.index -= 4;
  }
  fork() {
    return new St(this.buffer, this.index);
  }
}
class re {
  /**
  Create a tree buffer.
  */
  constructor(e, s, i) {
    this.buffer = e, this.length = s, this.set = i;
  }
  /**
  @internal
  */
  get type() {
    return W.none;
  }
  /**
  @internal
  */
  toString() {
    let e = [];
    for (let s = 0; s < this.buffer.length; )
      e.push(this.childString(s)), s = this.buffer[s + 3];
    return e.join(",");
  }
  /**
  @internal
  */
  childString(e) {
    let s = this.buffer[e], i = this.buffer[e + 3], r = this.set.types[s], n = r.name;
    if (/\W/.test(n) && !r.isError && (n = JSON.stringify(n)), e += 4, i == e)
      return n;
    let o = [];
    for (; e < i; )
      o.push(this.childString(e)), e = this.buffer[e + 3];
    return n + "(" + o.join(",") + ")";
  }
  /**
  @internal
  */
  findChild(e, s, i, r, n) {
    let { buffer: o } = this, h = -1;
    for (let a = e; a != s && !(cs(n, r, o[a + 1], o[a + 2]) && (h = a, i > 0)); a = o[a + 3])
      ;
    return h;
  }
  /**
  @internal
  */
  slice(e, s, i) {
    let r = this.buffer, n = new Uint16Array(s - e), o = 0;
    for (let h = e, a = 0; h < s; ) {
      n[a++] = r[h++], n[a++] = r[h++] - i;
      let l = n[a++] = r[h++] - i;
      n[a++] = r[h++] - e, o = Math.max(o, l);
    }
    return new re(n, o, this.set);
  }
}
function cs(t, e, s, i) {
  switch (t) {
    case -2:
      return s < e;
    case -1:
      return i >= e && s < e;
    case 0:
      return s < e && i > e;
    case 1:
      return s <= e && i > e;
    case 2:
      return i > e;
    case 4:
      return !0;
  }
}
function ve(t, e, s, i) {
  for (var r; t.from == t.to || (s < 1 ? t.from >= e : t.from > e) || (s > -1 ? t.to <= e : t.to < e); ) {
    let o = !i && t instanceof V && t.index < 0 ? null : t.parent;
    if (!o)
      return t;
    t = o;
  }
  let n = i ? 0 : N.IgnoreOverlays;
  if (i)
    for (let o = t, h = o.parent; h; o = h, h = o.parent)
      o instanceof V && o.index < 0 && ((r = h.enter(e, s, n)) === null || r === void 0 ? void 0 : r.from) != o.from && (t = h);
  for (; ; ) {
    let o = t.enter(e, s, n);
    if (!o)
      return t;
    t = o;
  }
}
class $s {
  cursor(e = 0) {
    return new at(this, e);
  }
  getChild(e, s = null, i = null) {
    let r = Pt(this, e, s, i);
    return r.length ? r[0] : null;
  }
  getChildren(e, s = null, i = null) {
    return Pt(this, e, s, i);
  }
  resolve(e, s = 0) {
    return ve(this, e, s, !1);
  }
  resolveInner(e, s = 0) {
    return ve(this, e, s, !0);
  }
  matchContext(e) {
    return ht(this, e);
  }
  enterUnfinishedNodesBefore(e) {
    let s = this.childBefore(e), i = this;
    for (; s; ) {
      let r = s.lastChild;
      if (!r || r.to != s.to)
        break;
      r.type.isError && r.from == r.to ? (i = s, s = r.prevSibling) : s = r;
    }
    return i;
  }
  get node() {
    return this;
  }
  get next() {
    return this.parent;
  }
}
class V extends $s {
  constructor(e, s, i, r) {
    super(), this._tree = e, this.from = s, this.index = i, this._parent = r;
  }
  get type() {
    return this._tree.type;
  }
  get name() {
    return this._tree.type.name;
  }
  get to() {
    return this.from + this._tree.length;
  }
  nextChild(e, s, i, r, n = 0) {
    for (let o = this; ; ) {
      for (let { children: h, positions: a } = o._tree, l = s > 0 ? h.length : -1; e != l; e += s) {
        let x = h[e], u = a[e] + o.from;
        if (cs(r, i, u, u + x.length)) {
          if (x instanceof re) {
            if (n & N.ExcludeBuffers)
              continue;
            let f = x.findChild(0, x.buffer.length, s, i - u, r);
            if (f > -1)
              return new ie(new Ls(o, x, e, u), null, f);
          } else if (n & N.IncludeAnonymous || !x.type.isAnonymous || Tt(x)) {
            let f;
            if (!(n & N.IgnoreMounts) && (f = Ne.get(x)) && !f.overlay)
              return new V(f.tree, u, e, o);
            let p = new V(x, u, e, o);
            return n & N.IncludeAnonymous || !p.type.isAnonymous ? p : p.nextChild(s < 0 ? x.children.length - 1 : 0, s, i, r);
          }
        }
      }
      if (n & N.IncludeAnonymous || !o.type.isAnonymous || (o.index >= 0 ? e = o.index + s : e = s < 0 ? -1 : o._parent._tree.children.length, o = o._parent, !o))
        return null;
    }
  }
  get firstChild() {
    return this.nextChild(
      0,
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(e) {
    return this.nextChild(
      0,
      1,
      e,
      2
      /* Side.After */
    );
  }
  childBefore(e) {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  enter(e, s, i = 0) {
    let r;
    if (!(i & N.IgnoreOverlays) && (r = Ne.get(this._tree)) && r.overlay) {
      let n = e - this.from;
      for (let { from: o, to: h } of r.overlay)
        if ((s > 0 ? o <= n : o < n) && (s < 0 ? h >= n : h > n))
          return new V(r.tree, r.overlay[0].from + this.from, -1, this);
    }
    return this.nextChild(0, 1, e, s, i);
  }
  nextSignificantParent() {
    let e = this;
    for (; e.type.isAnonymous && e._parent; )
      e = e._parent;
    return e;
  }
  get parent() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  }
  get nextSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index + 1,
      1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get prevSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get tree() {
    return this._tree;
  }
  toTree() {
    return this._tree;
  }
  /**
  @internal
  */
  toString() {
    return this._tree.toString();
  }
}
function Pt(t, e, s, i) {
  let r = t.cursor(), n = [];
  if (!r.firstChild())
    return n;
  if (s != null) {
    for (; !r.type.is(s); )
      if (!r.nextSibling())
        return n;
  }
  for (; ; ) {
    if (i != null && r.type.is(i))
      return n;
    if (r.type.is(e) && n.push(r.node), !r.nextSibling())
      return i == null ? n : [];
  }
}
function ht(t, e, s = e.length - 1) {
  for (let i = t.parent; s >= 0; i = i.parent) {
    if (!i)
      return !1;
    if (!i.type.isAnonymous) {
      if (e[s] && e[s] != i.name)
        return !1;
      s--;
    }
  }
  return !0;
}
class Ls {
  constructor(e, s, i, r) {
    this.parent = e, this.buffer = s, this.index = i, this.start = r;
  }
}
class ie extends $s {
  get name() {
    return this.type.name;
  }
  get from() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  }
  get to() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  }
  constructor(e, s, i) {
    super(), this.context = e, this._parent = s, this.index = i, this.type = e.buffer.set.types[e.buffer.buffer[i]];
  }
  child(e, s, i) {
    let { buffer: r } = this.context, n = r.findChild(this.index + 4, r.buffer[this.index + 3], e, s - this.context.start, i);
    return n < 0 ? null : new ie(this.context, this, n);
  }
  get firstChild() {
    return this.child(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.child(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(e) {
    return this.child(
      1,
      e,
      2
      /* Side.After */
    );
  }
  childBefore(e) {
    return this.child(
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  enter(e, s, i = 0) {
    if (i & N.ExcludeBuffers)
      return null;
    let { buffer: r } = this.context, n = r.findChild(this.index + 4, r.buffer[this.index + 3], s > 0 ? 1 : -1, e - this.context.start, s);
    return n < 0 ? null : new ie(this.context, this, n);
  }
  get parent() {
    return this._parent || this.context.parent.nextSignificantParent();
  }
  externalSibling(e) {
    return this._parent ? null : this.context.parent.nextChild(
      this.context.index + e,
      e,
      0,
      4
      /* Side.DontCare */
    );
  }
  get nextSibling() {
    let { buffer: e } = this.context, s = e.buffer[this.index + 3];
    return s < (this._parent ? e.buffer[this._parent.index + 3] : e.buffer.length) ? new ie(this.context, this._parent, s) : this.externalSibling(1);
  }
  get prevSibling() {
    let { buffer: e } = this.context, s = this._parent ? this._parent.index + 4 : 0;
    return this.index == s ? this.externalSibling(-1) : new ie(this.context, this._parent, e.findChild(
      s,
      this.index,
      -1,
      0,
      4
      /* Side.DontCare */
    ));
  }
  get tree() {
    return null;
  }
  toTree() {
    let e = [], s = [], { buffer: i } = this.context, r = this.index + 4, n = i.buffer[this.index + 3];
    if (n > r) {
      let o = i.buffer[this.index + 1];
      e.push(i.slice(r, n, o)), s.push(0);
    }
    return new _(this.type, e, s, this.to - this.from);
  }
  /**
  @internal
  */
  toString() {
    return this.context.buffer.childString(this.index);
  }
}
function ds(t) {
  if (!t.length)
    return null;
  let e = 0, s = t[0];
  for (let n = 1; n < t.length; n++) {
    let o = t[n];
    (o.from > s.from || o.to < s.to) && (s = o, e = n);
  }
  let i = s instanceof V && s.index < 0 ? null : s.parent, r = t.slice();
  return i ? r[e] = i : r.splice(e, 1), new qs(r, s);
}
class qs {
  constructor(e, s) {
    this.heads = e, this.node = s;
  }
  get next() {
    return ds(this.heads);
  }
}
function Xs(t, e, s) {
  let i = t.resolveInner(e, s), r = null;
  for (let n = i instanceof V ? i : i.context.parent; n; n = n.parent)
    if (n.index < 0) {
      let o = n.parent;
      (r || (r = [i])).push(o.resolve(e, s)), n = o;
    } else {
      let o = Ne.get(n.tree);
      if (o && o.overlay && o.overlay[0].from <= e && o.overlay[o.overlay.length - 1].to >= e) {
        let h = new V(o.tree, o.overlay[0].from + n.from, -1, n);
        (r || (r = [i])).push(ve(h, e, s, !1));
      }
    }
  return r ? ds(r) : i;
}
class at {
  /**
  Shorthand for `.type.name`.
  */
  get name() {
    return this.type.name;
  }
  /**
  @internal
  */
  constructor(e, s = 0) {
    if (this.mode = s, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, e instanceof V)
      this.yieldNode(e);
    else {
      this._tree = e.context.parent, this.buffer = e.context;
      for (let i = e._parent; i; i = i._parent)
        this.stack.unshift(i.index);
      this.bufferNode = e, this.yieldBuf(e.index);
    }
  }
  yieldNode(e) {
    return e ? (this._tree = e, this.type = e.type, this.from = e.from, this.to = e.to, !0) : !1;
  }
  yieldBuf(e, s) {
    this.index = e;
    let { start: i, buffer: r } = this.buffer;
    return this.type = s || r.set.types[r.buffer[e]], this.from = i + r.buffer[e + 1], this.to = i + r.buffer[e + 2], !0;
  }
  /**
  @internal
  */
  yield(e) {
    return e ? e instanceof V ? (this.buffer = null, this.yieldNode(e)) : (this.buffer = e.context, this.yieldBuf(e.index, e.type)) : !1;
  }
  /**
  @internal
  */
  toString() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  }
  /**
  @internal
  */
  enterChild(e, s, i) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(e < 0 ? this._tree._tree.children.length - 1 : 0, e, s, i, this.mode));
    let { buffer: r } = this.buffer, n = r.findChild(this.index + 4, r.buffer[this.index + 3], e, s - this.buffer.start, i);
    return n < 0 ? !1 : (this.stack.push(this.index), this.yieldBuf(n));
  }
  /**
  Move the cursor to this node's first child. When this returns
  false, the node has no child, and the cursor has not been moved.
  */
  firstChild() {
    return this.enterChild(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to this node's last child.
  */
  lastChild() {
    return this.enterChild(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to the first child that ends after `pos`.
  */
  childAfter(e) {
    return this.enterChild(
      1,
      e,
      2
      /* Side.After */
    );
  }
  /**
  Move to the last child that starts before `pos`.
  */
  childBefore(e) {
    return this.enterChild(
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  /**
  Move the cursor to the child around `pos`. If side is -1 the
  child may end at that position, when 1 it may start there. This
  will also enter [overlaid](#common.MountedTree.overlay)
  [mounted](#common.NodeProp^mounted) trees unless `overlays` is
  set to false.
  */
  enter(e, s, i = this.mode) {
    return this.buffer ? i & N.ExcludeBuffers ? !1 : this.enterChild(1, e, s) : this.yield(this._tree.enter(e, s, i));
  }
  /**
  Move to the node's parent node, if this isn't the top node.
  */
  parent() {
    if (!this.buffer)
      return this.yieldNode(this.mode & N.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    let e = this.mode & N.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(e);
  }
  /**
  @internal
  */
  sibling(e) {
    if (!this.buffer)
      return this._tree._parent ? this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + e, e, 0, 4, this.mode)) : !1;
    let { buffer: s } = this.buffer, i = this.stack.length - 1;
    if (e < 0) {
      let r = i < 0 ? 0 : this.stack[i] + 4;
      if (this.index != r)
        return this.yieldBuf(s.findChild(
          r,
          this.index,
          -1,
          0,
          4
          /* Side.DontCare */
        ));
    } else {
      let r = s.buffer[this.index + 3];
      if (r < (i < 0 ? s.buffer.length : s.buffer[this.stack[i] + 3]))
        return this.yieldBuf(r);
    }
    return i < 0 ? this.yield(this.buffer.parent.nextChild(this.buffer.index + e, e, 0, 4, this.mode)) : !1;
  }
  /**
  Move to this node's next sibling, if any.
  */
  nextSibling() {
    return this.sibling(1);
  }
  /**
  Move to this node's previous sibling, if any.
  */
  prevSibling() {
    return this.sibling(-1);
  }
  atLastNode(e) {
    let s, i, { buffer: r } = this;
    if (r) {
      if (e > 0) {
        if (this.index < r.buffer.buffer.length)
          return !1;
      } else
        for (let n = 0; n < this.index; n++)
          if (r.buffer.buffer[n + 3] < this.index)
            return !1;
      ({ index: s, parent: i } = r);
    } else
      ({ index: s, _parent: i } = this._tree);
    for (; i; { index: s, _parent: i } = i)
      if (s > -1)
        for (let n = s + e, o = e < 0 ? -1 : i._tree.children.length; n != o; n += e) {
          let h = i._tree.children[n];
          if (this.mode & N.IncludeAnonymous || h instanceof re || !h.type.isAnonymous || Tt(h))
            return !1;
        }
    return !0;
  }
  move(e, s) {
    if (s && this.enterChild(
      e,
      0,
      4
      /* Side.DontCare */
    ))
      return !0;
    for (; ; ) {
      if (this.sibling(e))
        return !0;
      if (this.atLastNode(e) || !this.parent())
        return !1;
    }
  }
  /**
  Move to the next node in a
  [pre-order](https://en.wikipedia.org/wiki/Tree_traversal#Pre-order,_NLR)
  traversal, going from a node to its first child or, if the
  current node is empty or `enter` is false, its next sibling or
  the next sibling of the first parent node that has one.
  */
  next(e = !0) {
    return this.move(1, e);
  }
  /**
  Move to the next node in a last-to-first pre-order traveral. A
  node is followed by its last child or, if it has none, its
  previous sibling or the previous sibling of the first parent
  node that has one.
  */
  prev(e = !0) {
    return this.move(-1, e);
  }
  /**
  Move the cursor to the innermost node that covers `pos`. If
  `side` is -1, it will enter nodes that end at `pos`. If it is 1,
  it will enter nodes that start at `pos`.
  */
  moveTo(e, s = 0) {
    for (; (this.from == this.to || (s < 1 ? this.from >= e : this.from > e) || (s > -1 ? this.to <= e : this.to < e)) && this.parent(); )
      ;
    for (; this.enterChild(1, e, s); )
      ;
    return this;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) at the cursor's current
  position.
  */
  get node() {
    if (!this.buffer)
      return this._tree;
    let e = this.bufferNode, s = null, i = 0;
    if (e && e.context == this.buffer)
      e:
        for (let r = this.index, n = this.stack.length; n >= 0; ) {
          for (let o = e; o; o = o._parent)
            if (o.index == r) {
              if (r == this.index)
                return o;
              s = o, i = n + 1;
              break e;
            }
          r = this.stack[--n];
        }
    for (let r = i; r < this.stack.length; r++)
      s = new ie(this.buffer, s, this.stack[r]);
    return this.bufferNode = new ie(this.buffer, s, this.index);
  }
  /**
  Get the [tree](#common.Tree) that represents the current node, if
  any. Will return null when the node is in a [tree
  buffer](#common.TreeBuffer).
  */
  get tree() {
    return this.buffer ? null : this._tree._tree;
  }
  /**
  Iterate over the current node and all its descendants, calling
  `enter` when entering a node and `leave`, if given, when leaving
  one. When `enter` returns `false`, any children of that node are
  skipped, and `leave` isn't called for it.
  */
  iterate(e, s) {
    for (let i = 0; ; ) {
      let r = !1;
      if (this.type.isAnonymous || e(this) !== !1) {
        if (this.firstChild()) {
          i++;
          continue;
        }
        this.type.isAnonymous || (r = !0);
      }
      for (; r && s && s(this), r = this.type.isAnonymous, !this.nextSibling(); ) {
        if (!i)
          return;
        this.parent(), i--, r = !0;
      }
    }
  }
  /**
  Test whether the current node matches a given context—a sequence
  of direct parent node names. Empty strings in the context array
  are treated as wildcards.
  */
  matchContext(e) {
    if (!this.buffer)
      return ht(this.node, e);
    let { buffer: s } = this.buffer, { types: i } = s.set;
    for (let r = e.length - 1, n = this.stack.length - 1; r >= 0; n--) {
      if (n < 0)
        return ht(this.node, e, r);
      let o = i[s.buffer[this.stack[n]]];
      if (!o.isAnonymous) {
        if (e[r] && e[r] != o.name)
          return !1;
        r--;
      }
    }
    return !0;
  }
}
function Tt(t) {
  return t.children.some((e) => e instanceof re || !e.type.isAnonymous || Tt(e));
}
function Ms(t) {
  var e;
  let { buffer: s, nodeSet: i, maxBufferLength: r = ps, reused: n = [], minRepeatType: o = i.types.length } = t, h = Array.isArray(s) ? new St(s, s.length) : s, a = i.types, l = 0, x = 0;
  function u(v, y, g, B, R, E) {
    let { id: m, start: S, end: J, size: P } = h, G = x;
    for (; P < 0; )
      if (h.next(), P == -1) {
        let K = n[m];
        g.push(K), B.push(S - v);
        return;
      } else if (P == -3) {
        l = m;
        return;
      } else if (P == -4) {
        x = m;
        return;
      } else
        throw new RangeError(`Unrecognized record size: ${P}`);
    let ne = a[m], fe, oe, Rt = S - v;
    if (J - S <= r && (oe = w(h.pos - y, R))) {
      let K = new Uint16Array(oe.size - oe.skip), U = h.pos - oe.size, q = K.length;
      for (; h.pos > U; )
        q = A(oe.start, K, q);
      fe = new re(K, J - oe.start, i), Rt = oe.start - v;
    } else {
      let K = h.pos - P;
      h.next();
      let U = [], q = [], he = m >= o ? m : -1, pe = 0, ye = J;
      for (; h.pos > K; )
        he >= 0 && h.id == he && h.size >= 0 ? (h.end <= ye - r && ($(U, q, S, pe, h.end, ye, he, G), pe = U.length, ye = h.end), h.next()) : E > 2500 ? f(S, K, U, q) : u(S, K, U, q, he, E + 1);
      if (he >= 0 && pe > 0 && pe < U.length && $(U, q, S, pe, S, ye, he, G), U.reverse(), q.reverse(), he > -1 && pe > 0) {
        let It = p(ne);
        fe = vt(ne, U, q, 0, U.length, 0, J - S, It, It);
      } else
        fe = O(ne, U, q, J - S, G - J);
    }
    g.push(fe), B.push(Rt);
  }
  function f(v, y, g, B) {
    let R = [], E = 0, m = -1;
    for (; h.pos > y; ) {
      let { id: S, start: J, end: P, size: G } = h;
      if (G > 4)
        h.next();
      else {
        if (m > -1 && J < m)
          break;
        m < 0 && (m = P - r), R.push(S, J, P), E++, h.next();
      }
    }
    if (E) {
      let S = new Uint16Array(E * 4), J = R[R.length - 2];
      for (let P = R.length - 3, G = 0; P >= 0; P -= 3)
        S[G++] = R[P], S[G++] = R[P + 1] - J, S[G++] = R[P + 2] - J, S[G++] = G;
      g.push(new re(S, R[2] - J, i)), B.push(J - v);
    }
  }
  function p(v) {
    return (y, g, B) => {
      let R = 0, E = y.length - 1, m, S;
      if (E >= 0 && (m = y[E]) instanceof _) {
        if (!E && m.type == v && m.length == B)
          return m;
        (S = m.prop(k.lookAhead)) && (R = g[E] + m.length + S);
      }
      return O(v, y, g, B, R);
    };
  }
  function $(v, y, g, B, R, E, m, S) {
    let J = [], P = [];
    for (; v.length > B; )
      J.push(v.pop()), P.push(y.pop() + g - R);
    v.push(O(i.types[m], J, P, E - R, S - E)), y.push(R - g);
  }
  function O(v, y, g, B, R = 0, E) {
    if (l) {
      let m = [k.contextHash, l];
      E = E ? [m].concat(E) : [m];
    }
    if (R > 25) {
      let m = [k.lookAhead, R];
      E = E ? [m].concat(E) : [m];
    }
    return new _(v, y, g, B, E);
  }
  function w(v, y) {
    let g = h.fork(), B = 0, R = 0, E = 0, m = g.end - r, S = { size: 0, start: 0, skip: 0 };
    e:
      for (let J = g.pos - v; g.pos > J; ) {
        let P = g.size;
        if (g.id == y && P >= 0) {
          S.size = B, S.start = R, S.skip = E, E += 4, B += 4, g.next();
          continue;
        }
        let G = g.pos - P;
        if (P < 0 || G < J || g.start < m)
          break;
        let ne = g.id >= o ? 4 : 0, fe = g.start;
        for (g.next(); g.pos > G; ) {
          if (g.size < 0)
            if (g.size == -3)
              ne += 4;
            else
              break e;
          else
            g.id >= o && (ne += 4);
          g.next();
        }
        R = fe, B += P, E += ne;
      }
    return (y < 0 || B == v) && (S.size = B, S.start = R, S.skip = E), S.size > 4 ? S : void 0;
  }
  function A(v, y, g) {
    let { id: B, start: R, end: E, size: m } = h;
    if (h.next(), m >= 0 && B < o) {
      let S = g;
      if (m > 4) {
        let J = h.pos - (m - 4);
        for (; h.pos > J; )
          g = A(v, y, g);
      }
      y[--g] = S, y[--g] = E - v, y[--g] = R - v, y[--g] = B;
    } else
      m == -3 ? l = B : m == -4 && (x = B);
    return g;
  }
  let D = [], F = [];
  for (; h.pos > 0; )
    u(t.start || 0, t.bufferStart || 0, D, F, -1, 0);
  let H = (e = t.length) !== null && e !== void 0 ? e : D.length ? F[0] + D[0].length : 0;
  return new _(a[t.topID], D.reverse(), F.reverse(), H);
}
const Bt = /* @__PURE__ */ new WeakMap();
function Ce(t, e) {
  if (!t.isAnonymous || e instanceof re || e.type != t)
    return 1;
  let s = Bt.get(e);
  if (s == null) {
    s = 1;
    for (let i of e.children) {
      if (i.type != t || !(i instanceof _)) {
        s = 1;
        break;
      }
      s += Ce(t, i);
    }
    Bt.set(e, s);
  }
  return s;
}
function vt(t, e, s, i, r, n, o, h, a) {
  let l = 0;
  for (let $ = i; $ < r; $++)
    l += Ce(t, e[$]);
  let x = Math.ceil(
    l * 1.5 / 8
    /* Balance.BranchFactor */
  ), u = [], f = [];
  function p($, O, w, A, D) {
    for (let F = w; F < A; ) {
      let H = F, v = O[F], y = Ce(t, $[F]);
      for (F++; F < A; F++) {
        let g = Ce(t, $[F]);
        if (y + g >= x)
          break;
        y += g;
      }
      if (F == H + 1) {
        if (y > x) {
          let g = $[H];
          p(g.children, g.positions, 0, g.children.length, O[H] + D);
          continue;
        }
        u.push($[H]);
      } else {
        let g = O[F - 1] + $[F - 1].length - v;
        u.push(vt(t, $, O, H, F, v, g, null, a));
      }
      f.push(v + D - n);
    }
  }
  return p(e, s, i, r, 0), (h || a)(u, f, o);
}
class xe {
  /**
  Construct a tree fragment. You'll usually want to use
  [`addTree`](#common.TreeFragment^addTree) and
  [`applyChanges`](#common.TreeFragment^applyChanges) instead of
  calling this directly.
  */
  constructor(e, s, i, r, n = !1, o = !1) {
    this.from = e, this.to = s, this.tree = i, this.offset = r, this.open = (n ? 1 : 0) | (o ? 2 : 0);
  }
  /**
  Whether the start of the fragment represents the start of a
  parse, or the end of a change. (In the second case, it may not
  be safe to reuse some nodes at the start, depending on the
  parsing algorithm.)
  */
  get openStart() {
    return (this.open & 1) > 0;
  }
  /**
  Whether the end of the fragment represents the end of a
  full-document parse, or the start of a change.
  */
  get openEnd() {
    return (this.open & 2) > 0;
  }
  /**
  Create a set of fragments from a freshly parsed tree, or update
  an existing set of fragments by replacing the ones that overlap
  with a tree with content from the new tree. When `partial` is
  true, the parse is treated as incomplete, and the resulting
  fragment has [`openEnd`](#common.TreeFragment.openEnd) set to
  true.
  */
  static addTree(e, s = [], i = !1) {
    let r = [new xe(0, e.length, e, 0, !1, i)];
    for (let n of s)
      n.to > e.length && r.push(n);
    return r;
  }
  /**
  Apply a set of edits to an array of fragments, removing or
  splitting fragments as necessary to remove edited ranges, and
  adjusting offsets for fragments that moved.
  */
  static applyChanges(e, s, i = 128) {
    if (!s.length)
      return e;
    let r = [], n = 1, o = e.length ? e[0] : null;
    for (let h = 0, a = 0, l = 0; ; h++) {
      let x = h < s.length ? s[h] : null, u = x ? x.fromA : 1e9;
      if (u - a >= i)
        for (; o && o.from < u; ) {
          let f = o;
          if (a >= f.from || u <= f.to || l) {
            let p = Math.max(f.from, a) - l, $ = Math.min(f.to, u) - l;
            f = p >= $ ? null : new xe(p, $, f.tree, f.offset + l, h > 0, !!x);
          }
          if (f && r.push(f), o.to > u)
            break;
          o = n < e.length ? e[n++] : null;
        }
      if (!x)
        break;
      a = x.toA, l = x.toA - x.toB;
    }
    return r;
  }
}
let gs = class {
  /**
  Start a parse, returning a [partial parse](#common.PartialParse)
  object. [`fragments`](#common.TreeFragment) can be passed in to
  make the parse incremental.
  
  By default, the entire input is parsed. You can pass `ranges`,
  which should be a sorted array of non-empty, non-overlapping
  ranges, to parse only those ranges. The tree returned in that
  case will start at `ranges[0].from`.
  */
  startParse(e, s, i) {
    return typeof e == "string" && (e = new Ys(e)), i = i ? i.length ? i.map((r) => new Qe(r.from, r.to)) : [new Qe(0, 0)] : [new Qe(0, e.length)], this.createParse(e, s || [], i);
  }
  /**
  Run a full parse, returning the resulting tree.
  */
  parse(e, s, i) {
    let r = this.startParse(e, s, i);
    for (; ; ) {
      let n = r.advance();
      if (n)
        return n;
    }
  }
};
class Ys {
  constructor(e) {
    this.string = e;
  }
  get length() {
    return this.string.length;
  }
  chunk(e) {
    return this.string.slice(e);
  }
  get lineChunks() {
    return !1;
  }
  read(e, s) {
    return this.string.slice(e, s);
  }
}
new k({ perNode: !0 });
class He {
  /**
  @internal
  */
  constructor(e, s, i, r, n, o, h, a, l, x = 0, u) {
    this.p = e, this.stack = s, this.state = i, this.reducePos = r, this.pos = n, this.score = o, this.buffer = h, this.bufferBase = a, this.curContext = l, this.lookAhead = x, this.parent = u;
  }
  /**
  @internal
  */
  toString() {
    return `[${this.stack.filter((e, s) => s % 3 == 0).concat(this.state)}]@${this.pos}${this.score ? "!" + this.score : ""}`;
  }
  // Start an empty stack
  /**
  @internal
  */
  static start(e, s, i = 0) {
    let r = e.parser.context;
    return new He(e, [], s, i, i, 0, [], 0, r ? new Jt(r, r.start) : null, 0, null);
  }
  /**
  The stack's current [context](#lr.ContextTracker) value, if
  any. Its type will depend on the context tracker's type
  parameter, or it will be `null` if there is no context
  tracker.
  */
  get context() {
    return this.curContext ? this.curContext.context : null;
  }
  // Push a state onto the stack, tracking its start position as well
  // as the buffer base at that point.
  /**
  @internal
  */
  pushState(e, s) {
    this.stack.push(this.state, s, this.bufferBase + this.buffer.length), this.state = e;
  }
  // Apply a reduce action
  /**
  @internal
  */
  reduce(e) {
    var s;
    let i = e >> 19, r = e & 65535, { parser: n } = this.p, o = n.dynamicPrecedence(r);
    if (o && (this.score += o), i == 0) {
      this.pushState(n.getGoto(this.state, r, !0), this.reducePos), r < n.minRepeatTerm && this.storeNode(r, this.reducePos, this.reducePos, 4, !0), this.reduceContext(r, this.reducePos);
      return;
    }
    let h = this.stack.length - (i - 1) * 3 - (e & 262144 ? 6 : 0), a = h ? this.stack[h - 2] : this.p.ranges[0].from, l = this.reducePos - a;
    l >= 2e3 && !(!((s = this.p.parser.nodeSet.types[r]) === null || s === void 0) && s.isAnonymous) && (a == this.p.lastBigReductionStart ? (this.p.bigReductionCount++, this.p.lastBigReductionSize = l) : this.p.lastBigReductionSize < l && (this.p.bigReductionCount = 1, this.p.lastBigReductionStart = a, this.p.lastBigReductionSize = l));
    let x = h ? this.stack[h - 1] : 0, u = this.bufferBase + this.buffer.length - x;
    if (r < n.minRepeatTerm || e & 131072) {
      let f = n.stateFlag(
        this.state,
        1
        /* StateFlag.Skipped */
      ) ? this.pos : this.reducePos;
      this.storeNode(r, a, f, u + 4, !0);
    }
    if (e & 262144)
      this.state = this.stack[h];
    else {
      let f = this.stack[h - 3];
      this.state = n.getGoto(f, r, !0);
    }
    for (; this.stack.length > h; )
      this.stack.pop();
    this.reduceContext(r, a);
  }
  // Shift a value into the buffer
  /**
  @internal
  */
  storeNode(e, s, i, r = 4, n = !1) {
    if (e == 0 && (!this.stack.length || this.stack[this.stack.length - 1] < this.buffer.length + this.bufferBase)) {
      let o = this, h = this.buffer.length;
      if (h == 0 && o.parent && (h = o.bufferBase - o.parent.bufferBase, o = o.parent), h > 0 && o.buffer[h - 4] == 0 && o.buffer[h - 1] > -1) {
        if (s == i)
          return;
        if (o.buffer[h - 2] >= s) {
          o.buffer[h - 2] = i;
          return;
        }
      }
    }
    if (!n || this.pos == i)
      this.buffer.push(e, s, i, r);
    else {
      let o = this.buffer.length;
      if (o > 0 && this.buffer[o - 4] != 0)
        for (; o > 0 && this.buffer[o - 2] > i; )
          this.buffer[o] = this.buffer[o - 4], this.buffer[o + 1] = this.buffer[o - 3], this.buffer[o + 2] = this.buffer[o - 2], this.buffer[o + 3] = this.buffer[o - 1], o -= 4, r > 4 && (r -= 4);
      this.buffer[o] = e, this.buffer[o + 1] = s, this.buffer[o + 2] = i, this.buffer[o + 3] = r;
    }
  }
  // Apply a shift action
  /**
  @internal
  */
  shift(e, s, i, r) {
    if (e & 131072)
      this.pushState(e & 65535, this.pos);
    else if (e & 262144)
      this.pos = r, this.shiftContext(s, i), s <= this.p.parser.maxNode && this.buffer.push(s, i, r, 4);
    else {
      let n = e, { parser: o } = this.p;
      (r > this.pos || s <= o.maxNode) && (this.pos = r, o.stateFlag(
        n,
        1
        /* StateFlag.Skipped */
      ) || (this.reducePos = r)), this.pushState(n, i), this.shiftContext(s, i), s <= o.maxNode && this.buffer.push(s, i, r, 4);
    }
  }
  // Apply an action
  /**
  @internal
  */
  apply(e, s, i, r) {
    e & 65536 ? this.reduce(e) : this.shift(e, s, i, r);
  }
  // Add a prebuilt (reused) node into the buffer.
  /**
  @internal
  */
  useNode(e, s) {
    let i = this.p.reused.length - 1;
    (i < 0 || this.p.reused[i] != e) && (this.p.reused.push(e), i++);
    let r = this.pos;
    this.reducePos = this.pos = r + e.length, this.pushState(s, r), this.buffer.push(
      i,
      r,
      this.reducePos,
      -1
      /* size == -1 means this is a reused value */
    ), this.curContext && this.updateContext(this.curContext.tracker.reuse(this.curContext.context, e, this, this.p.stream.reset(this.pos - e.length)));
  }
  // Split the stack. Due to the buffer sharing and the fact
  // that `this.stack` tends to stay quite shallow, this isn't very
  // expensive.
  /**
  @internal
  */
  split() {
    let e = this, s = e.buffer.length;
    for (; s > 0 && e.buffer[s - 2] > e.reducePos; )
      s -= 4;
    let i = e.buffer.slice(s), r = e.bufferBase + s;
    for (; e && r == e.bufferBase; )
      e = e.parent;
    return new He(this.p, this.stack.slice(), this.state, this.reducePos, this.pos, this.score, i, r, this.curContext, this.lookAhead, e);
  }
  // Try to recover from an error by 'deleting' (ignoring) one token.
  /**
  @internal
  */
  recoverByDelete(e, s) {
    let i = e <= this.p.parser.maxNode;
    i && this.storeNode(e, this.pos, s, 4), this.storeNode(0, this.pos, s, i ? 8 : 4), this.pos = this.reducePos = s, this.score -= 190;
  }
  /**
  Check if the given term would be able to be shifted (optionally
  after some reductions) on this stack. This can be useful for
  external tokenizers that want to make sure they only provide a
  given token when it applies.
  */
  canShift(e) {
    for (let s = new Qs(this); ; ) {
      let i = this.p.parser.stateSlot(
        s.state,
        4
        /* ParseState.DefaultReduce */
      ) || this.p.parser.hasAction(s.state, e);
      if (i == 0)
        return !1;
      if (!(i & 65536))
        return !0;
      s.reduce(i);
    }
  }
  // Apply up to Recover.MaxNext recovery actions that conceptually
  // inserts some missing token or rule.
  /**
  @internal
  */
  recoverByInsert(e) {
    if (this.stack.length >= 300)
      return [];
    let s = this.p.parser.nextStates(this.state);
    if (s.length > 8 || this.stack.length >= 120) {
      let r = [];
      for (let n = 0, o; n < s.length; n += 2)
        (o = s[n + 1]) != this.state && this.p.parser.hasAction(o, e) && r.push(s[n], o);
      if (this.stack.length < 120)
        for (let n = 0; r.length < 8 && n < s.length; n += 2) {
          let o = s[n + 1];
          r.some((h, a) => a & 1 && h == o) || r.push(s[n], o);
        }
      s = r;
    }
    let i = [];
    for (let r = 0; r < s.length && i.length < 4; r += 2) {
      let n = s[r + 1];
      if (n == this.state)
        continue;
      let o = this.split();
      o.pushState(n, this.pos), o.storeNode(0, o.pos, o.pos, 4, !0), o.shiftContext(s[r], this.pos), o.reducePos = this.pos, o.score -= 200, i.push(o);
    }
    return i;
  }
  // Force a reduce, if possible. Return false if that can't
  // be done.
  /**
  @internal
  */
  forceReduce() {
    let { parser: e } = this.p, s = e.stateSlot(
      this.state,
      5
      /* ParseState.ForcedReduce */
    );
    if (!(s & 65536))
      return !1;
    if (!e.validAction(this.state, s)) {
      let i = s >> 19, r = s & 65535, n = this.stack.length - i * 3;
      if (n < 0 || e.getGoto(this.stack[n], r, !1) < 0) {
        let o = this.findForcedReduction();
        if (o == null)
          return !1;
        s = o;
      }
      this.storeNode(0, this.pos, this.pos, 4, !0), this.score -= 100;
    }
    return this.reducePos = this.pos, this.reduce(s), !0;
  }
  /**
  Try to scan through the automaton to find some kind of reduction
  that can be applied. Used when the regular ForcedReduce field
  isn't a valid action. @internal
  */
  findForcedReduction() {
    let { parser: e } = this.p, s = [], i = (r, n) => {
      if (!s.includes(r))
        return s.push(r), e.allActions(r, (o) => {
          if (!(o & 393216))
            if (o & 65536) {
              let h = (o >> 19) - n;
              if (h > 1) {
                let a = o & 65535, l = this.stack.length - h * 3;
                if (l >= 0 && e.getGoto(this.stack[l], a, !1) >= 0)
                  return h << 19 | 65536 | a;
              }
            } else {
              let h = i(o, n + 1);
              if (h != null)
                return h;
            }
        });
    };
    return i(this.state, 0);
  }
  /**
  @internal
  */
  forceAll() {
    for (; !this.p.parser.stateFlag(
      this.state,
      2
      /* StateFlag.Accepting */
    ); )
      if (!this.forceReduce()) {
        this.storeNode(0, this.pos, this.pos, 4, !0);
        break;
      }
    return this;
  }
  /**
  Check whether this state has no further actions (assumed to be a direct descendant of the
  top state, since any other states must be able to continue
  somehow). @internal
  */
  get deadEnd() {
    if (this.stack.length != 3)
      return !1;
    let { parser: e } = this.p;
    return e.data[e.stateSlot(
      this.state,
      1
      /* ParseState.Actions */
    )] == 65535 && !e.stateSlot(
      this.state,
      4
      /* ParseState.DefaultReduce */
    );
  }
  /**
  Restart the stack (put it back in its start state). Only safe
  when this.stack.length == 3 (state is directly below the top
  state). @internal
  */
  restart() {
    this.storeNode(0, this.pos, this.pos, 4, !0), this.state = this.stack[0], this.stack.length = 0;
  }
  /**
  @internal
  */
  sameState(e) {
    if (this.state != e.state || this.stack.length != e.stack.length)
      return !1;
    for (let s = 0; s < this.stack.length; s += 3)
      if (this.stack[s] != e.stack[s])
        return !1;
    return !0;
  }
  /**
  Get the parser used by this stack.
  */
  get parser() {
    return this.p.parser;
  }
  /**
  Test whether a given dialect (by numeric ID, as exported from
  the terms file) is enabled.
  */
  dialectEnabled(e) {
    return this.p.parser.dialect.flags[e];
  }
  shiftContext(e, s) {
    this.curContext && this.updateContext(this.curContext.tracker.shift(this.curContext.context, e, this, this.p.stream.reset(s)));
  }
  reduceContext(e, s) {
    this.curContext && this.updateContext(this.curContext.tracker.reduce(this.curContext.context, e, this, this.p.stream.reset(s)));
  }
  /**
  @internal
  */
  emitContext() {
    let e = this.buffer.length - 1;
    (e < 0 || this.buffer[e] != -3) && this.buffer.push(this.curContext.hash, this.pos, this.pos, -3);
  }
  /**
  @internal
  */
  emitLookAhead() {
    let e = this.buffer.length - 1;
    (e < 0 || this.buffer[e] != -4) && this.buffer.push(this.lookAhead, this.pos, this.pos, -4);
  }
  updateContext(e) {
    if (e != this.curContext.context) {
      let s = new Jt(this.curContext.tracker, e);
      s.hash != this.curContext.hash && this.emitContext(), this.curContext = s;
    }
  }
  /**
  @internal
  */
  setLookAhead(e) {
    e > this.lookAhead && (this.emitLookAhead(), this.lookAhead = e);
  }
  /**
  @internal
  */
  close() {
    this.curContext && this.curContext.tracker.strict && this.emitContext(), this.lookAhead > 0 && this.emitLookAhead();
  }
}
class Jt {
  constructor(e, s) {
    this.tracker = e, this.context = s, this.hash = e.strict ? e.hash(s) : 0;
  }
}
class Qs {
  constructor(e) {
    this.start = e, this.state = e.state, this.stack = e.stack, this.base = this.stack.length;
  }
  reduce(e) {
    let s = e & 65535, i = e >> 19;
    i == 0 ? (this.stack == this.start.stack && (this.stack = this.stack.slice()), this.stack.push(this.state, 0, 0), this.base += 3) : this.base -= (i - 1) * 3;
    let r = this.start.p.parser.getGoto(this.stack[this.base - 3], s, !0);
    this.state = r;
  }
}
class Ge {
  constructor(e, s, i) {
    this.stack = e, this.pos = s, this.index = i, this.buffer = e.buffer, this.index == 0 && this.maybeNext();
  }
  static create(e, s = e.bufferBase + e.buffer.length) {
    return new Ge(e, s, s - e.bufferBase);
  }
  maybeNext() {
    let e = this.stack.parent;
    e != null && (this.index = this.stack.bufferBase - e.bufferBase, this.stack = e, this.buffer = e.buffer);
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  next() {
    this.index -= 4, this.pos -= 4, this.index == 0 && this.maybeNext();
  }
  fork() {
    return new Ge(this.stack, this.pos, this.index);
  }
}
function we(t, e = Uint16Array) {
  if (typeof t != "string")
    return t;
  let s = null;
  for (let i = 0, r = 0; i < t.length; ) {
    let n = 0;
    for (; ; ) {
      let o = t.charCodeAt(i++), h = !1;
      if (o == 126) {
        n = 65535;
        break;
      }
      o >= 92 && o--, o >= 34 && o--;
      let a = o - 32;
      if (a >= 46 && (a -= 46, h = !0), n += a, h)
        break;
      n *= 46;
    }
    s ? s[r++] = n : s = new e(n);
  }
  return s;
}
class _e {
  constructor() {
    this.start = -1, this.value = -1, this.end = -1, this.extended = -1, this.lookAhead = 0, this.mask = 0, this.context = 0;
  }
}
const Ct = new _e();
class Zs {
  /**
  @internal
  */
  constructor(e, s) {
    this.input = e, this.ranges = s, this.chunk = "", this.chunkOff = 0, this.chunk2 = "", this.chunk2Pos = 0, this.next = -1, this.token = Ct, this.rangeIndex = 0, this.pos = this.chunkPos = s[0].from, this.range = s[0], this.end = s[s.length - 1].to, this.readNext();
  }
  /**
  @internal
  */
  resolveOffset(e, s) {
    let i = this.range, r = this.rangeIndex, n = this.pos + e;
    for (; n < i.from; ) {
      if (!r)
        return null;
      let o = this.ranges[--r];
      n -= i.from - o.to, i = o;
    }
    for (; s < 0 ? n > i.to : n >= i.to; ) {
      if (r == this.ranges.length - 1)
        return null;
      let o = this.ranges[++r];
      n += o.from - i.to, i = o;
    }
    return n;
  }
  /**
  @internal
  */
  clipPos(e) {
    if (e >= this.range.from && e < this.range.to)
      return e;
    for (let s of this.ranges)
      if (s.to > e)
        return Math.max(e, s.from);
    return this.end;
  }
  /**
  Look at a code unit near the stream position. `.peek(0)` equals
  `.next`, `.peek(-1)` gives you the previous character, and so
  on.
  
  Note that looking around during tokenizing creates dependencies
  on potentially far-away content, which may reduce the
  effectiveness incremental parsing—when looking forward—or even
  cause invalid reparses when looking backward more than 25 code
  units, since the library does not track lookbehind.
  */
  peek(e) {
    let s = this.chunkOff + e, i, r;
    if (s >= 0 && s < this.chunk.length)
      i = this.pos + e, r = this.chunk.charCodeAt(s);
    else {
      let n = this.resolveOffset(e, 1);
      if (n == null)
        return -1;
      if (i = n, i >= this.chunk2Pos && i < this.chunk2Pos + this.chunk2.length)
        r = this.chunk2.charCodeAt(i - this.chunk2Pos);
      else {
        let o = this.rangeIndex, h = this.range;
        for (; h.to <= i; )
          h = this.ranges[++o];
        this.chunk2 = this.input.chunk(this.chunk2Pos = i), i + this.chunk2.length > h.to && (this.chunk2 = this.chunk2.slice(0, h.to - i)), r = this.chunk2.charCodeAt(0);
      }
    }
    return i >= this.token.lookAhead && (this.token.lookAhead = i + 1), r;
  }
  /**
  Accept a token. By default, the end of the token is set to the
  current stream position, but you can pass an offset (relative to
  the stream position) to change that.
  */
  acceptToken(e, s = 0) {
    let i = s ? this.resolveOffset(s, -1) : this.pos;
    if (i == null || i < this.token.start)
      throw new RangeError("Token end out of bounds");
    this.token.value = e, this.token.end = i;
  }
  getChunk() {
    if (this.pos >= this.chunk2Pos && this.pos < this.chunk2Pos + this.chunk2.length) {
      let { chunk: e, chunkPos: s } = this;
      this.chunk = this.chunk2, this.chunkPos = this.chunk2Pos, this.chunk2 = e, this.chunk2Pos = s, this.chunkOff = this.pos - this.chunkPos;
    } else {
      this.chunk2 = this.chunk, this.chunk2Pos = this.chunkPos;
      let e = this.input.chunk(this.pos), s = this.pos + e.length;
      this.chunk = s > this.range.to ? e.slice(0, this.range.to - this.pos) : e, this.chunkPos = this.pos, this.chunkOff = 0;
    }
  }
  readNext() {
    return this.chunkOff >= this.chunk.length && (this.getChunk(), this.chunkOff == this.chunk.length) ? this.next = -1 : this.next = this.chunk.charCodeAt(this.chunkOff);
  }
  /**
  Move the stream forward N (defaults to 1) code units. Returns
  the new value of [`next`](#lr.InputStream.next).
  */
  advance(e = 1) {
    for (this.chunkOff += e; this.pos + e >= this.range.to; ) {
      if (this.rangeIndex == this.ranges.length - 1)
        return this.setDone();
      e -= this.range.to - this.pos, this.range = this.ranges[++this.rangeIndex], this.pos = this.range.from;
    }
    return this.pos += e, this.pos >= this.token.lookAhead && (this.token.lookAhead = this.pos + 1), this.readNext();
  }
  setDone() {
    return this.pos = this.chunkPos = this.end, this.range = this.ranges[this.rangeIndex = this.ranges.length - 1], this.chunk = "", this.next = -1;
  }
  /**
  @internal
  */
  reset(e, s) {
    if (s ? (this.token = s, s.start = e, s.lookAhead = e + 1, s.value = s.extended = -1) : this.token = Ct, this.pos != e) {
      if (this.pos = e, e == this.end)
        return this.setDone(), this;
      for (; e < this.range.from; )
        this.range = this.ranges[--this.rangeIndex];
      for (; e >= this.range.to; )
        this.range = this.ranges[++this.rangeIndex];
      e >= this.chunkPos && e < this.chunkPos + this.chunk.length ? this.chunkOff = e - this.chunkPos : (this.chunk = "", this.chunkOff = 0), this.readNext();
    }
    return this;
  }
  /**
  @internal
  */
  read(e, s) {
    if (e >= this.chunkPos && s <= this.chunkPos + this.chunk.length)
      return this.chunk.slice(e - this.chunkPos, s - this.chunkPos);
    if (e >= this.chunk2Pos && s <= this.chunk2Pos + this.chunk2.length)
      return this.chunk2.slice(e - this.chunk2Pos, s - this.chunk2Pos);
    if (e >= this.range.from && s <= this.range.to)
      return this.input.read(e, s);
    let i = "";
    for (let r of this.ranges) {
      if (r.from >= s)
        break;
      r.to > e && (i += this.input.read(Math.max(r.from, e), Math.min(r.to, s)));
    }
    return i;
  }
}
class de {
  constructor(e, s) {
    this.data = e, this.id = s;
  }
  token(e, s) {
    let { parser: i } = s.p;
    Ks(this.data, e, s, this.id, i.data, i.tokenPrecTable);
  }
}
de.prototype.contextual = de.prototype.fallback = de.prototype.extend = !1;
de.prototype.fallback = de.prototype.extend = !1;
class Os {
  /**
  Create a tokenizer. The first argument is the function that,
  given an input stream, scans for the types of tokens it
  recognizes at the stream's position, and calls
  [`acceptToken`](#lr.InputStream.acceptToken) when it finds
  one.
  */
  constructor(e, s = {}) {
    this.token = e, this.contextual = !!s.contextual, this.fallback = !!s.fallback, this.extend = !!s.extend;
  }
}
function Ks(t, e, s, i, r, n) {
  let o = 0, h = 1 << i, { dialect: a } = s.p.parser;
  e:
    for (; h & t[o]; ) {
      let l = t[o + 1];
      for (let p = o + 3; p < l; p += 2)
        if ((t[p + 1] & h) > 0) {
          let $ = t[p];
          if (a.allows($) && (e.token.value == -1 || e.token.value == $ || js($, e.token.value, r, n))) {
            e.acceptToken($);
            break;
          }
        }
      let x = e.next, u = 0, f = t[o + 2];
      if (e.next < 0 && f > u && t[l + f * 3 - 3] == 65535) {
        o = t[l + f * 3 - 1];
        continue e;
      }
      for (; u < f; ) {
        let p = u + f >> 1, $ = l + p + (p << 1), O = t[$], w = t[$ + 1] || 65536;
        if (x < O)
          f = p;
        else if (x >= w)
          u = p + 1;
        else {
          o = t[$ + 2], e.advance();
          continue e;
        }
      }
      break;
    }
}
function _t(t, e, s) {
  for (let i = e, r; (r = t[i]) != 65535; i++)
    if (r == s)
      return i - e;
  return -1;
}
function js(t, e, s, i) {
  let r = _t(s, i, e);
  return r < 0 || _t(s, i, t) < r;
}
const z = typeof process < "u" && process.env && /\bparse\b/.test(process.env.LOG);
let Ze = null;
function Dt(t, e, s) {
  let i = t.cursor(N.IncludeAnonymous);
  for (i.moveTo(e); ; )
    if (!(s < 0 ? i.childBefore(e) : i.childAfter(e)))
      for (; ; ) {
        if ((s < 0 ? i.to < e : i.from > e) && !i.type.isError)
          return s < 0 ? Math.max(0, Math.min(
            i.to - 1,
            e - 25
            /* Safety.Margin */
          )) : Math.min(t.length, Math.max(
            i.from + 1,
            e + 25
            /* Safety.Margin */
          ));
        if (s < 0 ? i.prevSibling() : i.nextSibling())
          break;
        if (!i.parent())
          return s < 0 ? 0 : t.length;
      }
}
class ei {
  constructor(e, s) {
    this.fragments = e, this.nodeSet = s, this.i = 0, this.fragment = null, this.safeFrom = -1, this.safeTo = -1, this.trees = [], this.start = [], this.index = [], this.nextFragment();
  }
  nextFragment() {
    let e = this.fragment = this.i == this.fragments.length ? null : this.fragments[this.i++];
    if (e) {
      for (this.safeFrom = e.openStart ? Dt(e.tree, e.from + e.offset, 1) - e.offset : e.from, this.safeTo = e.openEnd ? Dt(e.tree, e.to + e.offset, -1) - e.offset : e.to; this.trees.length; )
        this.trees.pop(), this.start.pop(), this.index.pop();
      this.trees.push(e.tree), this.start.push(-e.offset), this.index.push(0), this.nextStart = this.safeFrom;
    } else
      this.nextStart = 1e9;
  }
  // `pos` must be >= any previously given `pos` for this cursor
  nodeAt(e) {
    if (e < this.nextStart)
      return null;
    for (; this.fragment && this.safeTo <= e; )
      this.nextFragment();
    if (!this.fragment)
      return null;
    for (; ; ) {
      let s = this.trees.length - 1;
      if (s < 0)
        return this.nextFragment(), null;
      let i = this.trees[s], r = this.index[s];
      if (r == i.children.length) {
        this.trees.pop(), this.start.pop(), this.index.pop();
        continue;
      }
      let n = i.children[r], o = this.start[s] + i.positions[r];
      if (o > e)
        return this.nextStart = o, null;
      if (n instanceof _) {
        if (o == e) {
          if (o < this.safeFrom)
            return null;
          let h = o + n.length;
          if (h <= this.safeTo) {
            let a = n.prop(k.lookAhead);
            if (!a || h + a < this.fragment.to)
              return n;
          }
        }
        this.index[s]++, o + n.length >= Math.max(this.safeFrom, e) && (this.trees.push(n), this.start.push(o), this.index.push(0));
      } else
        this.index[s]++, this.nextStart = o + n.length;
    }
  }
}
class ti {
  constructor(e, s) {
    this.stream = s, this.tokens = [], this.mainToken = null, this.actions = [], this.tokens = e.tokenizers.map((i) => new _e());
  }
  getActions(e) {
    let s = 0, i = null, { parser: r } = e.p, { tokenizers: n } = r, o = r.stateSlot(
      e.state,
      3
      /* ParseState.TokenizerMask */
    ), h = e.curContext ? e.curContext.hash : 0, a = 0;
    for (let l = 0; l < n.length; l++) {
      if (!(1 << l & o))
        continue;
      let x = n[l], u = this.tokens[l];
      if (!(i && !x.fallback) && ((x.contextual || u.start != e.pos || u.mask != o || u.context != h) && (this.updateCachedToken(u, x, e), u.mask = o, u.context = h), u.lookAhead > u.end + 25 && (a = Math.max(u.lookAhead, a)), u.value != 0)) {
        let f = s;
        if (u.extended > -1 && (s = this.addActions(e, u.extended, u.end, s)), s = this.addActions(e, u.value, u.end, s), !x.extend && (i = u, s > f))
          break;
      }
    }
    for (; this.actions.length > s; )
      this.actions.pop();
    return a && e.setLookAhead(a), !i && e.pos == this.stream.end && (i = new _e(), i.value = e.p.parser.eofTerm, i.start = i.end = e.pos, s = this.addActions(e, i.value, i.end, s)), this.mainToken = i, this.actions;
  }
  getMainToken(e) {
    if (this.mainToken)
      return this.mainToken;
    let s = new _e(), { pos: i, p: r } = e;
    return s.start = i, s.end = Math.min(i + 1, r.stream.end), s.value = i == r.stream.end ? r.parser.eofTerm : 0, s;
  }
  updateCachedToken(e, s, i) {
    let r = this.stream.clipPos(i.pos);
    if (s.token(this.stream.reset(r, e), i), e.value > -1) {
      let { parser: n } = i.p;
      for (let o = 0; o < n.specialized.length; o++)
        if (n.specialized[o] == e.value) {
          let h = n.specializers[o](this.stream.read(e.start, e.end), i);
          if (h >= 0 && i.p.parser.dialect.allows(h >> 1)) {
            h & 1 ? e.extended = h >> 1 : e.value = h >> 1;
            break;
          }
        }
    } else
      e.value = 0, e.end = this.stream.clipPos(r + 1);
  }
  putAction(e, s, i, r) {
    for (let n = 0; n < r; n += 3)
      if (this.actions[n] == e)
        return r;
    return this.actions[r++] = e, this.actions[r++] = s, this.actions[r++] = i, r;
  }
  addActions(e, s, i, r) {
    let { state: n } = e, { parser: o } = e.p, { data: h } = o;
    for (let a = 0; a < 2; a++)
      for (let l = o.stateSlot(
        n,
        a ? 2 : 1
        /* ParseState.Actions */
      ); ; l += 3) {
        if (h[l] == 65535)
          if (h[l + 1] == 1)
            l = j(h, l + 2);
          else {
            r == 0 && h[l + 1] == 2 && (r = this.putAction(j(h, l + 2), s, i, r));
            break;
          }
        h[l] == s && (r = this.putAction(j(h, l + 1), s, i, r));
      }
    return r;
  }
}
class si {
  constructor(e, s, i, r) {
    this.parser = e, this.input = s, this.ranges = r, this.recovering = 0, this.nextStackID = 9812, this.minStackPos = 0, this.reused = [], this.stoppedAt = null, this.lastBigReductionStart = -1, this.lastBigReductionSize = 0, this.bigReductionCount = 0, this.stream = new Zs(s, r), this.tokens = new ti(e, this.stream), this.topTerm = e.top[1];
    let { from: n } = r[0];
    this.stacks = [He.start(this, e.top[0], n)], this.fragments = i.length && this.stream.end - n > e.bufferLength * 4 ? new ei(i, e.nodeSet) : null;
  }
  get parsedPos() {
    return this.minStackPos;
  }
  // Move the parser forward. This will process all parse stacks at
  // `this.pos` and try to advance them to a further position. If no
  // stack for such a position is found, it'll start error-recovery.
  //
  // When the parse is finished, this will return a syntax tree. When
  // not, it returns `null`.
  advance() {
    let e = this.stacks, s = this.minStackPos, i = this.stacks = [], r, n;
    if (this.bigReductionCount > 300 && e.length == 1) {
      let [o] = e;
      for (; o.forceReduce() && o.stack.length && o.stack[o.stack.length - 2] >= this.lastBigReductionStart; )
        ;
      this.bigReductionCount = this.lastBigReductionSize = 0;
    }
    for (let o = 0; o < e.length; o++) {
      let h = e[o];
      for (; ; ) {
        if (this.tokens.mainToken = null, h.pos > s)
          i.push(h);
        else {
          if (this.advanceStack(h, i, e))
            continue;
          {
            r || (r = [], n = []), r.push(h);
            let a = this.tokens.getMainToken(h);
            n.push(a.value, a.end);
          }
        }
        break;
      }
    }
    if (!i.length) {
      let o = r && ri(r);
      if (o)
        return z && console.log("Finish with " + this.stackID(o)), this.stackToTree(o);
      if (this.parser.strict)
        throw z && r && console.log("Stuck with token " + (this.tokens.mainToken ? this.parser.getName(this.tokens.mainToken.value) : "none")), new SyntaxError("No parse at " + s);
      this.recovering || (this.recovering = 5);
    }
    if (this.recovering && r) {
      let o = this.stoppedAt != null && r[0].pos > this.stoppedAt ? r[0] : this.runRecovery(r, n, i);
      if (o)
        return z && console.log("Force-finish " + this.stackID(o)), this.stackToTree(o.forceAll());
    }
    if (this.recovering) {
      let o = this.recovering == 1 ? 1 : this.recovering * 3;
      if (i.length > o)
        for (i.sort((h, a) => a.score - h.score); i.length > o; )
          i.pop();
      i.some((h) => h.reducePos > s) && this.recovering--;
    } else if (i.length > 1) {
      e:
        for (let o = 0; o < i.length - 1; o++) {
          let h = i[o];
          for (let a = o + 1; a < i.length; a++) {
            let l = i[a];
            if (h.sameState(l) || h.buffer.length > 500 && l.buffer.length > 500)
              if ((h.score - l.score || h.buffer.length - l.buffer.length) > 0)
                i.splice(a--, 1);
              else {
                i.splice(o--, 1);
                continue e;
              }
          }
        }
      i.length > 12 && i.splice(
        12,
        i.length - 12
        /* Rec.MaxStackCount */
      );
    }
    this.minStackPos = i[0].pos;
    for (let o = 1; o < i.length; o++)
      i[o].pos < this.minStackPos && (this.minStackPos = i[o].pos);
    return null;
  }
  stopAt(e) {
    if (this.stoppedAt != null && this.stoppedAt < e)
      throw new RangeError("Can't move stoppedAt forward");
    this.stoppedAt = e;
  }
  // Returns an updated version of the given stack, or null if the
  // stack can't advance normally. When `split` and `stacks` are
  // given, stacks split off by ambiguous operations will be pushed to
  // `split`, or added to `stacks` if they move `pos` forward.
  advanceStack(e, s, i) {
    let r = e.pos, { parser: n } = this, o = z ? this.stackID(e) + " -> " : "";
    if (this.stoppedAt != null && r > this.stoppedAt)
      return e.forceReduce() ? e : null;
    if (this.fragments) {
      let l = e.curContext && e.curContext.tracker.strict, x = l ? e.curContext.hash : 0;
      for (let u = this.fragments.nodeAt(r); u; ) {
        let f = this.parser.nodeSet.types[u.type.id] == u.type ? n.getGoto(e.state, u.type.id) : -1;
        if (f > -1 && u.length && (!l || (u.prop(k.contextHash) || 0) == x))
          return e.useNode(u, f), z && console.log(o + this.stackID(e) + ` (via reuse of ${n.getName(u.type.id)})`), !0;
        if (!(u instanceof _) || u.children.length == 0 || u.positions[0] > 0)
          break;
        let p = u.children[0];
        if (p instanceof _ && u.positions[0] == 0)
          u = p;
        else
          break;
      }
    }
    let h = n.stateSlot(
      e.state,
      4
      /* ParseState.DefaultReduce */
    );
    if (h > 0)
      return e.reduce(h), z && console.log(o + this.stackID(e) + ` (via always-reduce ${n.getName(
        h & 65535
        /* Action.ValueMask */
      )})`), !0;
    if (e.stack.length >= 8400)
      for (; e.stack.length > 6e3 && e.forceReduce(); )
        ;
    let a = this.tokens.getActions(e);
    for (let l = 0; l < a.length; ) {
      let x = a[l++], u = a[l++], f = a[l++], p = l == a.length || !i, $ = p ? e : e.split(), O = this.tokens.mainToken;
      if ($.apply(x, u, O ? O.start : $.pos, f), z && console.log(o + this.stackID($) + ` (via ${x & 65536 ? `reduce of ${n.getName(
        x & 65535
        /* Action.ValueMask */
      )}` : "shift"} for ${n.getName(u)} @ ${r}${$ == e ? "" : ", split"})`), p)
        return !0;
      $.pos > r ? s.push($) : i.push($);
    }
    return !1;
  }
  // Advance a given stack forward as far as it will go. Returns the
  // (possibly updated) stack if it got stuck, or null if it moved
  // forward and was given to `pushStackDedup`.
  advanceFully(e, s) {
    let i = e.pos;
    for (; ; ) {
      if (!this.advanceStack(e, null, null))
        return !1;
      if (e.pos > i)
        return At(e, s), !0;
    }
  }
  runRecovery(e, s, i) {
    let r = null, n = !1;
    for (let o = 0; o < e.length; o++) {
      let h = e[o], a = s[o << 1], l = s[(o << 1) + 1], x = z ? this.stackID(h) + " -> " : "";
      if (h.deadEnd && (n || (n = !0, h.restart(), z && console.log(x + this.stackID(h) + " (restarted)"), this.advanceFully(h, i))))
        continue;
      let u = h.split(), f = x;
      for (let p = 0; u.forceReduce() && p < 10 && (z && console.log(f + this.stackID(u) + " (via force-reduce)"), !this.advanceFully(u, i)); p++)
        z && (f = this.stackID(u) + " -> ");
      for (let p of h.recoverByInsert(a))
        z && console.log(x + this.stackID(p) + " (via recover-insert)"), this.advanceFully(p, i);
      this.stream.end > h.pos ? (l == h.pos && (l++, a = 0), h.recoverByDelete(a, l), z && console.log(x + this.stackID(h) + ` (via recover-delete ${this.parser.getName(a)})`), At(h, i)) : (!r || r.score < h.score) && (r = h);
    }
    return r;
  }
  // Convert the stack's buffer to a syntax tree.
  stackToTree(e) {
    return e.close(), _.build({
      buffer: Ge.create(e),
      nodeSet: this.parser.nodeSet,
      topID: this.topTerm,
      maxBufferLength: this.parser.bufferLength,
      reused: this.reused,
      start: this.ranges[0].from,
      length: e.pos - this.ranges[0].from,
      minRepeatType: this.parser.minRepeatTerm
    });
  }
  stackID(e) {
    let s = (Ze || (Ze = /* @__PURE__ */ new WeakMap())).get(e);
    return s || Ze.set(e, s = String.fromCodePoint(this.nextStackID++)), s + e;
  }
}
function At(t, e) {
  for (let s = 0; s < e.length; s++) {
    let i = e[s];
    if (i.pos == t.pos && i.sameState(t)) {
      e[s].score < t.score && (e[s] = t);
      return;
    }
  }
  e.push(t);
}
class ii {
  constructor(e, s, i) {
    this.source = e, this.flags = s, this.disabled = i;
  }
  allows(e) {
    return !this.disabled || this.disabled[e] == 0;
  }
}
class We extends gs {
  /**
  @internal
  */
  constructor(e) {
    if (super(), this.wrappers = [], e.version != 14)
      throw new RangeError(`Parser version (${e.version}) doesn't match runtime version (14)`);
    let s = e.nodeNames.split(" ");
    this.minRepeatTerm = s.length;
    for (let h = 0; h < e.repeatNodeCount; h++)
      s.push("");
    let i = Object.keys(e.topRules).map((h) => e.topRules[h][1]), r = [];
    for (let h = 0; h < s.length; h++)
      r.push([]);
    function n(h, a, l) {
      r[h].push([a, a.deserialize(String(l))]);
    }
    if (e.nodeProps)
      for (let h of e.nodeProps) {
        let a = h[0];
        typeof a == "string" && (a = k[a]);
        for (let l = 1; l < h.length; ) {
          let x = h[l++];
          if (x >= 0)
            n(x, a, h[l++]);
          else {
            let u = h[l + -x];
            for (let f = -x; f > 0; f--)
              n(h[l++], a, u);
            l++;
          }
        }
      }
    this.nodeSet = new mt(s.map((h, a) => W.define({
      name: a >= this.minRepeatTerm ? void 0 : h,
      id: a,
      props: r[a],
      top: i.indexOf(a) > -1,
      error: a == 0,
      skipped: e.skippedNodes && e.skippedNodes.indexOf(a) > -1
    }))), e.propSources && (this.nodeSet = this.nodeSet.extend(...e.propSources)), this.strict = !1, this.bufferLength = ps;
    let o = we(e.tokenData);
    this.context = e.context, this.specializerSpecs = e.specialized || [], this.specialized = new Uint16Array(this.specializerSpecs.length);
    for (let h = 0; h < this.specializerSpecs.length; h++)
      this.specialized[h] = this.specializerSpecs[h].term;
    this.specializers = this.specializerSpecs.map(Nt), this.states = we(e.states, Uint32Array), this.data = we(e.stateData), this.goto = we(e.goto), this.maxTerm = e.maxTerm, this.tokenizers = e.tokenizers.map((h) => typeof h == "number" ? new de(o, h) : h), this.topRules = e.topRules, this.dialects = e.dialects || {}, this.dynamicPrecedences = e.dynamicPrecedences || null, this.tokenPrecTable = e.tokenPrec, this.termNames = e.termNames || null, this.maxNode = this.nodeSet.types.length - 1, this.dialect = this.parseDialect(), this.top = this.topRules[Object.keys(this.topRules)[0]];
  }
  createParse(e, s, i) {
    let r = new si(this, e, s, i);
    for (let n of this.wrappers)
      r = n(r, e, s, i);
    return r;
  }
  /**
  Get a goto table entry @internal
  */
  getGoto(e, s, i = !1) {
    let r = this.goto;
    if (s >= r[0])
      return -1;
    for (let n = r[s + 1]; ; ) {
      let o = r[n++], h = o & 1, a = r[n++];
      if (h && i)
        return a;
      for (let l = n + (o >> 1); n < l; n++)
        if (r[n] == e)
          return a;
      if (h)
        return -1;
    }
  }
  /**
  Check if this state has an action for a given terminal @internal
  */
  hasAction(e, s) {
    let i = this.data;
    for (let r = 0; r < 2; r++)
      for (let n = this.stateSlot(
        e,
        r ? 2 : 1
        /* ParseState.Actions */
      ), o; ; n += 3) {
        if ((o = i[n]) == 65535)
          if (i[n + 1] == 1)
            o = i[n = j(i, n + 2)];
          else {
            if (i[n + 1] == 2)
              return j(i, n + 2);
            break;
          }
        if (o == s || o == 0)
          return j(i, n + 1);
      }
    return 0;
  }
  /**
  @internal
  */
  stateSlot(e, s) {
    return this.states[e * 6 + s];
  }
  /**
  @internal
  */
  stateFlag(e, s) {
    return (this.stateSlot(
      e,
      0
      /* ParseState.Flags */
    ) & s) > 0;
  }
  /**
  @internal
  */
  validAction(e, s) {
    return !!this.allActions(e, (i) => i == s ? !0 : null);
  }
  /**
  @internal
  */
  allActions(e, s) {
    let i = this.stateSlot(
      e,
      4
      /* ParseState.DefaultReduce */
    ), r = i ? s(i) : void 0;
    for (let n = this.stateSlot(
      e,
      1
      /* ParseState.Actions */
    ); r == null; n += 3) {
      if (this.data[n] == 65535)
        if (this.data[n + 1] == 1)
          n = j(this.data, n + 2);
        else
          break;
      r = s(j(this.data, n + 1));
    }
    return r;
  }
  /**
  Get the states that can follow this one through shift actions or
  goto jumps. @internal
  */
  nextStates(e) {
    let s = [];
    for (let i = this.stateSlot(
      e,
      1
      /* ParseState.Actions */
    ); ; i += 3) {
      if (this.data[i] == 65535)
        if (this.data[i + 1] == 1)
          i = j(this.data, i + 2);
        else
          break;
      if (!(this.data[i + 2] & 1)) {
        let r = this.data[i + 1];
        s.some((n, o) => o & 1 && n == r) || s.push(this.data[i], r);
      }
    }
    return s;
  }
  /**
  Configure the parser. Returns a new parser instance that has the
  given settings modified. Settings not provided in `config` are
  kept from the original parser.
  */
  configure(e) {
    let s = Object.assign(Object.create(We.prototype), this);
    if (e.props && (s.nodeSet = this.nodeSet.extend(...e.props)), e.top) {
      let i = this.topRules[e.top];
      if (!i)
        throw new RangeError(`Invalid top rule name ${e.top}`);
      s.top = i;
    }
    return e.tokenizers && (s.tokenizers = this.tokenizers.map((i) => {
      let r = e.tokenizers.find((n) => n.from == i);
      return r ? r.to : i;
    })), e.specializers && (s.specializers = this.specializers.slice(), s.specializerSpecs = this.specializerSpecs.map((i, r) => {
      let n = e.specializers.find((h) => h.from == i.external);
      if (!n)
        return i;
      let o = Object.assign(Object.assign({}, i), { external: n.to });
      return s.specializers[r] = Nt(o), o;
    })), e.contextTracker && (s.context = e.contextTracker), e.dialect && (s.dialect = this.parseDialect(e.dialect)), e.strict != null && (s.strict = e.strict), e.wrap && (s.wrappers = s.wrappers.concat(e.wrap)), e.bufferLength != null && (s.bufferLength = e.bufferLength), s;
  }
  /**
  Tells you whether any [parse wrappers](#lr.ParserConfig.wrap)
  are registered for this parser.
  */
  hasWrappers() {
    return this.wrappers.length > 0;
  }
  /**
  Returns the name associated with a given term. This will only
  work for all terms when the parser was generated with the
  `--names` option. By default, only the names of tagged terms are
  stored.
  */
  getName(e) {
    return this.termNames ? this.termNames[e] : String(e <= this.maxNode && this.nodeSet.types[e].name || e);
  }
  /**
  The eof term id is always allocated directly after the node
  types. @internal
  */
  get eofTerm() {
    return this.maxNode + 1;
  }
  /**
  The type of top node produced by the parser.
  */
  get topNode() {
    return this.nodeSet.types[this.top[1]];
  }
  /**
  @internal
  */
  dynamicPrecedence(e) {
    let s = this.dynamicPrecedences;
    return s == null ? 0 : s[e] || 0;
  }
  /**
  @internal
  */
  parseDialect(e) {
    let s = Object.keys(this.dialects), i = s.map(() => !1);
    if (e)
      for (let n of e.split(" ")) {
        let o = s.indexOf(n);
        o >= 0 && (i[o] = !0);
      }
    let r = null;
    for (let n = 0; n < s.length; n++)
      if (!i[n])
        for (let o = this.dialects[s[n]], h; (h = this.data[o++]) != 65535; )
          (r || (r = new Uint8Array(this.maxTerm + 1)))[h] = 1;
    return new ii(e, i, r);
  }
  /**
  Used by the output of the parser generator. Not available to
  user code. @hide
  */
  static deserialize(e) {
    return new We(e);
  }
}
function j(t, e) {
  return t[e] | t[e + 1] << 16;
}
function ri(t) {
  let e = null;
  for (let s of t) {
    let i = s.p.stoppedAt;
    (s.pos == s.p.stream.end || i != null && s.pos > i) && s.p.parser.stateFlag(
      s.state,
      2
      /* StateFlag.Accepting */
    ) && (!e || e.score < s.score) && (e = s);
  }
  return e;
}
function Nt(t) {
  if (t.external) {
    let e = t.extend ? 1 : 0;
    return (s, i) => t.external(s, i) << 1 | e;
  }
  return t.get;
}
const ni = 1, bs = 2, oi = 3, hi = 4, ms = 5, ai = 6, yt = 8, li = 11, Et = 12, ui = 13, xi = 14, Ss = 16, Ts = 18, fi = 20, pi = 21, ci = 22, $i = 25, kt = 0;
function Ht(t) {
  return t === 45 || t === 46 || t >= 48 && t <= 57 || t === 95 || t >= 97 && t <= 122 || t >= 65 && t <= 90 || t == 183 || t >= 192 && t <= 214 || t >= 216 && t <= 246 || t >= 248 && t <= 893 || t >= 895 && t <= 8191 || t >= 8204 && t <= 8205 || t >= 8255 && t <= 8256 || t >= 8304 && t <= 8591 || t >= 11264 && t <= 12271 || t >= 12289 && t <= 55295 || t >= 63744 && t <= 64975 || t >= 65008 && t <= 65533 || t >= 65536 && t <= 983039;
}
function Gt(t) {
  return t >= 9 && t <= 13 || t === 32 || t === 133 || t >= 8206 && t <= 8207 || t === 8232 || t === 8233;
}
function vs(t, e) {
  const s = /* @__PURE__ */ new Set(["{", "}"]);
  return t && s.add("#"), e && (s.add("<"), s.add(">")), s;
}
function ys(t, e) {
  const s = /* @__PURE__ */ new Set(["{"]);
  return t && (s.add("#"), s.add("}")), e && s.add("<"), s;
}
const Wt = "'";
function di(t, e, s, i) {
  const h = t.pos;
  let a = 0;
  e:
    for (; t.next !== -1; ) {
      const l = t.next, x = Ot(l);
      switch (a) {
        case 0:
          if (x === Wt)
            a = 2;
          else if (s.has(x))
            break e;
          break;
        case 2:
          e.has(x) ? a = 1 : a = 0;
          break;
        case 1:
          x === Wt && (a = 0);
          break;
      }
      t.advance();
    }
  h < t.pos && t.acceptToken(i);
}
function gi(t, e, s, i) {
  const l = t.pos;
  let x = 0, u = !1, f = "";
  e:
    for (; t.next !== -1; ) {
      const p = t.next, $ = Ot(p);
      switch (x) {
        case 0:
          if ($ === "<")
            x = 1;
          else
            break e;
          break;
        case 1:
          if ($ === "/")
            u = !0, x = 2;
          else if (Ht(p))
            f += $, x = 2;
          else
            break e;
          break;
        case 2:
          if ($ === ">")
            x = 4;
          else if (Gt(p)) {
            if (f === "")
              break e;
            x = 3;
          } else if (Ht(p))
            f += $;
          else
            break e;
          break;
        case 3:
          if ($ === ">")
            x = 4;
          else if (!Gt(p))
            break e;
          break;
        case 4:
          break e;
      }
      t.advance();
    }
  l >= t.pos || (x === 4 ? t.acceptToken(u ? i : s) : t.acceptToken(e));
}
function Es({
  input: t,
  stack: e,
  escapable: s,
  ending: i,
  textToken: r,
  openTag: n,
  closeTag: o
}) {
  const h = Ot(t.next), a = e.dialectEnabled(kt);
  return h === "<" && a ? gi(t, r, n, o) : di(t, s, i, r);
}
const Oi = new Os((t, e) => {
  const s = e.dialectEnabled(kt);
  return Es({
    input: t,
    stack: e,
    escapable: vs(!1, s),
    ending: ys(!1, s),
    textToken: ni,
    openTag: bs,
    closeTag: oi
  });
}), bi = new Os((t, e) => {
  const s = e.dialectEnabled(kt);
  return Es({
    input: t,
    stack: e,
    escapable: vs(!0, s),
    ending: ys(!0, s),
    textToken: hi,
    openTag: ms,
    closeTag: ai
  });
}), wt = We.deserialize({
  version: 14,
  states: "/`QQOTOOQcOUOOOOOO'#Ce'#CeOOOR'#Cq'#CqOtOSO'#CdOOOP'#Cu'#CuO|OTO'#CzQOOOOOOOOQ'#Cr'#CrO!TOUO'#DTOOOO'#Ch'#ChO!_OSO'#CgOwOSO'#CgO!jOSO,59OOOOO,59f,59fOOOO,59o,59oO!oOWO,59RO!zOSO,59RO#SOSO,59ROOOR'#Ct'#CtOOOR1G.j1G.jOOOO'#Ci'#CiO#_OSO1G.mO!rOWO1G.mOOOO'#Cl'#ClO#jOSO1G.qO#rOWO1G.mO#}OSO1G.mO$VO`O7+$XO$_OSO7+$XO$gOSO7+$XO$rOSO7+$]O$zOpO7+$]O$uOSO7+$]O!rOWO7+$XO%VOWO7+$XOOOO'#Cj'#CjOOOO'#Cw'#CwO$YO`O'#CwO%bO`O<<GsO$VO`O<<GsO%mOSO<<GsO%uOpO<<GwO&QOSO<<GwOOOO'#Cm'#CmOOOO'#Co'#CoO&VOSO'#CnOOOO'#Cx'#CxO$}OpO<<GwO&_OpO<<GwO&jOpO<<GwO&rOSO<<GsO&}OSO<<GwO!rOWO<<GsOOOO,59c,59cO'VO`OAN=_OOOO-E6u-E6uO'_O`OAN=_O$VO`OAN=_O$}OpOAN=cO'jOpOAN=cO&jOpOAN=cO'uOpOAN=cO(QOUO,59YO(XOSO,59YOOOO,59d,59dO'mOpOAN=cOOOO-E6v-E6vO%QOpO'#CxO(^OSOAN=_O(fOSOAN=cO(kOSOAN=_O(vOSOAN=cO)OO`OG22yO)WO`OG22yO&jOpOG22}O)cOpOG22}O)kOpOG22}O$}OpOG22}OOOO'#Cp'#CpO)vOSO1G.tO(QOUO1G.tO$VO`OG22yO){OpOG22}O*WOSOG22yO*`OSOG22}O*eO`OLD(eO*mOpOLD(iO*pOpOLD(iO&jOpOLD(iOOOO7+$`7+$`O*xOSO7+$`O*}O`OLD(eO$}OpOLD(iO$VO`OLD(eO+YOpOLD(iO+eOpO!$'LTO+mOpO!$'LTOOOO<<Gz<<GzO+xO`O!$'LPO&jOpO!$'LTO,QO`O!$'LPO$}OpO!$'LTO,]OpO!)9AoO,eOpO!)9AoO,pO`O!)9AkO&jOpO!)9AoO,xOpO!.K7ZO-QOpO!.K7ZO-]OpO!4/,u",
  stateData: "-h~OPUOQTORTOYQOxRO~OSXOTWOUWOYQOxRO~Oo[OpYO~OmnX~PQOmwXgwX~PcOoaOq`OgZX~OgcO~OogOreOthO~OqjOgZa~OokOqjOgZa~OomOqlOgZi~OoqOqpO~OorOreOthO~OqsOgZi~OovOstO~OqxOgZq~OoyOqxOgZq~Oo{OqzO~Oo!QOu|Ov}O~Oo!VOreOthO~Oo!XOstOgZy~Oq![OgZy~Oo!]Ou|Ov}O~Oq!`O~OY!aOo!bO~Oo!dOv}Og_y~Oo!fOv}O~Oo!gOq![OgZy~Oo!hOq!`O~OstOgZ!R~Oo!kOstOgZ!R~Oo!nOv}Og_!R~Oo!pOu|Ov}O~OgdP~PcOY!sO~Oq!tOgZ!R~Oq!uO~Oo!vOq!tOgZ!R~Oo!wOq!uO~OstOgZ!Z~Oo!xOstOgZ!Z~Ov}Og_!Z~Oo!zOv}Og_!Z~Og!|O~Oo#POu|Ov}O~Oq#QOgZ!Z~Oq#RO~OstOgZ!c~Oo#SOv}Og_!c~Og#UO~Oo#VOstOgZ!c~Oo#YOu|Ov}O~Ov}Og_!k~Oo#ZOv}Og_!k~OstOgZ!k~Oo#]OstOgZ!k~Ov}Og_!s~Oo#_Ov}Og_!s~OstOgZ!s~Ov}Og_!{~Oo#aOv}Og_!{~Ov}Og_#T~Ouv~",
  goto: "'_xPPPPPPPPy!TP!]!`!f!t!]#Y#h$O$s%fy}P%l%oP%s&ZP&}PPPPPPPP'TSUOUXXPX!a!s]SOPUX!a!sR]SQZSRb[Qf`SngjS!TrsR!i!Vdulwx!Z![!l!t#O#Q#X]!Wv!X!k!x#V#]Qi`SogjS!UrsR!j!VQ!SpS!_z!QS!m!]!`S!{!p!uS#W#P#RR#^#Yt!Ppz!R!S!^!_!`!m!o!u!y!{#R#T#W#[#^#`k!c!Q!]!d!f!n!p!z#P#S#Y#Z#_#a!a!Opz!Q!R!S!]!^!_!`!d!f!m!n!o!p!u!y!z!{#P#R#S#T#W#Y#Z#[#^#_#`#aQ!r!aR!}!sRd]TUOUQwlY!Yw!Z!l#O#XQ!ZxQ!l![Q#O!tR#X#QQ!RpS!^z!S^!e!R!^!o!y#T#[#`S!o!_!`S!y!m!uS#T!{#RQ#[#WR#`#^QVOR^UQVPQ_XT!q!a!s",
  nodeNames: "⚠ Text HtmlTagOpen HtmlTagClose TextNested HtmlTagOpenNested HtmlTagCloseNested Root Expression ExpressionOpen { FormatExpression Param FormatFunction FormatStyle SelectExpression SelectFunction Offset SelectVariant VariantDescriptor VariantContent PluralPlaceholder HtmlTagNested } ExpressionClose HtmlTag Nested",
  maxTerm: 40,
  skippedNodes: [0],
  repeatNodeCount: 2,
  tokenData: "$@Q~R!{OX&xX^,n^p&xpq,nqs+^st-ct|+^|}.i}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#W&x#W#X.n#X#b&x#b#c@s#c#d!)k#d#e!Hr#e#g&x#g#h#5}#h#i$5o#i#o&x#o#p$>u#p#q+^#q#r$?{#r#s+^#s#y&x#y#z,n#z$f&x$f$g,n$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BY#BZ,n#BZ$IS&x$IS$I_,n$I_$Id&x$Id$I|+^$I|$JO,n$JO$JT&x$JT$JU,n$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KV$KW,n$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FU&FV,n&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x]'R!csSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&xS+c_sSOX+^^p+^q|+^}#q+^#r#y+^#z$f+^$g#BY+^#BZ$IS+^$I_$I|+^$JO$JT+^$JU$KV+^$KW&FU+^&FV;'S+^;'S;=`,b<%lO+^S,eP;=`<%l+^],kP;=`<%l&x~,sYo~X^,npq,n#y#z,n$f$g,n#BY#BZ,n$IS$I_,n$I|$JO,n$JT$JU,n$KV$KW,n&FU&FV,nT-j_sSxPOX+^^p+^q|+^}#q+^#r#y+^#z$f+^$g#BY+^#BZ$IS+^$I_$I|+^$JO$JT+^$JU$KV+^$KW&FU+^&FV;'S+^;'S;=`,b<%lO+^~.nOq~_.w!dsSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#U3V#U#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_3`!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#h&x#h#i7q#i#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_7z!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#X&x#X#Y<]#Y#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_<h!crQsSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_@|!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#i&x#i#jE_#j#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_Eh!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#a&x#a#bIy#b#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_JS!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#U&x#U#VNe#V#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_Nn!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#X&x#X#Y!%P#Y#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_!%Y!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#f&x#f#g<]#g#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x]!)t!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#Y&x#Y#Z!.V#Z#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x]!.`!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#Y&x#Y#Z!2q#Z#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x]!2z!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#g&x#g#h!7]#h#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x]!7f!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#X&x#X#Y!;w#Y#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x]!<Q!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#h&x#h#i!@c#i#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x]!@l!dsSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!]!Dz!]!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x[!EPcsSOX+^^p+^q{+^{|!F[}!O!F[!O!Q+^!Q![!Gf![#q+^#r#y+^#z$f+^$g#BY+^#BZ$IS+^$I_$I|+^$JO$JT+^$JU$KV+^$KW&FU+^&FV;'S+^;'S;=`,b<%lO+^[!FaasSOX+^^p+^q|+^}!Q+^!Q![!Gf![#q+^#r#y+^#z$f+^$g#BY+^#BZ$IS+^$I_$I|+^$JO$JT+^$JU$KV+^$KW&FU+^&FV;'S+^;'S;=`,b<%lO+^[!GmasSuWOX+^^p+^q|+^}!Q+^!Q![!Gf![#q+^#r#y+^#z$f+^$g#BY+^#BZ$IS+^$I_$I|+^$JO$JT+^$JU$KV+^$KW&FU+^&FV;'S+^;'S;=`,b<%lO+^_!H{!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#`&x#`#a!M^#a#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_!Mg!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#i&x#i#j##x#j#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_#$R!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#f&x#f#g#(d#g#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_#(m!dsSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#U#,{#U#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_#-U!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#`&x#`#a#1g#a#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_#1r!csSpPtQvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_#6W!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#X&x#X#Y#:i#Y#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_#:r!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#`&x#`#a#?T#a#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_#?^!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#X&x#X#Y#Co#Y#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_#Cx!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#V&x#V#W#HZ#W#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_#Hd!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#h&x#h#i#Lu#i#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_#MQ!esSpPtQvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#c&x#c#d$#c#d#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_$#l!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#f&x#f#g$'}#g#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_$(W!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#W&x#W#X$,i#X#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_$,r!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#]&x#]#^$1T#^#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_$1^!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#b&x#b#c#(d#c#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_$5x!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#]&x#]#^$:Z#^#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&x_$:d!esSpPvWOX&x^p&xq|+^}!Q+^!Q![&x![!c+^!c!}&x!}#R+^#R#S&x#S#T+^#T#a&x#a#b7q#b#o&x#o#q+^#r#s+^#s#y&x#z$f&x$g$n+^$n$o&x$o$p+^$p$q&x$q$s+^$s$t&x$t$u+^$u$v&x$v$x+^$x$|&x$|$}+^$}%R&x%R%S+^%S%V&x%V%W+^%W%o&x%o%p+^%p&a&x&a&b+^&b#BY&x#BZ$IS&x$I_$Id&x$Id$I|+^$JO$JT&x$JU$Je+^$Je$Jg&x$Jg$Jz+^$Jz$J{&x$J{$KV+^$KW%#t&x%#t%3d+^%3d%6z&x%6z%Dl+^%Dl%E[&x%E[&/x+^&/x&;O&x&;O&=t+^&=t&FU&x&FV&FY+^&FY&F^&x&F^&Fw+^&Fw&GW&x&GW&GX+^&GX;'S&x;'S;=`,h<%l?>`&x?>`?>b+^?>b?DR&x?DR?DT+^?DTO&xT$>|_YPsSOX+^^p+^q|+^}#q+^#r#y+^#z$f+^$g#BY+^#BZ$IS+^$I_$I|+^$JO$JT+^$JU$KV+^$KW&FU+^&FV;'S+^;'S;=`,b<%lO+^~$@QOg~",
  tokenizers: [Oi, bi, 0, 1, 2, 3],
  topRules: { Root: [0, 7], Nested: [1, 26] },
  dialects: { tags: 0 },
  tokenPrec: 573
});
function mi(t) {
  const e = [];
  let s = t.firstChild;
  for (; s; )
    e.push(s), s = s.nextSibling;
  return e;
}
const Si = (t, e) => {
  let s;
  try {
    s = wt.configure({
      strict: !0,
      top: e ? "Nested" : "Root",
      dialect: "tags"
    }).parse(t);
  } catch {
    return null;
  }
  const i = [], r = /* @__PURE__ */ new Map();
  function n(u) {
    return t.substring(u.from, u.to);
  }
  function o(u) {
    const f = u.parent;
    let p = "", $;
    const O = [];
    mi(u).forEach((A) => {
      const D = n(A);
      switch (A.type.id) {
        case Et:
          p = D;
          break;
        case ui:
          $ = D;
          break;
        case xi:
          O.push(D);
          break;
      }
    });
    const w = ["{", p];
    return $ && (w.push(", "), w.push($)), O.length && w.push(`, ${O.join(" ")}`), w.push("}"), {
      position: { start: f.from, end: f.to },
      type: "variable",
      name: p,
      normalizedValue: w.join("")
    };
  }
  function h(u) {
    const f = u.firstChild, p = [bs, ms].includes(f.type.id), $ = n(f), O = $.substring(p ? 1 : 2, $.length - 1).trim();
    return {
      position: { start: f.from, end: f.to },
      type: p ? "tagOpen" : "tagClose",
      name: O,
      normalizedValue: p ? `<${O}>` : `</${O}>`
    };
  }
  function a(u) {
    if (u.type === "tagOpen") {
      const f = r.get(u.name) ?? [];
      f.push(u), r.set(u.name, f);
    } else if (u.type === "tagClose") {
      const f = r.get(u.name);
      f ? (f.pop(), f.length === 0 && r.delete(u.name)) : u.error = "missing_open_tag";
    }
    i.push(u);
  }
  const l = s.cursor();
  let x;
  do {
    const u = l.node;
    switch (u.type.id) {
      case pi:
        a({
          name: "#",
          type: "hash",
          position: { start: l.from, end: l.to },
          normalizedValue: "#"
        }), x = !1;
        break;
      case yt: {
        const f = u.firstChild.nextSibling;
        (f == null ? void 0 : f.type.id) === li && a(o(f)), x = !1;
        break;
      }
      case ci:
      case $i:
        a(h(u)), x = !1;
        break;
      default:
        x = !0;
        break;
    }
  } while (l.next(x));
  return r.forEach(
    (u) => u.forEach((f) => {
      f.error = "missing_close_tag";
    })
  ), i;
};
class Ti extends Ws {
  constructor(e, s) {
    super(), this.value = e, this.examplePluralNum = s;
  }
  toDOM() {
    const e = document.createElement("span");
    let s = `placeholder-widget placeholder-${this.value.type}`;
    this.value.error && (s = s + ` placeholder-error placeholder-error-${this.value.error}`), e.className = s;
    const i = document.createElement("span");
    return i.textContent = this.value.type !== "hash" ? this.value.name : `#${this.examplePluralNum ?? ""}`, e.appendChild(i), e;
  }
}
function zt(t, e, s) {
  const i = Si(t, s);
  return i === null ? null : i.filter((r) => {
    if (e) {
      const [n] = e;
      if (n > r.position.start && n < r.position.end)
        return !1;
    }
    return !0;
  });
}
function Ut(t, e) {
  const s = new bt();
  return t.forEach((i) => {
    s.add(
      i.position.start,
      i.position.end,
      Z.widget({
        widget: new Ti(i, e),
        side: 1
      })
    );
  }), s.finish();
}
function vi(t, e) {
  return e.find((s) => s.name === t.name && s.type === s.type);
}
function yi(t, e) {
  return e.find(
    (s) => s.name === t.name && s.type === t.type && s.position.start === s.position.start && s.position.end === s.position.end
  );
}
function Ei(t, e, s) {
  return e.filter((i) => !!(yi(i, t) || vi(i, s)));
}
function ki(t, e, s, i, r) {
  const n = s - e, h = r - i - n;
  return t.filter((a) => e < a.position.end && s > a.position.start ? !1 : (s < a.position.start && (a.position.start += h, a.position.end += h), !0));
}
function Ke(t, e) {
  let s = t;
  return e.iterChanges((i, r, n, o) => {
    s = ki(s, i, r, n, o);
  }), s;
}
const qr = (t) => {
  const { noUpdates: e, allowedNewPlaceholders: s, nested: i } = t;
  return xs.define({
    create(r) {
      try {
        return zt(r.doc.toString(), void 0, i) || [];
      } catch {
        return [];
      }
    },
    update(r, n) {
      if (e)
        return Ke(r, n.changes);
      if (n.docChanged && !e) {
        let o;
        n.changes.iterChanges((a, l, x, u) => {
          const f = l - a;
          u - x - f <= 1 && (o = [x, u]);
        });
        const h = zt(
          n.state.doc.toString(),
          o,
          i
        );
        return h === null ? Ke(r, n.changes) : s ? Ei(
          r,
          Ke(r, n.changes),
          s
        ) : h;
      }
      return r;
    },
    provide(r) {
      return Xe.fromClass(
        class {
          constructor(n) {
            Ee(this, "decorationSet");
            this.decorationSet = Ut(
              n.state.field(r),
              t == null ? void 0 : t.examplePluralNum
            );
          }
          update(n) {
            this.decorationSet = Ut(
              n.state.field(r),
              t == null ? void 0 : t.examplePluralNum
            );
          }
        },
        {
          decorations: (n) => n.decorationSet,
          provide: (n) => ue.atomicRanges.of((o) => {
            var h;
            return ((h = o.plugin(n)) == null ? void 0 : h.decorationSet) || Z.none;
          })
        }
      );
    }
  });
};
let wi = 0;
class Q {
  /**
  @internal
  */
  constructor(e, s, i) {
    this.set = e, this.base = s, this.modified = i, this.id = wi++;
  }
  /**
  Define a new tag. If `parent` is given, the tag is treated as a
  sub-tag of that parent, and
  [highlighters](#highlight.tagHighlighter) that don't mention
  this tag will try to fall back to the parent tag (or grandparent
  tag, etc).
  */
  static define(e) {
    if (e != null && e.base)
      throw new Error("Can not derive from a modified tag");
    let s = new Q([], null, []);
    if (s.set.push(s), e)
      for (let i of e.set)
        s.set.push(i);
    return s;
  }
  /**
  Define a tag _modifier_, which is a function that, given a tag,
  will return a tag that is a subtag of the original. Applying the
  same modifier to a twice tag will return the same value (`m1(t1)
  == m1(t1)`) and applying multiple modifiers will, regardless or
  order, produce the same tag (`m1(m2(t1)) == m2(m1(t1))`).
  
  When multiple modifiers are applied to a given base tag, each
  smaller set of modifiers is registered as a parent, so that for
  example `m1(m2(m3(t1)))` is a subtype of `m1(m2(t1))`,
  `m1(m3(t1)`, and so on.
  */
  static defineModifier() {
    let e = new ze();
    return (s) => s.modified.indexOf(e) > -1 ? s : ze.get(s.base || s, s.modified.concat(e).sort((i, r) => i.id - r.id));
  }
}
let Ri = 0;
class ze {
  constructor() {
    this.instances = [], this.id = Ri++;
  }
  static get(e, s) {
    if (!s.length)
      return e;
    let i = s[0].instances.find((h) => h.base == e && Ii(s, h.modified));
    if (i)
      return i;
    let r = [], n = new Q(r, e, s);
    for (let h of s)
      h.instances.push(n);
    let o = Fi(s);
    for (let h of e.set)
      if (!h.modified.length)
        for (let a of o)
          r.push(ze.get(h, a));
    return n;
  }
}
function Ii(t, e) {
  return t.length == e.length && t.every((s, i) => s == e[i]);
}
function Fi(t) {
  let e = [[]];
  for (let s = 0; s < t.length; s++)
    for (let i = 0, r = e.length; i < r; i++)
      e.push(e[i].concat(t[s]));
  return e.sort((s, i) => i.length - s.length);
}
function ks(t) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let s in t) {
    let i = t[s];
    Array.isArray(i) || (i = [i]);
    for (let r of s.split(" "))
      if (r) {
        let n = [], o = 2, h = r;
        for (let u = 0; ; ) {
          if (h == "..." && u > 0 && u + 3 == r.length) {
            o = 1;
            break;
          }
          let f = /^"(?:[^"\\]|\\.)*?"|[^\/!]+/.exec(h);
          if (!f)
            throw new RangeError("Invalid path: " + r);
          if (n.push(f[0] == "*" ? "" : f[0][0] == '"' ? JSON.parse(f[0]) : f[0]), u += f[0].length, u == r.length)
            break;
          let p = r[u++];
          if (u == r.length && p == "!") {
            o = 0;
            break;
          }
          if (p != "/")
            throw new RangeError("Invalid path: " + r);
          h = r.slice(u);
        }
        let a = n.length - 1, l = n[a];
        if (!l)
          throw new RangeError("Invalid path: " + r);
        let x = new Ue(i, o, a > 0 ? n.slice(0, a) : null);
        e[l] = x.sort(e[l]);
      }
  }
  return ws.add(e);
}
const ws = new k();
class Ue {
  constructor(e, s, i, r) {
    this.tags = e, this.mode = s, this.context = i, this.next = r;
  }
  get opaque() {
    return this.mode == 0;
  }
  get inherit() {
    return this.mode == 1;
  }
  sort(e) {
    return !e || e.depth < this.depth ? (this.next = e, this) : (e.next = this.sort(e.next), e);
  }
  get depth() {
    return this.context ? this.context.length : 0;
  }
}
Ue.empty = new Ue([], 2, null);
function Rs(t, e) {
  let s = /* @__PURE__ */ Object.create(null);
  for (let n of t)
    if (!Array.isArray(n.tag))
      s[n.tag.id] = n.class;
    else
      for (let o of n.tag)
        s[o.id] = n.class;
  let { scope: i, all: r = null } = e || {};
  return {
    style: (n) => {
      let o = r;
      for (let h of n)
        for (let a of h.set) {
          let l = s[a.id];
          if (l) {
            o = o ? o + " " + l : l;
            break;
          }
        }
      return o;
    },
    scope: i
  };
}
function Pi(t, e) {
  let s = null;
  for (let i of t) {
    let r = i.style(e);
    r && (s = s ? s + " " + r : r);
  }
  return s;
}
function Bi(t, e, s, i = 0, r = t.length) {
  let n = new Ji(i, Array.isArray(e) ? e : [e], s);
  n.highlightRange(t.cursor(), i, r, "", n.highlighters), n.flush(r);
}
class Ji {
  constructor(e, s, i) {
    this.at = e, this.highlighters = s, this.span = i, this.class = "";
  }
  startSpan(e, s) {
    s != this.class && (this.flush(e), e > this.at && (this.at = e), this.class = s);
  }
  flush(e) {
    e > this.at && this.class && this.span(this.at, e, this.class);
  }
  highlightRange(e, s, i, r, n) {
    let { type: o, from: h, to: a } = e;
    if (h >= i || a <= s)
      return;
    o.isTop && (n = this.highlighters.filter((p) => !p.scope || p.scope(o)));
    let l = r, x = Ci(e) || Ue.empty, u = Pi(n, x.tags);
    if (u && (l && (l += " "), l += u, x.mode == 1 && (r += (r ? " " : "") + u)), this.startSpan(Math.max(s, h), l), x.opaque)
      return;
    let f = e.tree && e.tree.prop(k.mounted);
    if (f && f.overlay) {
      let p = e.node.enter(f.overlay[0].from + h, 1), $ = this.highlighters.filter((w) => !w.scope || w.scope(f.tree.type)), O = e.firstChild();
      for (let w = 0, A = h; ; w++) {
        let D = w < f.overlay.length ? f.overlay[w] : null, F = D ? D.from + h : a, H = Math.max(s, A), v = Math.min(i, F);
        if (H < v && O)
          for (; e.from < v && (this.highlightRange(e, H, v, r, n), this.startSpan(Math.min(v, e.to), l), !(e.to >= F || !e.nextSibling())); )
            ;
        if (!D || F > i)
          break;
        A = D.to + h, A > s && (this.highlightRange(p.cursor(), Math.max(s, D.from + h), Math.min(i, A), "", $), this.startSpan(Math.min(i, A), l));
      }
      O && e.parent();
    } else if (e.firstChild()) {
      f && (r = "");
      do
        if (!(e.to <= s)) {
          if (e.from >= i)
            break;
          this.highlightRange(e, s, i, r, n), this.startSpan(Math.min(i, e.to), l);
        }
      while (e.nextSibling());
      e.parent();
    }
  }
}
function Ci(t) {
  let e = t.type.prop(ws);
  for (; e && e.context && !t.matchContext(e.context); )
    e = e.next;
  return e || null;
}
const c = Q.define, Re = c(), te = c(), Vt = c(te), Lt = c(te), se = c(), Ie = c(se), je = c(se), Y = c(), ae = c(Y), X = c(), M = c(), lt = c(), me = c(lt), Fe = c(), d = {
  /**
  A comment.
  */
  comment: Re,
  /**
  A line [comment](#highlight.tags.comment).
  */
  lineComment: c(Re),
  /**
  A block [comment](#highlight.tags.comment).
  */
  blockComment: c(Re),
  /**
  A documentation [comment](#highlight.tags.comment).
  */
  docComment: c(Re),
  /**
  Any kind of identifier.
  */
  name: te,
  /**
  The [name](#highlight.tags.name) of a variable.
  */
  variableName: c(te),
  /**
  A type [name](#highlight.tags.name).
  */
  typeName: Vt,
  /**
  A tag name (subtag of [`typeName`](#highlight.tags.typeName)).
  */
  tagName: c(Vt),
  /**
  A property or field [name](#highlight.tags.name).
  */
  propertyName: Lt,
  /**
  An attribute name (subtag of [`propertyName`](#highlight.tags.propertyName)).
  */
  attributeName: c(Lt),
  /**
  The [name](#highlight.tags.name) of a class.
  */
  className: c(te),
  /**
  A label [name](#highlight.tags.name).
  */
  labelName: c(te),
  /**
  A namespace [name](#highlight.tags.name).
  */
  namespace: c(te),
  /**
  The [name](#highlight.tags.name) of a macro.
  */
  macroName: c(te),
  /**
  A literal value.
  */
  literal: se,
  /**
  A string [literal](#highlight.tags.literal).
  */
  string: Ie,
  /**
  A documentation [string](#highlight.tags.string).
  */
  docString: c(Ie),
  /**
  A character literal (subtag of [string](#highlight.tags.string)).
  */
  character: c(Ie),
  /**
  An attribute value (subtag of [string](#highlight.tags.string)).
  */
  attributeValue: c(Ie),
  /**
  A number [literal](#highlight.tags.literal).
  */
  number: je,
  /**
  An integer [number](#highlight.tags.number) literal.
  */
  integer: c(je),
  /**
  A floating-point [number](#highlight.tags.number) literal.
  */
  float: c(je),
  /**
  A boolean [literal](#highlight.tags.literal).
  */
  bool: c(se),
  /**
  Regular expression [literal](#highlight.tags.literal).
  */
  regexp: c(se),
  /**
  An escape [literal](#highlight.tags.literal), for example a
  backslash escape in a string.
  */
  escape: c(se),
  /**
  A color [literal](#highlight.tags.literal).
  */
  color: c(se),
  /**
  A URL [literal](#highlight.tags.literal).
  */
  url: c(se),
  /**
  A language keyword.
  */
  keyword: X,
  /**
  The [keyword](#highlight.tags.keyword) for the self or this
  object.
  */
  self: c(X),
  /**
  The [keyword](#highlight.tags.keyword) for null.
  */
  null: c(X),
  /**
  A [keyword](#highlight.tags.keyword) denoting some atomic value.
  */
  atom: c(X),
  /**
  A [keyword](#highlight.tags.keyword) that represents a unit.
  */
  unit: c(X),
  /**
  A modifier [keyword](#highlight.tags.keyword).
  */
  modifier: c(X),
  /**
  A [keyword](#highlight.tags.keyword) that acts as an operator.
  */
  operatorKeyword: c(X),
  /**
  A control-flow related [keyword](#highlight.tags.keyword).
  */
  controlKeyword: c(X),
  /**
  A [keyword](#highlight.tags.keyword) that defines something.
  */
  definitionKeyword: c(X),
  /**
  A [keyword](#highlight.tags.keyword) related to defining or
  interfacing with modules.
  */
  moduleKeyword: c(X),
  /**
  An operator.
  */
  operator: M,
  /**
  An [operator](#highlight.tags.operator) that dereferences something.
  */
  derefOperator: c(M),
  /**
  Arithmetic-related [operator](#highlight.tags.operator).
  */
  arithmeticOperator: c(M),
  /**
  Logical [operator](#highlight.tags.operator).
  */
  logicOperator: c(M),
  /**
  Bit [operator](#highlight.tags.operator).
  */
  bitwiseOperator: c(M),
  /**
  Comparison [operator](#highlight.tags.operator).
  */
  compareOperator: c(M),
  /**
  [Operator](#highlight.tags.operator) that updates its operand.
  */
  updateOperator: c(M),
  /**
  [Operator](#highlight.tags.operator) that defines something.
  */
  definitionOperator: c(M),
  /**
  Type-related [operator](#highlight.tags.operator).
  */
  typeOperator: c(M),
  /**
  Control-flow [operator](#highlight.tags.operator).
  */
  controlOperator: c(M),
  /**
  Program or markup punctuation.
  */
  punctuation: lt,
  /**
  [Punctuation](#highlight.tags.punctuation) that separates
  things.
  */
  separator: c(lt),
  /**
  Bracket-style [punctuation](#highlight.tags.punctuation).
  */
  bracket: me,
  /**
  Angle [brackets](#highlight.tags.bracket) (usually `<` and `>`
  tokens).
  */
  angleBracket: c(me),
  /**
  Square [brackets](#highlight.tags.bracket) (usually `[` and `]`
  tokens).
  */
  squareBracket: c(me),
  /**
  Parentheses (usually `(` and `)` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  paren: c(me),
  /**
  Braces (usually `{` and `}` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  brace: c(me),
  /**
  Content, for example plain text in XML or markup documents.
  */
  content: Y,
  /**
  [Content](#highlight.tags.content) that represents a heading.
  */
  heading: ae,
  /**
  A level 1 [heading](#highlight.tags.heading).
  */
  heading1: c(ae),
  /**
  A level 2 [heading](#highlight.tags.heading).
  */
  heading2: c(ae),
  /**
  A level 3 [heading](#highlight.tags.heading).
  */
  heading3: c(ae),
  /**
  A level 4 [heading](#highlight.tags.heading).
  */
  heading4: c(ae),
  /**
  A level 5 [heading](#highlight.tags.heading).
  */
  heading5: c(ae),
  /**
  A level 6 [heading](#highlight.tags.heading).
  */
  heading6: c(ae),
  /**
  A prose separator (such as a horizontal rule).
  */
  contentSeparator: c(Y),
  /**
  [Content](#highlight.tags.content) that represents a list.
  */
  list: c(Y),
  /**
  [Content](#highlight.tags.content) that represents a quote.
  */
  quote: c(Y),
  /**
  [Content](#highlight.tags.content) that is emphasized.
  */
  emphasis: c(Y),
  /**
  [Content](#highlight.tags.content) that is styled strong.
  */
  strong: c(Y),
  /**
  [Content](#highlight.tags.content) that is part of a link.
  */
  link: c(Y),
  /**
  [Content](#highlight.tags.content) that is styled as code or
  monospace.
  */
  monospace: c(Y),
  /**
  [Content](#highlight.tags.content) that has a strike-through
  style.
  */
  strikethrough: c(Y),
  /**
  Inserted text in a change-tracking format.
  */
  inserted: c(),
  /**
  Deleted text.
  */
  deleted: c(),
  /**
  Changed text.
  */
  changed: c(),
  /**
  An invalid or unsyntactic element.
  */
  invalid: c(),
  /**
  Metadata or meta-instruction.
  */
  meta: Fe,
  /**
  [Metadata](#highlight.tags.meta) that applies to the entire
  document.
  */
  documentMeta: c(Fe),
  /**
  [Metadata](#highlight.tags.meta) that annotates or adds
  attributes to a given syntactic element.
  */
  annotation: c(Fe),
  /**
  Processing instruction or preprocessor directive. Subtag of
  [meta](#highlight.tags.meta).
  */
  processingInstruction: c(Fe),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that a
  given element is being defined. Expected to be used with the
  various [name](#highlight.tags.name) tags.
  */
  definition: Q.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that
  something is constant. Mostly expected to be used with
  [variable names](#highlight.tags.variableName).
  */
  constant: Q.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) used to indicate that
  a [variable](#highlight.tags.variableName) or [property
  name](#highlight.tags.propertyName) is being called or defined
  as a function.
  */
  function: Q.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that can be applied to
  [names](#highlight.tags.name) to indicate that they belong to
  the language's standard environment.
  */
  standard: Q.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates a given
  [names](#highlight.tags.name) is local to some scope.
  */
  local: Q.defineModifier(),
  /**
  A generic variant [modifier](#highlight.Tag^defineModifier) that
  can be used to tag language-specific alternative variants of
  some common tag. It is recommended for themes to define special
  forms of at least the [string](#highlight.tags.string) and
  [variable name](#highlight.tags.variableName) tags, since those
  come up a lot.
  */
  special: Q.defineModifier()
};
Rs([
  { tag: d.link, class: "tok-link" },
  { tag: d.heading, class: "tok-heading" },
  { tag: d.emphasis, class: "tok-emphasis" },
  { tag: d.strong, class: "tok-strong" },
  { tag: d.keyword, class: "tok-keyword" },
  { tag: d.atom, class: "tok-atom" },
  { tag: d.bool, class: "tok-bool" },
  { tag: d.url, class: "tok-url" },
  { tag: d.labelName, class: "tok-labelName" },
  { tag: d.inserted, class: "tok-inserted" },
  { tag: d.deleted, class: "tok-deleted" },
  { tag: d.literal, class: "tok-literal" },
  { tag: d.string, class: "tok-string" },
  { tag: d.number, class: "tok-number" },
  { tag: [d.regexp, d.escape, d.special(d.string)], class: "tok-string2" },
  { tag: d.variableName, class: "tok-variableName" },
  { tag: d.local(d.variableName), class: "tok-variableName tok-local" },
  { tag: d.definition(d.variableName), class: "tok-variableName tok-definition" },
  { tag: d.special(d.variableName), class: "tok-variableName2" },
  { tag: d.definition(d.propertyName), class: "tok-propertyName tok-definition" },
  { tag: d.typeName, class: "tok-typeName" },
  { tag: d.namespace, class: "tok-namespace" },
  { tag: d.className, class: "tok-className" },
  { tag: d.macroName, class: "tok-macroName" },
  { tag: d.propertyName, class: "tok-propertyName" },
  { tag: d.operator, class: "tok-operator" },
  { tag: d.comment, class: "tok-comment" },
  { tag: d.meta, class: "tok-meta" },
  { tag: d.invalid, class: "tok-invalid" },
  { tag: d.punctuation, class: "tok-punctuation" }
]);
const ut = "ͼ", qt = typeof Symbol > "u" ? "__" + ut : Symbol.for(ut), xt = typeof Symbol > "u" ? "__styleSet" + Math.floor(Math.random() * 1e8) : Symbol("styleSet"), Xt = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : {};
class Mt {
  // :: (Object<Style>, ?{finish: ?(string) → string})
  // Create a style module from the given spec.
  //
  // When `finish` is given, it is called on regular (non-`@`)
  // selectors (after `&` expansion) to compute the final selector.
  constructor(e, s) {
    this.rules = [];
    let { finish: i } = s || {};
    function r(o) {
      return /^@/.test(o) ? [o] : o.split(/,\s*/);
    }
    function n(o, h, a, l) {
      let x = [], u = /^@(\w+)\b/.exec(o[0]), f = u && u[1] == "keyframes";
      if (u && h == null)
        return a.push(o[0] + ";");
      for (let p in h) {
        let $ = h[p];
        if (/&/.test(p))
          n(
            p.split(/,\s*/).map((O) => o.map((w) => O.replace(/&/, w))).reduce((O, w) => O.concat(w)),
            $,
            a
          );
        else if ($ && typeof $ == "object") {
          if (!u)
            throw new RangeError("The value of a property (" + p + ") should be a primitive value.");
          n(r(p), $, x, f);
        } else
          $ != null && x.push(p.replace(/_.*/, "").replace(/[A-Z]/g, (O) => "-" + O.toLowerCase()) + ": " + $ + ";");
      }
      (x.length || f) && a.push((i && !u && !l ? o.map(i) : o).join(", ") + " {" + x.join(" ") + "}");
    }
    for (let o in e)
      n(r(o), e[o], this.rules);
  }
  // :: () → string
  // Returns a string containing the module's CSS rules.
  getRules() {
    return this.rules.join(`
`);
  }
  // :: () → string
  // Generate a new unique CSS class name.
  static newName() {
    let e = Xt[qt] || 1;
    return Xt[qt] = e + 1, ut + e.toString(36);
  }
  // :: (union<Document, ShadowRoot>, union<[StyleModule], StyleModule>, ?{nonce: ?string})
  //
  // Mount the given set of modules in the given DOM root, which ensures
  // that the CSS rules defined by the module are available in that
  // context.
  //
  // Rules are only added to the document once per root.
  //
  // Rule order will follow the order of the modules, so that rules from
  // modules later in the array take precedence of those from earlier
  // modules. If you call this function multiple times for the same root
  // in a way that changes the order of already mounted modules, the old
  // order will be changed.
  //
  // If a Content Security Policy nonce is provided, it is added to
  // the `<style>` tag generated by the library.
  static mount(e, s, i) {
    let r = e[xt], n = i && i.nonce;
    r ? n && r.setNonce(n) : r = new _i(e, n), r.mount(Array.isArray(s) ? s : [s]);
  }
}
let Yt = /* @__PURE__ */ new Map();
class _i {
  constructor(e, s) {
    let i = e.ownerDocument || e, r = i.defaultView;
    if (!e.head && e.adoptedStyleSheets && r.CSSStyleSheet) {
      let n = Yt.get(i);
      if (n)
        return e.adoptedStyleSheets = [n.sheet, ...e.adoptedStyleSheets], e[xt] = n;
      this.sheet = new r.CSSStyleSheet(), e.adoptedStyleSheets = [this.sheet, ...e.adoptedStyleSheets], Yt.set(i, this);
    } else {
      this.styleTag = i.createElement("style"), s && this.styleTag.setAttribute("nonce", s);
      let n = e.head || e;
      n.insertBefore(this.styleTag, n.firstChild);
    }
    this.modules = [], e[xt] = this;
  }
  mount(e) {
    let s = this.sheet, i = 0, r = 0;
    for (let n = 0; n < e.length; n++) {
      let o = e[n], h = this.modules.indexOf(o);
      if (h < r && h > -1 && (this.modules.splice(h, 1), r--, h = -1), h == -1) {
        if (this.modules.splice(r++, 0, o), s)
          for (let a = 0; a < o.rules.length; a++)
            s.insertRule(o.rules[a], i++);
      } else {
        for (; r < h; )
          i += this.modules[r++].rules.length;
        i += o.rules.length, r++;
      }
    }
    if (!s) {
      let n = "";
      for (let o = 0; o < this.modules.length; o++)
        n += this.modules[o].getRules() + `
`;
      this.styleTag.textContent = n;
    }
  }
  setNonce(e) {
    this.styleTag && this.styleTag.getAttribute("nonce") != e && this.styleTag.setAttribute("nonce", e);
  }
}
var et;
const $e = /* @__PURE__ */ new k();
function Di(t) {
  return qe.define({
    combine: t ? (e) => e.concat(t) : void 0
  });
}
const Ai = /* @__PURE__ */ new k();
class L {
  /**
  Construct a language object. If you need to invoke this
  directly, first define a data facet with
  [`defineLanguageFacet`](https://codemirror.net/6/docs/ref/#language.defineLanguageFacet), and then
  configure your parser to [attach](https://codemirror.net/6/docs/ref/#language.languageDataProp) it
  to the language's outer syntax node.
  */
  constructor(e, s, i = [], r = "") {
    this.data = e, this.name = r, Ye.prototype.hasOwnProperty("tree") || Object.defineProperty(Ye.prototype, "tree", { get() {
      return ee(this);
    } }), this.parser = s, this.extension = [
      Oe.of(this),
      Ye.languageData.of((n, o, h) => {
        let a = Qt(n, o, h), l = a.type.prop($e);
        if (!l)
          return [];
        let x = n.facet(l), u = a.type.prop(Ai);
        if (u) {
          let f = a.resolve(o - a.from, h);
          for (let p of u)
            if (p.test(f, n)) {
              let $ = n.facet(p.facet);
              return p.type == "replace" ? $ : $.concat(x);
            }
        }
        return x;
      })
    ].concat(i);
  }
  /**
  Query whether this language is active at the given position.
  */
  isActiveAt(e, s, i = -1) {
    return Qt(e, s, i).type.prop($e) == this.data;
  }
  /**
  Find the document regions that were parsed using this language.
  The returned regions will _include_ any nested languages rooted
  in this language, when those exist.
  */
  findRegions(e) {
    let s = e.facet(Oe);
    if ((s == null ? void 0 : s.data) == this.data)
      return [{ from: 0, to: e.doc.length }];
    if (!s || !s.allowsNesting)
      return [];
    let i = [], r = (n, o) => {
      if (n.prop($e) == this.data) {
        i.push({ from: o, to: o + n.length });
        return;
      }
      let h = n.prop(k.mounted);
      if (h) {
        if (h.tree.prop($e) == this.data) {
          if (h.overlay)
            for (let a of h.overlay)
              i.push({ from: a.from + o, to: a.to + o });
          else
            i.push({ from: o, to: o + n.length });
          return;
        } else if (h.overlay) {
          let a = i.length;
          if (r(h.tree, h.overlay[0].from + o), i.length > a)
            return;
        }
      }
      for (let a = 0; a < n.children.length; a++) {
        let l = n.children[a];
        l instanceof _ && r(l, n.positions[a] + o);
      }
    };
    return r(ee(e), 0), i;
  }
  /**
  Indicates whether this language allows nested languages. The
  default implementation returns true.
  */
  get allowsNesting() {
    return !0;
  }
}
L.setState = /* @__PURE__ */ Gs.define();
function Qt(t, e, s) {
  let i = t.facet(Oe), r = ee(t).topNode;
  if (!i || i.allowsNesting)
    for (let n = r; n; n = n.enter(e, s, N.ExcludeBuffers))
      n.type.isTop && (r = n);
  return r;
}
class Ve extends L {
  constructor(e, s, i) {
    super(e, s, [], i), this.parser = s;
  }
  /**
  Define a language from a parser.
  */
  static define(e) {
    let s = Di(e.languageData);
    return new Ve(s, e.parser.configure({
      props: [$e.add((i) => i.isTop ? s : void 0)]
    }), e.name);
  }
  /**
  Create a new instance of this language with a reconfigured
  version of its parser and optionally a new name.
  */
  configure(e, s) {
    return new Ve(this.data, this.parser.configure(e), s || this.name);
  }
  get allowsNesting() {
    return this.parser.hasWrappers();
  }
}
function ee(t) {
  let e = t.field(L.state, !1);
  return e ? e.tree : _.empty;
}
class Ni {
  /**
  Create an input object for the given document.
  */
  constructor(e) {
    this.doc = e, this.cursorPos = 0, this.string = "", this.cursor = e.iter();
  }
  get length() {
    return this.doc.length;
  }
  syncTo(e) {
    return this.string = this.cursor.next(e - this.cursorPos).value, this.cursorPos = e + this.string.length, this.cursorPos - this.string.length;
  }
  chunk(e) {
    return this.syncTo(e), this.string;
  }
  get lineChunks() {
    return !0;
  }
  read(e, s) {
    let i = this.cursorPos - this.string.length;
    return e < i || s >= this.cursorPos ? this.doc.sliceString(e, s) : this.string.slice(e - i, s - i);
  }
}
let Se = null;
class Le {
  constructor(e, s, i = [], r, n, o, h, a) {
    this.parser = e, this.state = s, this.fragments = i, this.tree = r, this.treeLen = n, this.viewport = o, this.skipped = h, this.scheduleOn = a, this.parse = null, this.tempSkipped = [];
  }
  /**
  @internal
  */
  static create(e, s, i) {
    return new Le(e, s, [], _.empty, 0, i, [], null);
  }
  startParse() {
    return this.parser.startParse(new Ni(this.state.doc), this.fragments);
  }
  /**
  @internal
  */
  work(e, s) {
    return s != null && s >= this.state.doc.length && (s = void 0), this.tree != _.empty && this.isDone(s ?? this.state.doc.length) ? (this.takeTree(), !0) : this.withContext(() => {
      var i;
      if (typeof e == "number") {
        let r = Date.now() + e;
        e = () => Date.now() > r;
      }
      for (this.parse || (this.parse = this.startParse()), s != null && (this.parse.stoppedAt == null || this.parse.stoppedAt > s) && s < this.state.doc.length && this.parse.stopAt(s); ; ) {
        let r = this.parse.advance();
        if (r)
          if (this.fragments = this.withoutTempSkipped(xe.addTree(r, this.fragments, this.parse.stoppedAt != null)), this.treeLen = (i = this.parse.stoppedAt) !== null && i !== void 0 ? i : this.state.doc.length, this.tree = r, this.parse = null, this.treeLen < (s ?? this.state.doc.length))
            this.parse = this.startParse();
          else
            return !0;
        if (e())
          return !1;
      }
    });
  }
  /**
  @internal
  */
  takeTree() {
    let e, s;
    this.parse && (e = this.parse.parsedPos) >= this.treeLen && ((this.parse.stoppedAt == null || this.parse.stoppedAt > e) && this.parse.stopAt(e), this.withContext(() => {
      for (; !(s = this.parse.advance()); )
        ;
    }), this.treeLen = e, this.tree = s, this.fragments = this.withoutTempSkipped(xe.addTree(this.tree, this.fragments, !0)), this.parse = null);
  }
  withContext(e) {
    let s = Se;
    Se = this;
    try {
      return e();
    } finally {
      Se = s;
    }
  }
  withoutTempSkipped(e) {
    for (let s; s = this.tempSkipped.pop(); )
      e = Zt(e, s.from, s.to);
    return e;
  }
  /**
  @internal
  */
  changes(e, s) {
    let { fragments: i, tree: r, treeLen: n, viewport: o, skipped: h } = this;
    if (this.takeTree(), !e.empty) {
      let a = [];
      if (e.iterChangedRanges((l, x, u, f) => a.push({ fromA: l, toA: x, fromB: u, toB: f })), i = xe.applyChanges(i, a), r = _.empty, n = 0, o = { from: e.mapPos(o.from, -1), to: e.mapPos(o.to, 1) }, this.skipped.length) {
        h = [];
        for (let l of this.skipped) {
          let x = e.mapPos(l.from, 1), u = e.mapPos(l.to, -1);
          x < u && h.push({ from: x, to: u });
        }
      }
    }
    return new Le(this.parser, s, i, r, n, o, h, this.scheduleOn);
  }
  /**
  @internal
  */
  updateViewport(e) {
    if (this.viewport.from == e.from && this.viewport.to == e.to)
      return !1;
    this.viewport = e;
    let s = this.skipped.length;
    for (let i = 0; i < this.skipped.length; i++) {
      let { from: r, to: n } = this.skipped[i];
      r < e.to && n > e.from && (this.fragments = Zt(this.fragments, r, n), this.skipped.splice(i--, 1));
    }
    return this.skipped.length >= s ? !1 : (this.reset(), !0);
  }
  /**
  @internal
  */
  reset() {
    this.parse && (this.takeTree(), this.parse = null);
  }
  /**
  Notify the parse scheduler that the given region was skipped
  because it wasn't in view, and the parse should be restarted
  when it comes into view.
  */
  skipUntilInView(e, s) {
    this.skipped.push({ from: e, to: s });
  }
  /**
  Returns a parser intended to be used as placeholder when
  asynchronously loading a nested parser. It'll skip its input and
  mark it as not-really-parsed, so that the next update will parse
  it again.
  
  When `until` is given, a reparse will be scheduled when that
  promise resolves.
  */
  static getSkippingParser(e) {
    return new class extends gs {
      createParse(s, i, r) {
        let n = r[0].from, o = r[r.length - 1].to;
        return {
          parsedPos: n,
          advance() {
            let a = Se;
            if (a) {
              for (let l of r)
                a.tempSkipped.push(l);
              e && (a.scheduleOn = a.scheduleOn ? Promise.all([a.scheduleOn, e]) : e);
            }
            return this.parsedPos = o, new _(W.none, [], [], o - n);
          },
          stoppedAt: null,
          stopAt() {
          }
        };
      }
    }();
  }
  /**
  @internal
  */
  isDone(e) {
    e = Math.min(e, this.state.doc.length);
    let s = this.fragments;
    return this.treeLen >= e && s.length && s[0].from == 0 && s[0].to >= e;
  }
  /**
  Get the context for the current parse, or `null` if no editor
  parse is in progress.
  */
  static get() {
    return Se;
  }
}
function Zt(t, e, s) {
  return xe.applyChanges(t, [{ fromA: e, toA: s, fromB: e, toB: s }]);
}
class ge {
  constructor(e) {
    this.context = e, this.tree = e.tree;
  }
  apply(e) {
    if (!e.docChanged && this.tree == this.context.tree)
      return this;
    let s = this.context.changes(e.changes, e.state), i = this.context.treeLen == e.startState.doc.length ? void 0 : Math.max(e.changes.mapPos(this.context.treeLen), s.viewport.to);
    return s.work(20, i) || s.takeTree(), new ge(s);
  }
  static init(e) {
    let s = Math.min(3e3, e.doc.length), i = Le.create(e.facet(Oe).parser, e, { from: 0, to: s });
    return i.work(20, s) || i.takeTree(), new ge(i);
  }
}
L.state = /* @__PURE__ */ xs.define({
  create: ge.init,
  update(t, e) {
    for (let s of e.effects)
      if (s.is(L.setState))
        return s.value;
    return e.startState.facet(Oe) != e.state.facet(Oe) ? ge.init(e.state) : t.apply(e);
  }
});
let Is = (t) => {
  let e = setTimeout(
    () => t(),
    500
    /* Work.MaxPause */
  );
  return () => clearTimeout(e);
};
typeof requestIdleCallback < "u" && (Is = (t) => {
  let e = -1, s = setTimeout(
    () => {
      e = requestIdleCallback(t, {
        timeout: 400
        /* Work.MinPause */
      });
    },
    100
    /* Work.MinPause */
  );
  return () => e < 0 ? clearTimeout(s) : cancelIdleCallback(e);
});
const tt = typeof navigator < "u" && (!((et = navigator.scheduling) === null || et === void 0) && et.isInputPending) ? () => navigator.scheduling.isInputPending() : null, Hi = /* @__PURE__ */ Xe.fromClass(class {
  constructor(e) {
    this.view = e, this.working = null, this.workScheduled = 0, this.chunkEnd = -1, this.chunkBudget = -1, this.work = this.work.bind(this), this.scheduleWork();
  }
  update(e) {
    let s = this.view.state.field(L.state).context;
    (s.updateViewport(e.view.viewport) || this.view.viewport.to > s.treeLen) && this.scheduleWork(), (e.docChanged || e.selectionSet) && (this.view.hasFocus && (this.chunkBudget += 50), this.scheduleWork()), this.checkAsyncSchedule(s);
  }
  scheduleWork() {
    if (this.working)
      return;
    let { state: e } = this.view, s = e.field(L.state);
    (s.tree != s.context.tree || !s.context.isDone(e.doc.length)) && (this.working = Is(this.work));
  }
  work(e) {
    this.working = null;
    let s = Date.now();
    if (this.chunkEnd < s && (this.chunkEnd < 0 || this.view.hasFocus) && (this.chunkEnd = s + 3e4, this.chunkBudget = 3e3), this.chunkBudget <= 0)
      return;
    let { state: i, viewport: { to: r } } = this.view, n = i.field(L.state);
    if (n.tree == n.context.tree && n.context.isDone(
      r + 1e5
      /* Work.MaxParseAhead */
    ))
      return;
    let o = Date.now() + Math.min(this.chunkBudget, 100, e && !tt ? Math.max(25, e.timeRemaining() - 5) : 1e9), h = n.context.treeLen < r && i.doc.length > r + 1e3, a = n.context.work(() => tt && tt() || Date.now() > o, r + (h ? 0 : 1e5));
    this.chunkBudget -= Date.now() - s, (a || this.chunkBudget <= 0) && (n.context.takeTree(), this.view.dispatch({ effects: L.setState.of(new ge(n.context)) })), this.chunkBudget > 0 && !(a && !h) && this.scheduleWork(), this.checkAsyncSchedule(n.context);
  }
  checkAsyncSchedule(e) {
    e.scheduleOn && (this.workScheduled++, e.scheduleOn.then(() => this.scheduleWork()).catch((s) => zs(this.view.state, s)).then(() => this.workScheduled--), e.scheduleOn = null);
  }
  destroy() {
    this.working && this.working();
  }
  isWorking() {
    return !!(this.working || this.workScheduled > 0);
  }
}, {
  eventHandlers: { focus() {
    this.scheduleWork();
  } }
}), Oe = /* @__PURE__ */ qe.define({
  combine(t) {
    return t.length ? t[0] : null;
  },
  enables: (t) => [
    L.state,
    Hi,
    ue.contentAttributes.compute([t], (e) => {
      let s = e.facet(t);
      return s && s.name ? { "data-language": s.name } : {};
    })
  ]
});
class Gi {
  /**
  Create a language support object.
  */
  constructor(e, s = []) {
    this.language = e, this.support = s, this.extension = [e, s];
  }
}
class Me {
  constructor(e, s) {
    this.specs = e;
    let i;
    function r(h) {
      let a = Mt.newName();
      return (i || (i = /* @__PURE__ */ Object.create(null)))["." + a] = h, a;
    }
    const n = typeof s.all == "string" ? s.all : s.all ? r(s.all) : void 0, o = s.scope;
    this.scope = o instanceof L ? (h) => h.prop($e) == o.data : o ? (h) => h == o : void 0, this.style = Rs(e.map((h) => ({
      tag: h.tag,
      class: h.class || r(Object.assign({}, h, { tag: null }))
    })), {
      all: n
    }).style, this.module = i ? new Mt(i) : null, this.themeType = s.themeType;
  }
  /**
  Create a highlighter style that associates the given styles to
  the given tags. The specs must be objects that hold a style tag
  or array of tags in their `tag` property, and either a single
  `class` property providing a static CSS class (for highlighter
  that rely on external styling), or a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)-style
  set of CSS properties (which define the styling for those tags).
  
  The CSS rules created for a highlighter will be emitted in the
  order of the spec's properties. That means that for elements that
  have multiple tags associated with them, styles defined further
  down in the list will have a higher CSS precedence than styles
  defined earlier.
  */
  static define(e, s) {
    return new Me(e, s || {});
  }
}
const ft = /* @__PURE__ */ qe.define(), Fs = /* @__PURE__ */ qe.define({
  combine(t) {
    return t.length ? [t[0]] : null;
  }
});
function st(t) {
  let e = t.facet(ft);
  return e.length ? e : t.facet(Fs);
}
function Wi(t, e) {
  let s = [Ui], i;
  return t instanceof Me && (t.module && s.push(ue.styleModule.of(t.module)), i = t.themeType), e != null && e.fallback ? s.push(Fs.of(t)) : i ? s.push(ft.computeN([ue.darkTheme], (r) => r.facet(ue.darkTheme) == (i == "dark") ? [t] : [])) : s.push(ft.of(t)), s;
}
class zi {
  constructor(e) {
    this.markCache = /* @__PURE__ */ Object.create(null), this.tree = ee(e.state), this.decorations = this.buildDeco(e, st(e.state));
  }
  update(e) {
    let s = ee(e.state), i = st(e.state), r = i != st(e.startState);
    s.length < e.view.viewport.to && !r && s.type == this.tree.type ? this.decorations = this.decorations.map(e.changes) : (s != this.tree || e.viewportChanged || r) && (this.tree = s, this.decorations = this.buildDeco(e.view, i));
  }
  buildDeco(e, s) {
    if (!s || !this.tree.length)
      return Z.none;
    let i = new bt();
    for (let { from: r, to: n } of e.visibleRanges)
      Bi(this.tree, s, (o, h, a) => {
        i.add(o, h, this.markCache[a] || (this.markCache[a] = Z.mark({ class: a })));
      }, r, n);
    return i.finish();
  }
}
const Ui = /* @__PURE__ */ fs.high(/* @__PURE__ */ Xe.fromClass(zi, {
  decorations: (t) => t.decorations
})), Vi = /* @__PURE__ */ Object.create(null), Kt = [W.none], jt = [], es = /* @__PURE__ */ Object.create(null), Li = /* @__PURE__ */ Object.create(null);
for (let [t, e] of [
  ["variable", "variableName"],
  ["variable-2", "variableName.special"],
  ["string-2", "string.special"],
  ["def", "variableName.definition"],
  ["tag", "tagName"],
  ["attribute", "attributeName"],
  ["type", "typeName"],
  ["builtin", "variableName.standard"],
  ["qualifier", "modifier"],
  ["error", "invalid"],
  ["header", "heading"],
  ["property", "propertyName"]
])
  Li[t] = /* @__PURE__ */ qi(Vi, e);
function it(t, e) {
  jt.indexOf(t) > -1 || (jt.push(t), console.warn(e));
}
function qi(t, e) {
  let s = [];
  for (let h of e.split(" ")) {
    let a = [];
    for (let l of h.split(".")) {
      let x = t[l] || d[l];
      x ? typeof x == "function" ? a.length ? a = a.map(x) : it(l, `Modifier ${l} used at start of tag`) : a.length ? it(l, `Tag ${l} used as modifier`) : a = Array.isArray(x) ? x : [x] : it(l, `Unknown highlighting tag ${l}`);
    }
    for (let l of a)
      s.push(l);
  }
  if (!s.length)
    return 0;
  let i = e.replace(/ /g, "_"), r = i + " " + s.map((h) => h.id), n = es[r];
  if (n)
    return n.id;
  let o = es[r] = W.define({
    id: Kt.length,
    name: i,
    props: [ks({ [i]: s })]
  });
  return Kt.push(o), o.id;
}
Ae.RTL, Ae.LTR;
const Xi = (t) => Ve.define({
  name: "icu-tolgee",
  parser: wt.configure({
    top: t ? "Nested" : "Root",
    props: [
      ks({
        TextRoot: d.string,
        Text: d.string,
        PluralPlaceholder: d.keyword,
        VariantDescriptor: d.keyword,
        FormatFunction: d.keyword,
        SelectFunction: d.keyword,
        Param: d.variableName,
        FormatStyle: d.variableName,
        "{ }": d.paren,
        Sep: d.separator,
        "< >": d.tagName,
        Slash: d.tagName,
        TagName: d.tagName
      })
    ]
  })
});
function Mr(t) {
  return new Gi(Xi(t));
}
const Yr = (t) => Wi(
  Me.define([
    { tag: d.variableName, color: t.other },
    { tag: d.keyword, color: t.function },
    { tag: d.bracket, color: t.other },
    { tag: d.tagName, color: t.other },
    { tag: d.content, color: t.main },
    { tag: d.string, color: t.main }
  ])
), Qr = Xe.fromClass(
  class {
    constructor(t) {
      Ee(this, "isolates");
      Ee(this, "tree");
      this.isolates = ts(t), this.tree = ee(t.state);
    }
    update(t) {
      (t.docChanged || t.viewportChanged || ee(t.state) != this.tree) && (this.isolates = ts(t.view), this.tree = ee(t.state));
    }
  },
  {
    provide: (t) => {
      function e(s) {
        var i;
        return ((i = s.plugin(t)) == null ? void 0 : i.isolates) ?? Z.none;
      }
      return fs.lowest([
        ue.decorations.of(e),
        ue.bidiIsolatedRanges.of(e)
      ]);
    }
  }
), Mi = Z.mark({
  attributes: { style: "direction: ltr; unicode-bidi: isolate" },
  bidiIsolate: Ae.LTR
}), Yi = Z.mark({
  attributes: { style: "direction: rtl; unicode-bidi: isolate" },
  bidiIsolate: Ae.RTL
});
function ts(t) {
  const e = new bt();
  for (const { from: s, to: i } of t.visibleRanges)
    ee(t.state).iterate({
      from: s,
      to: i,
      enter(r) {
        (r.name === "HtmlTagOpen" || r.name === "HtmlTagClose" || r.name === "Expression") && e.add(r.from, r.to, Mi), (r.name === "TextRoot" || r.name === "Text") && e.add(r.from, r.to, Yi);
      }
    });
  return e.finish();
}
const Qi = {
  variable: {
    border: "#7AD3C1",
    background: "#BEF3E9",
    text: "#008371"
  },
  tag: {
    border: "#F27FA6",
    background: "#F9C4D6",
    text: "#822343"
  },
  variant: {
    border: "#BBC2CB",
    background: "#F0F2F4",
    text: "#4D5B6E"
  }
}, Zr = ({
  styled: t,
  colors: e = Qi,
  component: s = "div"
}) => t(s)`
    white-space: pre-wrap;
    & .placeholder-widget {
      display: inline-flex;
      vertical-align: text-top;
      align-items: center;
      justify-content: center;
      min-width: 15px;
      border: 1px solid ${e.variable.border};
      background-color: ${e.variable.background};
      color: ${e.variable.text};
      border-radius: 10px;
      padding: 0px 7px;
      font-size: 12px;
      user-select: none;
      margin: 0px 1px;
      overflow: hidden;

      & > * {
        display: grid;
      }
    }
    & .placeholder-error {
      background: #ff000054;
    }

    & .placeholder-tagOpen {
      border: 1px solid ${e.tag.border};
      background-color: ${e.tag.background};
      color: ${e.tag.text};
      border-radius: 10px 0px 0px 10px;
      padding-right: 6px;
    }

    & .placeholder-tagClose {
      border: 1px solid ${e.tag.border};
      background-color: ${e.tag.background};
      color: ${e.tag.text};
      border-radius: 0px 10px 10px 0px;
      padding-left: 6px;
    }

    // in rtl mode, revert the placeholders direction
    &[dir="rtl"] .placeholder-tagOpen {
      border-radius: 0px 10px 10px 0px;
      padding-left: 6px;
    }
    &[dir="rtl"] .placeholder-tagClose {
      border-radius: 10px 0px 0px 10px;
      padding-right: 6px;
    }
  `, Zi = (t) => /^[^\p{White_Space}\p{Pattern_Syntax}]*$/uy.test(t), Pe = 0, rt = 1, Be = 2, nt = 3, ss = /* @__PURE__ */ new Set(["{", "}", "#"]), is = /* @__PURE__ */ new Set(["{", "}"]), le = "'", Ki = (t) => {
  let e = Pe;
  const s = [];
  let i;
  for (const r of t)
    switch (e) {
      case Pe:
        r === le ? e = Be : is.has(r) && (s.push(le), i = s.length, e = nt), s.push(r);
        break;
      case Be:
        ss.has(r) ? (i = s.length, e = rt) : e = Pe, s.push(r);
        break;
      case rt:
        r === le ? e = Pe : ss.has(r) && (i = s.length), s.push(r);
        break;
      case nt:
        r === le ? (s.splice(i + 1, 0, le), e = Be) : is.has(r) && (i = s.length), s.push(r);
        break;
    }
  return [rt, nt].includes(e) ? s.splice(i + 1, 0, le) : e === Be && s.push(le), s.join("");
};
var I = function() {
  return I = Object.assign || function(e) {
    for (var s, i = 1, r = arguments.length; i < r; i++) {
      s = arguments[i];
      for (var n in s)
        Object.prototype.hasOwnProperty.call(s, n) && (e[n] = s[n]);
    }
    return e;
  }, I.apply(this, arguments);
};
var b;
(function(t) {
  t[t.EXPECT_ARGUMENT_CLOSING_BRACE = 1] = "EXPECT_ARGUMENT_CLOSING_BRACE", t[t.EMPTY_ARGUMENT = 2] = "EMPTY_ARGUMENT", t[t.MALFORMED_ARGUMENT = 3] = "MALFORMED_ARGUMENT", t[t.EXPECT_ARGUMENT_TYPE = 4] = "EXPECT_ARGUMENT_TYPE", t[t.INVALID_ARGUMENT_TYPE = 5] = "INVALID_ARGUMENT_TYPE", t[t.EXPECT_ARGUMENT_STYLE = 6] = "EXPECT_ARGUMENT_STYLE", t[t.INVALID_NUMBER_SKELETON = 7] = "INVALID_NUMBER_SKELETON", t[t.INVALID_DATE_TIME_SKELETON = 8] = "INVALID_DATE_TIME_SKELETON", t[t.EXPECT_NUMBER_SKELETON = 9] = "EXPECT_NUMBER_SKELETON", t[t.EXPECT_DATE_TIME_SKELETON = 10] = "EXPECT_DATE_TIME_SKELETON", t[t.UNCLOSED_QUOTE_IN_ARGUMENT_STYLE = 11] = "UNCLOSED_QUOTE_IN_ARGUMENT_STYLE", t[t.EXPECT_SELECT_ARGUMENT_OPTIONS = 12] = "EXPECT_SELECT_ARGUMENT_OPTIONS", t[t.EXPECT_PLURAL_ARGUMENT_OFFSET_VALUE = 13] = "EXPECT_PLURAL_ARGUMENT_OFFSET_VALUE", t[t.INVALID_PLURAL_ARGUMENT_OFFSET_VALUE = 14] = "INVALID_PLURAL_ARGUMENT_OFFSET_VALUE", t[t.EXPECT_SELECT_ARGUMENT_SELECTOR = 15] = "EXPECT_SELECT_ARGUMENT_SELECTOR", t[t.EXPECT_PLURAL_ARGUMENT_SELECTOR = 16] = "EXPECT_PLURAL_ARGUMENT_SELECTOR", t[t.EXPECT_SELECT_ARGUMENT_SELECTOR_FRAGMENT = 17] = "EXPECT_SELECT_ARGUMENT_SELECTOR_FRAGMENT", t[t.EXPECT_PLURAL_ARGUMENT_SELECTOR_FRAGMENT = 18] = "EXPECT_PLURAL_ARGUMENT_SELECTOR_FRAGMENT", t[t.INVALID_PLURAL_ARGUMENT_SELECTOR = 19] = "INVALID_PLURAL_ARGUMENT_SELECTOR", t[t.DUPLICATE_PLURAL_ARGUMENT_SELECTOR = 20] = "DUPLICATE_PLURAL_ARGUMENT_SELECTOR", t[t.DUPLICATE_SELECT_ARGUMENT_SELECTOR = 21] = "DUPLICATE_SELECT_ARGUMENT_SELECTOR", t[t.MISSING_OTHER_CLAUSE = 22] = "MISSING_OTHER_CLAUSE", t[t.INVALID_TAG = 23] = "INVALID_TAG", t[t.INVALID_TAG_NAME = 25] = "INVALID_TAG_NAME", t[t.UNMATCHED_CLOSING_TAG = 26] = "UNMATCHED_CLOSING_TAG", t[t.UNCLOSED_TAG = 27] = "UNCLOSED_TAG";
})(b || (b = {}));
var C;
(function(t) {
  t[t.literal = 0] = "literal", t[t.argument = 1] = "argument", t[t.number = 2] = "number", t[t.date = 3] = "date", t[t.time = 4] = "time", t[t.select = 5] = "select", t[t.plural = 6] = "plural", t[t.pound = 7] = "pound", t[t.tag = 8] = "tag";
})(C || (C = {}));
var be;
(function(t) {
  t[t.number = 0] = "number", t[t.dateTime = 1] = "dateTime";
})(be || (be = {}));
function ji(t) {
  return t.type === C.number;
}
function er(t) {
  return t.type === C.date;
}
function tr(t) {
  return t.type === C.time;
}
function sr(t) {
  return t.type === C.select;
}
function ir(t) {
  return t.type === C.plural;
}
function rr(t) {
  return t.type === C.tag;
}
function nr(t) {
  return !!(t && typeof t == "object" && t.type === be.number);
}
function or(t) {
  return !!(t && typeof t == "object" && t.type === be.dateTime);
}
var Ps = /[ \xA0\u1680\u2000-\u200A\u202F\u205F\u3000]/, hr = /(?:[Eec]{1,6}|G{1,5}|[Qq]{1,5}|(?:[yYur]+|U{1,5})|[ML]{1,5}|d{1,2}|D{1,3}|F{1}|[abB]{1,5}|[hkHK]{1,2}|w{1,2}|W{1}|m{1,2}|s{1,2}|[zZOvVxX]{1,4})(?=([^']*'[^']*')*[^']*$)/g;
function ar(t) {
  var e = {};
  return t.replace(hr, function(s) {
    var i = s.length;
    switch (s[0]) {
      case "G":
        e.era = i === 4 ? "long" : i === 5 ? "narrow" : "short";
        break;
      case "y":
        e.year = i === 2 ? "2-digit" : "numeric";
        break;
      case "Y":
      case "u":
      case "U":
      case "r":
        throw new RangeError("`Y/u/U/r` (year) patterns are not supported, use `y` instead");
      case "q":
      case "Q":
        throw new RangeError("`q/Q` (quarter) patterns are not supported");
      case "M":
      case "L":
        e.month = ["numeric", "2-digit", "short", "long", "narrow"][i - 1];
        break;
      case "w":
      case "W":
        throw new RangeError("`w/W` (week) patterns are not supported");
      case "d":
        e.day = ["numeric", "2-digit"][i - 1];
        break;
      case "D":
      case "F":
      case "g":
        throw new RangeError("`D/F/g` (day) patterns are not supported, use `d` instead");
      case "E":
        e.weekday = i === 4 ? "long" : i === 5 ? "narrow" : "short";
        break;
      case "e":
        if (i < 4)
          throw new RangeError("`e..eee` (weekday) patterns are not supported");
        e.weekday = ["short", "long", "narrow", "short"][i - 4];
        break;
      case "c":
        if (i < 4)
          throw new RangeError("`c..ccc` (weekday) patterns are not supported");
        e.weekday = ["short", "long", "narrow", "short"][i - 4];
        break;
      case "a":
        e.hour12 = !0;
        break;
      case "b":
      case "B":
        throw new RangeError("`b/B` (period) patterns are not supported, use `a` instead");
      case "h":
        e.hourCycle = "h12", e.hour = ["numeric", "2-digit"][i - 1];
        break;
      case "H":
        e.hourCycle = "h23", e.hour = ["numeric", "2-digit"][i - 1];
        break;
      case "K":
        e.hourCycle = "h11", e.hour = ["numeric", "2-digit"][i - 1];
        break;
      case "k":
        e.hourCycle = "h24", e.hour = ["numeric", "2-digit"][i - 1];
        break;
      case "j":
      case "J":
      case "C":
        throw new RangeError("`j/J/C` (hour) patterns are not supported, use `h/H/K/k` instead");
      case "m":
        e.minute = ["numeric", "2-digit"][i - 1];
        break;
      case "s":
        e.second = ["numeric", "2-digit"][i - 1];
        break;
      case "S":
      case "A":
        throw new RangeError("`S/A` (second) patterns are not supported, use `s` instead");
      case "z":
        e.timeZoneName = i < 4 ? "short" : "long";
        break;
      case "Z":
      case "O":
      case "v":
      case "V":
      case "X":
      case "x":
        throw new RangeError("`Z/O/v/V/X/x` (timeZone) patterns are not supported, use `z` instead");
    }
    return "";
  }), e;
}
var lr = /[\t-\r \x85\u200E\u200F\u2028\u2029]/i;
function ur(t) {
  if (t.length === 0)
    throw new Error("Number skeleton cannot be empty");
  for (var e = t.split(lr).filter(function(f) {
    return f.length > 0;
  }), s = [], i = 0, r = e; i < r.length; i++) {
    var n = r[i], o = n.split("/");
    if (o.length === 0)
      throw new Error("Invalid number skeleton");
    for (var h = o[0], a = o.slice(1), l = 0, x = a; l < x.length; l++) {
      var u = x[l];
      if (u.length === 0)
        throw new Error("Invalid number skeleton");
    }
    s.push({ stem: h, options: a });
  }
  return s;
}
function xr(t) {
  return t.replace(/^(.*?)-/, "");
}
var rs = /^\.(?:(0+)(\*)?|(#+)|(0+)(#+))$/g, Bs = /^(@+)?(\+|#+)?[rs]?$/g, fr = /(\*)(0+)|(#+)(0+)|(0+)/g, Js = /^(0+)$/;
function ns(t) {
  var e = {};
  return t[t.length - 1] === "r" ? e.roundingPriority = "morePrecision" : t[t.length - 1] === "s" && (e.roundingPriority = "lessPrecision"), t.replace(Bs, function(s, i, r) {
    return typeof r != "string" ? (e.minimumSignificantDigits = i.length, e.maximumSignificantDigits = i.length) : r === "+" ? e.minimumSignificantDigits = i.length : i[0] === "#" ? e.maximumSignificantDigits = i.length : (e.minimumSignificantDigits = i.length, e.maximumSignificantDigits = i.length + (typeof r == "string" ? r.length : 0)), "";
  }), e;
}
function Cs(t) {
  switch (t) {
    case "sign-auto":
      return {
        signDisplay: "auto"
      };
    case "sign-accounting":
    case "()":
      return {
        currencySign: "accounting"
      };
    case "sign-always":
    case "+!":
      return {
        signDisplay: "always"
      };
    case "sign-accounting-always":
    case "()!":
      return {
        signDisplay: "always",
        currencySign: "accounting"
      };
    case "sign-except-zero":
    case "+?":
      return {
        signDisplay: "exceptZero"
      };
    case "sign-accounting-except-zero":
    case "()?":
      return {
        signDisplay: "exceptZero",
        currencySign: "accounting"
      };
    case "sign-never":
    case "+_":
      return {
        signDisplay: "never"
      };
  }
}
function pr(t) {
  var e;
  if (t[0] === "E" && t[1] === "E" ? (e = {
    notation: "engineering"
  }, t = t.slice(2)) : t[0] === "E" && (e = {
    notation: "scientific"
  }, t = t.slice(1)), e) {
    var s = t.slice(0, 2);
    if (s === "+!" ? (e.signDisplay = "always", t = t.slice(2)) : s === "+?" && (e.signDisplay = "exceptZero", t = t.slice(2)), !Js.test(t))
      throw new Error("Malformed concise eng/scientific notation");
    e.minimumIntegerDigits = t.length;
  }
  return e;
}
function os(t) {
  var e = {}, s = Cs(t);
  return s || e;
}
function cr(t) {
  for (var e = {}, s = 0, i = t; s < i.length; s++) {
    var r = i[s];
    switch (r.stem) {
      case "percent":
      case "%":
        e.style = "percent";
        continue;
      case "%x100":
        e.style = "percent", e.scale = 100;
        continue;
      case "currency":
        e.style = "currency", e.currency = r.options[0];
        continue;
      case "group-off":
      case ",_":
        e.useGrouping = !1;
        continue;
      case "precision-integer":
      case ".":
        e.maximumFractionDigits = 0;
        continue;
      case "measure-unit":
      case "unit":
        e.style = "unit", e.unit = xr(r.options[0]);
        continue;
      case "compact-short":
      case "K":
        e.notation = "compact", e.compactDisplay = "short";
        continue;
      case "compact-long":
      case "KK":
        e.notation = "compact", e.compactDisplay = "long";
        continue;
      case "scientific":
        e = I(I(I({}, e), { notation: "scientific" }), r.options.reduce(function(a, l) {
          return I(I({}, a), os(l));
        }, {}));
        continue;
      case "engineering":
        e = I(I(I({}, e), { notation: "engineering" }), r.options.reduce(function(a, l) {
          return I(I({}, a), os(l));
        }, {}));
        continue;
      case "notation-simple":
        e.notation = "standard";
        continue;
      case "unit-width-narrow":
        e.currencyDisplay = "narrowSymbol", e.unitDisplay = "narrow";
        continue;
      case "unit-width-short":
        e.currencyDisplay = "code", e.unitDisplay = "short";
        continue;
      case "unit-width-full-name":
        e.currencyDisplay = "name", e.unitDisplay = "long";
        continue;
      case "unit-width-iso-code":
        e.currencyDisplay = "symbol";
        continue;
      case "scale":
        e.scale = parseFloat(r.options[0]);
        continue;
      case "integer-width":
        if (r.options.length > 1)
          throw new RangeError("integer-width stems only accept a single optional option");
        r.options[0].replace(fr, function(a, l, x, u, f, p) {
          if (l)
            e.minimumIntegerDigits = x.length;
          else {
            if (u && f)
              throw new Error("We currently do not support maximum integer digits");
            if (p)
              throw new Error("We currently do not support exact integer digits");
          }
          return "";
        });
        continue;
    }
    if (Js.test(r.stem)) {
      e.minimumIntegerDigits = r.stem.length;
      continue;
    }
    if (rs.test(r.stem)) {
      if (r.options.length > 1)
        throw new RangeError("Fraction-precision stems only accept a single optional option");
      r.stem.replace(rs, function(a, l, x, u, f, p) {
        return x === "*" ? e.minimumFractionDigits = l.length : u && u[0] === "#" ? e.maximumFractionDigits = u.length : f && p ? (e.minimumFractionDigits = f.length, e.maximumFractionDigits = f.length + p.length) : (e.minimumFractionDigits = l.length, e.maximumFractionDigits = l.length), "";
      });
      var n = r.options[0];
      n === "w" ? e = I(I({}, e), { trailingZeroDisplay: "stripIfInteger" }) : n && (e = I(I({}, e), ns(n)));
      continue;
    }
    if (Bs.test(r.stem)) {
      e = I(I({}, e), ns(r.stem));
      continue;
    }
    var o = Cs(r.stem);
    o && (e = I(I({}, e), o));
    var h = pr(r.stem);
    h && (e = I(I({}, e), h));
  }
  return e;
}
var Je = {
  "001": [
    "H",
    "h"
  ],
  AC: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  AD: [
    "H",
    "hB"
  ],
  AE: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  AF: [
    "H",
    "hb",
    "hB",
    "h"
  ],
  AG: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  AI: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  AL: [
    "h",
    "H",
    "hB"
  ],
  AM: [
    "H",
    "hB"
  ],
  AO: [
    "H",
    "hB"
  ],
  AR: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  AS: [
    "h",
    "H"
  ],
  AT: [
    "H",
    "hB"
  ],
  AU: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  AW: [
    "H",
    "hB"
  ],
  AX: [
    "H"
  ],
  AZ: [
    "H",
    "hB",
    "h"
  ],
  BA: [
    "H",
    "hB",
    "h"
  ],
  BB: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  BD: [
    "h",
    "hB",
    "H"
  ],
  BE: [
    "H",
    "hB"
  ],
  BF: [
    "H",
    "hB"
  ],
  BG: [
    "H",
    "hB",
    "h"
  ],
  BH: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  BI: [
    "H",
    "h"
  ],
  BJ: [
    "H",
    "hB"
  ],
  BL: [
    "H",
    "hB"
  ],
  BM: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  BN: [
    "hb",
    "hB",
    "h",
    "H"
  ],
  BO: [
    "H",
    "hB",
    "h",
    "hb"
  ],
  BQ: [
    "H"
  ],
  BR: [
    "H",
    "hB"
  ],
  BS: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  BT: [
    "h",
    "H"
  ],
  BW: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  BY: [
    "H",
    "h"
  ],
  BZ: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  CA: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  CC: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  CD: [
    "hB",
    "H"
  ],
  CF: [
    "H",
    "h",
    "hB"
  ],
  CG: [
    "H",
    "hB"
  ],
  CH: [
    "H",
    "hB",
    "h"
  ],
  CI: [
    "H",
    "hB"
  ],
  CK: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  CL: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  CM: [
    "H",
    "h",
    "hB"
  ],
  CN: [
    "H",
    "hB",
    "hb",
    "h"
  ],
  CO: [
    "h",
    "H",
    "hB",
    "hb"
  ],
  CP: [
    "H"
  ],
  CR: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  CU: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  CV: [
    "H",
    "hB"
  ],
  CW: [
    "H",
    "hB"
  ],
  CX: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  CY: [
    "h",
    "H",
    "hb",
    "hB"
  ],
  CZ: [
    "H"
  ],
  DE: [
    "H",
    "hB"
  ],
  DG: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  DJ: [
    "h",
    "H"
  ],
  DK: [
    "H"
  ],
  DM: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  DO: [
    "h",
    "H",
    "hB",
    "hb"
  ],
  DZ: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  EA: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  EC: [
    "H",
    "hB",
    "h",
    "hb"
  ],
  EE: [
    "H",
    "hB"
  ],
  EG: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  EH: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  ER: [
    "h",
    "H"
  ],
  ES: [
    "H",
    "hB",
    "h",
    "hb"
  ],
  ET: [
    "hB",
    "hb",
    "h",
    "H"
  ],
  FI: [
    "H"
  ],
  FJ: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  FK: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  FM: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  FO: [
    "H",
    "h"
  ],
  FR: [
    "H",
    "hB"
  ],
  GA: [
    "H",
    "hB"
  ],
  GB: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  GD: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  GE: [
    "H",
    "hB",
    "h"
  ],
  GF: [
    "H",
    "hB"
  ],
  GG: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  GH: [
    "h",
    "H"
  ],
  GI: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  GL: [
    "H",
    "h"
  ],
  GM: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  GN: [
    "H",
    "hB"
  ],
  GP: [
    "H",
    "hB"
  ],
  GQ: [
    "H",
    "hB",
    "h",
    "hb"
  ],
  GR: [
    "h",
    "H",
    "hb",
    "hB"
  ],
  GT: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  GU: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  GW: [
    "H",
    "hB"
  ],
  GY: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  HK: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  HN: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  HR: [
    "H",
    "hB"
  ],
  HU: [
    "H",
    "h"
  ],
  IC: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  ID: [
    "H"
  ],
  IE: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  IL: [
    "H",
    "hB"
  ],
  IM: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  IN: [
    "h",
    "H"
  ],
  IO: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  IQ: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  IR: [
    "hB",
    "H"
  ],
  IS: [
    "H"
  ],
  IT: [
    "H",
    "hB"
  ],
  JE: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  JM: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  JO: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  JP: [
    "H",
    "K",
    "h"
  ],
  KE: [
    "hB",
    "hb",
    "H",
    "h"
  ],
  KG: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  KH: [
    "hB",
    "h",
    "H",
    "hb"
  ],
  KI: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  KM: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  KN: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  KP: [
    "h",
    "H",
    "hB",
    "hb"
  ],
  KR: [
    "h",
    "H",
    "hB",
    "hb"
  ],
  KW: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  KY: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  KZ: [
    "H",
    "hB"
  ],
  LA: [
    "H",
    "hb",
    "hB",
    "h"
  ],
  LB: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  LC: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  LI: [
    "H",
    "hB",
    "h"
  ],
  LK: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  LR: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  LS: [
    "h",
    "H"
  ],
  LT: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  LU: [
    "H",
    "h",
    "hB"
  ],
  LV: [
    "H",
    "hB",
    "hb",
    "h"
  ],
  LY: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  MA: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  MC: [
    "H",
    "hB"
  ],
  MD: [
    "H",
    "hB"
  ],
  ME: [
    "H",
    "hB",
    "h"
  ],
  MF: [
    "H",
    "hB"
  ],
  MG: [
    "H",
    "h"
  ],
  MH: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  MK: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  ML: [
    "H"
  ],
  MM: [
    "hB",
    "hb",
    "H",
    "h"
  ],
  MN: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  MO: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  MP: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  MQ: [
    "H",
    "hB"
  ],
  MR: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  MS: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  MT: [
    "H",
    "h"
  ],
  MU: [
    "H",
    "h"
  ],
  MV: [
    "H",
    "h"
  ],
  MW: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  MX: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  MY: [
    "hb",
    "hB",
    "h",
    "H"
  ],
  MZ: [
    "H",
    "hB"
  ],
  NA: [
    "h",
    "H",
    "hB",
    "hb"
  ],
  NC: [
    "H",
    "hB"
  ],
  NE: [
    "H"
  ],
  NF: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  NG: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  NI: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  NL: [
    "H",
    "hB"
  ],
  NO: [
    "H",
    "h"
  ],
  NP: [
    "H",
    "h",
    "hB"
  ],
  NR: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  NU: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  NZ: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  OM: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  PA: [
    "h",
    "H",
    "hB",
    "hb"
  ],
  PE: [
    "H",
    "hB",
    "h",
    "hb"
  ],
  PF: [
    "H",
    "h",
    "hB"
  ],
  PG: [
    "h",
    "H"
  ],
  PH: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  PK: [
    "h",
    "hB",
    "H"
  ],
  PL: [
    "H",
    "h"
  ],
  PM: [
    "H",
    "hB"
  ],
  PN: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  PR: [
    "h",
    "H",
    "hB",
    "hb"
  ],
  PS: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  PT: [
    "H",
    "hB"
  ],
  PW: [
    "h",
    "H"
  ],
  PY: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  QA: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  RE: [
    "H",
    "hB"
  ],
  RO: [
    "H",
    "hB"
  ],
  RS: [
    "H",
    "hB",
    "h"
  ],
  RU: [
    "H"
  ],
  RW: [
    "H",
    "h"
  ],
  SA: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  SB: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  SC: [
    "H",
    "h",
    "hB"
  ],
  SD: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  SE: [
    "H"
  ],
  SG: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  SH: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  SI: [
    "H",
    "hB"
  ],
  SJ: [
    "H"
  ],
  SK: [
    "H"
  ],
  SL: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  SM: [
    "H",
    "h",
    "hB"
  ],
  SN: [
    "H",
    "h",
    "hB"
  ],
  SO: [
    "h",
    "H"
  ],
  SR: [
    "H",
    "hB"
  ],
  SS: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  ST: [
    "H",
    "hB"
  ],
  SV: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  SX: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  SY: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  SZ: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  TA: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  TC: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  TD: [
    "h",
    "H",
    "hB"
  ],
  TF: [
    "H",
    "h",
    "hB"
  ],
  TG: [
    "H",
    "hB"
  ],
  TH: [
    "H",
    "h"
  ],
  TJ: [
    "H",
    "h"
  ],
  TL: [
    "H",
    "hB",
    "hb",
    "h"
  ],
  TM: [
    "H",
    "h"
  ],
  TN: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  TO: [
    "h",
    "H"
  ],
  TR: [
    "H",
    "hB"
  ],
  TT: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  TW: [
    "hB",
    "hb",
    "h",
    "H"
  ],
  TZ: [
    "hB",
    "hb",
    "H",
    "h"
  ],
  UA: [
    "H",
    "hB",
    "h"
  ],
  UG: [
    "hB",
    "hb",
    "H",
    "h"
  ],
  UM: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  US: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  UY: [
    "H",
    "h",
    "hB",
    "hb"
  ],
  UZ: [
    "H",
    "hB",
    "h"
  ],
  VA: [
    "H",
    "h",
    "hB"
  ],
  VC: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  VE: [
    "h",
    "H",
    "hB",
    "hb"
  ],
  VG: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  VI: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  VN: [
    "H",
    "h"
  ],
  VU: [
    "h",
    "H"
  ],
  WF: [
    "H",
    "hB"
  ],
  WS: [
    "h",
    "H"
  ],
  XK: [
    "H",
    "hB",
    "h"
  ],
  YE: [
    "h",
    "hB",
    "hb",
    "H"
  ],
  YT: [
    "H",
    "hB"
  ],
  ZA: [
    "H",
    "h",
    "hb",
    "hB"
  ],
  ZM: [
    "h",
    "hb",
    "H",
    "hB"
  ],
  ZW: [
    "H",
    "h"
  ],
  "af-ZA": [
    "H",
    "h",
    "hB",
    "hb"
  ],
  "ar-001": [
    "h",
    "hB",
    "hb",
    "H"
  ],
  "ca-ES": [
    "H",
    "h",
    "hB"
  ],
  "en-001": [
    "h",
    "hb",
    "H",
    "hB"
  ],
  "es-BO": [
    "H",
    "h",
    "hB",
    "hb"
  ],
  "es-BR": [
    "H",
    "h",
    "hB",
    "hb"
  ],
  "es-EC": [
    "H",
    "h",
    "hB",
    "hb"
  ],
  "es-ES": [
    "H",
    "h",
    "hB",
    "hb"
  ],
  "es-GQ": [
    "H",
    "h",
    "hB",
    "hb"
  ],
  "es-PE": [
    "H",
    "h",
    "hB",
    "hb"
  ],
  "fr-CA": [
    "H",
    "h",
    "hB"
  ],
  "gl-ES": [
    "H",
    "h",
    "hB"
  ],
  "gu-IN": [
    "hB",
    "hb",
    "h",
    "H"
  ],
  "hi-IN": [
    "hB",
    "h",
    "H"
  ],
  "it-CH": [
    "H",
    "h",
    "hB"
  ],
  "it-IT": [
    "H",
    "h",
    "hB"
  ],
  "kn-IN": [
    "hB",
    "h",
    "H"
  ],
  "ml-IN": [
    "hB",
    "h",
    "H"
  ],
  "mr-IN": [
    "hB",
    "hb",
    "h",
    "H"
  ],
  "pa-IN": [
    "hB",
    "hb",
    "h",
    "H"
  ],
  "ta-IN": [
    "hB",
    "h",
    "hb",
    "H"
  ],
  "te-IN": [
    "hB",
    "h",
    "H"
  ],
  "zu-ZA": [
    "H",
    "hB",
    "hb",
    "h"
  ]
};
function $r(t, e) {
  for (var s = "", i = 0; i < t.length; i++) {
    var r = t.charAt(i);
    if (r === "j") {
      for (var n = 0; i + 1 < t.length && t.charAt(i + 1) === r; )
        n++, i++;
      var o = 1 + (n & 1), h = n < 2 ? 1 : 3 + (n >> 1), a = "a", l = dr(e);
      for ((l == "H" || l == "k") && (h = 0); h-- > 0; )
        s += a;
      for (; o-- > 0; )
        s = l + s;
    } else
      r === "J" ? s += "H" : s += r;
  }
  return s;
}
function dr(t) {
  var e = t.hourCycle;
  if (e === void 0 && // @ts-ignore hourCycle(s) is not identified yet
  t.hourCycles && // @ts-ignore
  t.hourCycles.length && (e = t.hourCycles[0]), e)
    switch (e) {
      case "h24":
        return "k";
      case "h23":
        return "H";
      case "h12":
        return "h";
      case "h11":
        return "K";
      default:
        throw new Error("Invalid hourCycle");
    }
  var s = t.language, i;
  s !== "root" && (i = t.maximize().region);
  var r = Je[i || ""] || Je[s || ""] || Je["".concat(s, "-001")] || Je["001"];
  return r[0];
}
var ot, gr = new RegExp("^".concat(Ps.source, "*")), Or = new RegExp("".concat(Ps.source, "*$"));
function T(t, e) {
  return { start: t, end: e };
}
var br = !!String.prototype.startsWith && "_a".startsWith("a", 1), mr = !!String.fromCodePoint, Sr = !!Object.fromEntries, Tr = !!String.prototype.codePointAt, vr = !!String.prototype.trimStart, yr = !!String.prototype.trimEnd, Er = !!Number.isSafeInteger, kr = Er ? Number.isSafeInteger : function(t) {
  return typeof t == "number" && isFinite(t) && Math.floor(t) === t && Math.abs(t) <= 9007199254740991;
}, pt = !0;
try {
  var wr = Ds("([^\\p{White_Space}\\p{Pattern_Syntax}]*)", "yu");
  pt = ((ot = wr.exec("a")) === null || ot === void 0 ? void 0 : ot[0]) === "a";
} catch {
  pt = !1;
}
var hs = br ? (
  // Native
  function(e, s, i) {
    return e.startsWith(s, i);
  }
) : (
  // For IE11
  function(e, s, i) {
    return e.slice(i, i + s.length) === s;
  }
), ct = mr ? String.fromCodePoint : (
  // IE11
  function() {
    for (var e = [], s = 0; s < arguments.length; s++)
      e[s] = arguments[s];
    for (var i = "", r = e.length, n = 0, o; r > n; ) {
      if (o = e[n++], o > 1114111)
        throw RangeError(o + " is not a valid code point");
      i += o < 65536 ? String.fromCharCode(o) : String.fromCharCode(((o -= 65536) >> 10) + 55296, o % 1024 + 56320);
    }
    return i;
  }
), as = (
  // native
  Sr ? Object.fromEntries : (
    // Ponyfill
    function(e) {
      for (var s = {}, i = 0, r = e; i < r.length; i++) {
        var n = r[i], o = n[0], h = n[1];
        s[o] = h;
      }
      return s;
    }
  )
), _s = Tr ? (
  // Native
  function(e, s) {
    return e.codePointAt(s);
  }
) : (
  // IE 11
  function(e, s) {
    var i = e.length;
    if (!(s < 0 || s >= i)) {
      var r = e.charCodeAt(s), n;
      return r < 55296 || r > 56319 || s + 1 === i || (n = e.charCodeAt(s + 1)) < 56320 || n > 57343 ? r : (r - 55296 << 10) + (n - 56320) + 65536;
    }
  }
), Rr = vr ? (
  // Native
  function(e) {
    return e.trimStart();
  }
) : (
  // Ponyfill
  function(e) {
    return e.replace(gr, "");
  }
), Ir = yr ? (
  // Native
  function(e) {
    return e.trimEnd();
  }
) : (
  // Ponyfill
  function(e) {
    return e.replace(Or, "");
  }
);
function Ds(t, e) {
  return new RegExp(t, e);
}
var $t;
if (pt) {
  var ls = Ds("([^\\p{White_Space}\\p{Pattern_Syntax}]*)", "yu");
  $t = function(e, s) {
    var i;
    ls.lastIndex = s;
    var r = ls.exec(e);
    return (i = r[1]) !== null && i !== void 0 ? i : "";
  };
} else
  $t = function(e, s) {
    for (var i = []; ; ) {
      var r = _s(e, s);
      if (r === void 0 || As(r) || Jr(r))
        break;
      i.push(r), s += r >= 65536 ? 2 : 1;
    }
    return ct.apply(void 0, i);
  };
var Fr = (
  /** @class */
  function() {
    function t(e, s) {
      s === void 0 && (s = {}), this.message = e, this.position = { offset: 0, line: 1, column: 1 }, this.ignoreTag = !!s.ignoreTag, this.locale = s.locale, this.requiresOtherClause = !!s.requiresOtherClause, this.shouldParseSkeletons = !!s.shouldParseSkeletons;
    }
    return t.prototype.parse = function() {
      if (this.offset() !== 0)
        throw Error("parser can only be used once");
      return this.parseMessage(0, "", !1);
    }, t.prototype.parseMessage = function(e, s, i) {
      for (var r = []; !this.isEOF(); ) {
        var n = this.char();
        if (n === 123) {
          var o = this.parseArgument(e, i);
          if (o.err)
            return o;
          r.push(o.val);
        } else {
          if (n === 125 && e > 0)
            break;
          if (n === 35 && (s === "plural" || s === "selectordinal")) {
            var h = this.clonePosition();
            this.bump(), r.push({
              type: C.pound,
              location: T(h, this.clonePosition())
            });
          } else if (n === 60 && !this.ignoreTag && this.peek() === 47) {
            if (i)
              break;
            return this.error(b.UNMATCHED_CLOSING_TAG, T(this.clonePosition(), this.clonePosition()));
          } else if (n === 60 && !this.ignoreTag && dt(this.peek() || 0)) {
            var o = this.parseTag(e, s);
            if (o.err)
              return o;
            r.push(o.val);
          } else {
            var o = this.parseLiteral(e, s);
            if (o.err)
              return o;
            r.push(o.val);
          }
        }
      }
      return { val: r, err: null };
    }, t.prototype.parseTag = function(e, s) {
      var i = this.clonePosition();
      this.bump();
      var r = this.parseTagName();
      if (this.bumpSpace(), this.bumpIf("/>"))
        return {
          val: {
            type: C.literal,
            value: "<".concat(r, "/>"),
            location: T(i, this.clonePosition())
          },
          err: null
        };
      if (this.bumpIf(">")) {
        var n = this.parseMessage(e + 1, s, !0);
        if (n.err)
          return n;
        var o = n.val, h = this.clonePosition();
        if (this.bumpIf("</")) {
          if (this.isEOF() || !dt(this.char()))
            return this.error(b.INVALID_TAG, T(h, this.clonePosition()));
          var a = this.clonePosition(), l = this.parseTagName();
          return r !== l ? this.error(b.UNMATCHED_CLOSING_TAG, T(a, this.clonePosition())) : (this.bumpSpace(), this.bumpIf(">") ? {
            val: {
              type: C.tag,
              value: r,
              children: o,
              location: T(i, this.clonePosition())
            },
            err: null
          } : this.error(b.INVALID_TAG, T(h, this.clonePosition())));
        } else
          return this.error(b.UNCLOSED_TAG, T(i, this.clonePosition()));
      } else
        return this.error(b.INVALID_TAG, T(i, this.clonePosition()));
    }, t.prototype.parseTagName = function() {
      var e = this.offset();
      for (this.bump(); !this.isEOF() && Br(this.char()); )
        this.bump();
      return this.message.slice(e, this.offset());
    }, t.prototype.parseLiteral = function(e, s) {
      for (var i = this.clonePosition(), r = ""; ; ) {
        var n = this.tryParseQuote(s);
        if (n) {
          r += n;
          continue;
        }
        var o = this.tryParseUnquoted(e, s);
        if (o) {
          r += o;
          continue;
        }
        var h = this.tryParseLeftAngleBracket();
        if (h) {
          r += h;
          continue;
        }
        break;
      }
      var a = T(i, this.clonePosition());
      return {
        val: { type: C.literal, value: r, location: a },
        err: null
      };
    }, t.prototype.tryParseLeftAngleBracket = function() {
      return !this.isEOF() && this.char() === 60 && (this.ignoreTag || // If at the opening tag or closing tag position, bail.
      !Pr(this.peek() || 0)) ? (this.bump(), "<") : null;
    }, t.prototype.tryParseQuote = function(e) {
      if (this.isEOF() || this.char() !== 39)
        return null;
      switch (this.peek()) {
        case 39:
          return this.bump(), this.bump(), "'";
        case 123:
        case 60:
        case 62:
        case 125:
          break;
        case 35:
          if (e === "plural" || e === "selectordinal")
            break;
          return null;
        default:
          return null;
      }
      this.bump();
      var s = [this.char()];
      for (this.bump(); !this.isEOF(); ) {
        var i = this.char();
        if (i === 39)
          if (this.peek() === 39)
            s.push(39), this.bump();
          else {
            this.bump();
            break;
          }
        else
          s.push(i);
        this.bump();
      }
      return ct.apply(void 0, s);
    }, t.prototype.tryParseUnquoted = function(e, s) {
      if (this.isEOF())
        return null;
      var i = this.char();
      return i === 60 || i === 123 || i === 35 && (s === "plural" || s === "selectordinal") || i === 125 && e > 0 ? null : (this.bump(), ct(i));
    }, t.prototype.parseArgument = function(e, s) {
      var i = this.clonePosition();
      if (this.bump(), this.bumpSpace(), this.isEOF())
        return this.error(b.EXPECT_ARGUMENT_CLOSING_BRACE, T(i, this.clonePosition()));
      if (this.char() === 125)
        return this.bump(), this.error(b.EMPTY_ARGUMENT, T(i, this.clonePosition()));
      var r = this.parseIdentifierIfPossible().value;
      if (!r)
        return this.error(b.MALFORMED_ARGUMENT, T(i, this.clonePosition()));
      if (this.bumpSpace(), this.isEOF())
        return this.error(b.EXPECT_ARGUMENT_CLOSING_BRACE, T(i, this.clonePosition()));
      switch (this.char()) {
        case 125:
          return this.bump(), {
            val: {
              type: C.argument,
              // value does not include the opening and closing braces.
              value: r,
              location: T(i, this.clonePosition())
            },
            err: null
          };
        case 44:
          return this.bump(), this.bumpSpace(), this.isEOF() ? this.error(b.EXPECT_ARGUMENT_CLOSING_BRACE, T(i, this.clonePosition())) : this.parseArgumentOptions(e, s, r, i);
        default:
          return this.error(b.MALFORMED_ARGUMENT, T(i, this.clonePosition()));
      }
    }, t.prototype.parseIdentifierIfPossible = function() {
      var e = this.clonePosition(), s = this.offset(), i = $t(this.message, s), r = s + i.length;
      this.bumpTo(r);
      var n = this.clonePosition(), o = T(e, n);
      return { value: i, location: o };
    }, t.prototype.parseArgumentOptions = function(e, s, i, r) {
      var n, o = this.clonePosition(), h = this.parseIdentifierIfPossible().value, a = this.clonePosition();
      switch (h) {
        case "":
          return this.error(b.EXPECT_ARGUMENT_TYPE, T(o, a));
        case "number":
        case "date":
        case "time": {
          this.bumpSpace();
          var l = null;
          if (this.bumpIf(",")) {
            this.bumpSpace();
            var x = this.clonePosition(), u = this.parseSimpleArgStyleIfPossible();
            if (u.err)
              return u;
            var f = Ir(u.val);
            if (f.length === 0)
              return this.error(b.EXPECT_ARGUMENT_STYLE, T(this.clonePosition(), this.clonePosition()));
            var p = T(x, this.clonePosition());
            l = { style: f, styleLocation: p };
          }
          var $ = this.tryParseArgumentClose(r);
          if ($.err)
            return $;
          var O = T(r, this.clonePosition());
          if (l && hs(l == null ? void 0 : l.style, "::", 0)) {
            var w = Rr(l.style.slice(2));
            if (h === "number") {
              var u = this.parseNumberSkeletonFromString(w, l.styleLocation);
              return u.err ? u : {
                val: { type: C.number, value: i, location: O, style: u.val },
                err: null
              };
            } else {
              if (w.length === 0)
                return this.error(b.EXPECT_DATE_TIME_SKELETON, O);
              var A = w;
              this.locale && (A = $r(w, this.locale));
              var f = {
                type: be.dateTime,
                pattern: A,
                location: l.styleLocation,
                parsedOptions: this.shouldParseSkeletons ? ar(A) : {}
              }, D = h === "date" ? C.date : C.time;
              return {
                val: { type: D, value: i, location: O, style: f },
                err: null
              };
            }
          }
          return {
            val: {
              type: h === "number" ? C.number : h === "date" ? C.date : C.time,
              value: i,
              location: O,
              style: (n = l == null ? void 0 : l.style) !== null && n !== void 0 ? n : null
            },
            err: null
          };
        }
        case "plural":
        case "selectordinal":
        case "select": {
          var F = this.clonePosition();
          if (this.bumpSpace(), !this.bumpIf(","))
            return this.error(b.EXPECT_SELECT_ARGUMENT_OPTIONS, T(F, I({}, F)));
          this.bumpSpace();
          var H = this.parseIdentifierIfPossible(), v = 0;
          if (h !== "select" && H.value === "offset") {
            if (!this.bumpIf(":"))
              return this.error(b.EXPECT_PLURAL_ARGUMENT_OFFSET_VALUE, T(this.clonePosition(), this.clonePosition()));
            this.bumpSpace();
            var u = this.tryParseDecimalInteger(b.EXPECT_PLURAL_ARGUMENT_OFFSET_VALUE, b.INVALID_PLURAL_ARGUMENT_OFFSET_VALUE);
            if (u.err)
              return u;
            this.bumpSpace(), H = this.parseIdentifierIfPossible(), v = u.val;
          }
          var y = this.tryParsePluralOrSelectOptions(e, h, s, H);
          if (y.err)
            return y;
          var $ = this.tryParseArgumentClose(r);
          if ($.err)
            return $;
          var g = T(r, this.clonePosition());
          return h === "select" ? {
            val: {
              type: C.select,
              value: i,
              options: as(y.val),
              location: g
            },
            err: null
          } : {
            val: {
              type: C.plural,
              value: i,
              options: as(y.val),
              offset: v,
              pluralType: h === "plural" ? "cardinal" : "ordinal",
              location: g
            },
            err: null
          };
        }
        default:
          return this.error(b.INVALID_ARGUMENT_TYPE, T(o, a));
      }
    }, t.prototype.tryParseArgumentClose = function(e) {
      return this.isEOF() || this.char() !== 125 ? this.error(b.EXPECT_ARGUMENT_CLOSING_BRACE, T(e, this.clonePosition())) : (this.bump(), { val: !0, err: null });
    }, t.prototype.parseSimpleArgStyleIfPossible = function() {
      for (var e = 0, s = this.clonePosition(); !this.isEOF(); ) {
        var i = this.char();
        switch (i) {
          case 39: {
            this.bump();
            var r = this.clonePosition();
            if (!this.bumpUntil("'"))
              return this.error(b.UNCLOSED_QUOTE_IN_ARGUMENT_STYLE, T(r, this.clonePosition()));
            this.bump();
            break;
          }
          case 123: {
            e += 1, this.bump();
            break;
          }
          case 125: {
            if (e > 0)
              e -= 1;
            else
              return {
                val: this.message.slice(s.offset, this.offset()),
                err: null
              };
            break;
          }
          default:
            this.bump();
            break;
        }
      }
      return {
        val: this.message.slice(s.offset, this.offset()),
        err: null
      };
    }, t.prototype.parseNumberSkeletonFromString = function(e, s) {
      var i = [];
      try {
        i = ur(e);
      } catch {
        return this.error(b.INVALID_NUMBER_SKELETON, s);
      }
      return {
        val: {
          type: be.number,
          tokens: i,
          location: s,
          parsedOptions: this.shouldParseSkeletons ? cr(i) : {}
        },
        err: null
      };
    }, t.prototype.tryParsePluralOrSelectOptions = function(e, s, i, r) {
      for (var n, o = !1, h = [], a = /* @__PURE__ */ new Set(), l = r.value, x = r.location; ; ) {
        if (l.length === 0) {
          var u = this.clonePosition();
          if (s !== "select" && this.bumpIf("=")) {
            var f = this.tryParseDecimalInteger(b.EXPECT_PLURAL_ARGUMENT_SELECTOR, b.INVALID_PLURAL_ARGUMENT_SELECTOR);
            if (f.err)
              return f;
            x = T(u, this.clonePosition()), l = this.message.slice(u.offset, this.offset());
          } else
            break;
        }
        if (a.has(l))
          return this.error(s === "select" ? b.DUPLICATE_SELECT_ARGUMENT_SELECTOR : b.DUPLICATE_PLURAL_ARGUMENT_SELECTOR, x);
        l === "other" && (o = !0), this.bumpSpace();
        var p = this.clonePosition();
        if (!this.bumpIf("{"))
          return this.error(s === "select" ? b.EXPECT_SELECT_ARGUMENT_SELECTOR_FRAGMENT : b.EXPECT_PLURAL_ARGUMENT_SELECTOR_FRAGMENT, T(this.clonePosition(), this.clonePosition()));
        var $ = this.parseMessage(e + 1, s, i);
        if ($.err)
          return $;
        var O = this.tryParseArgumentClose(p);
        if (O.err)
          return O;
        h.push([
          l,
          {
            value: $.val,
            location: T(p, this.clonePosition())
          }
        ]), a.add(l), this.bumpSpace(), n = this.parseIdentifierIfPossible(), l = n.value, x = n.location;
      }
      return h.length === 0 ? this.error(s === "select" ? b.EXPECT_SELECT_ARGUMENT_SELECTOR : b.EXPECT_PLURAL_ARGUMENT_SELECTOR, T(this.clonePosition(), this.clonePosition())) : this.requiresOtherClause && !o ? this.error(b.MISSING_OTHER_CLAUSE, T(this.clonePosition(), this.clonePosition())) : { val: h, err: null };
    }, t.prototype.tryParseDecimalInteger = function(e, s) {
      var i = 1, r = this.clonePosition();
      this.bumpIf("+") || this.bumpIf("-") && (i = -1);
      for (var n = !1, o = 0; !this.isEOF(); ) {
        var h = this.char();
        if (h >= 48 && h <= 57)
          n = !0, o = o * 10 + (h - 48), this.bump();
        else
          break;
      }
      var a = T(r, this.clonePosition());
      return n ? (o *= i, kr(o) ? { val: o, err: null } : this.error(s, a)) : this.error(e, a);
    }, t.prototype.offset = function() {
      return this.position.offset;
    }, t.prototype.isEOF = function() {
      return this.offset() === this.message.length;
    }, t.prototype.clonePosition = function() {
      return {
        offset: this.position.offset,
        line: this.position.line,
        column: this.position.column
      };
    }, t.prototype.char = function() {
      var e = this.position.offset;
      if (e >= this.message.length)
        throw Error("out of bound");
      var s = _s(this.message, e);
      if (s === void 0)
        throw Error("Offset ".concat(e, " is at invalid UTF-16 code unit boundary"));
      return s;
    }, t.prototype.error = function(e, s) {
      return {
        val: null,
        err: {
          kind: e,
          message: this.message,
          location: s
        }
      };
    }, t.prototype.bump = function() {
      if (!this.isEOF()) {
        var e = this.char();
        e === 10 ? (this.position.line += 1, this.position.column = 1, this.position.offset += 1) : (this.position.column += 1, this.position.offset += e < 65536 ? 1 : 2);
      }
    }, t.prototype.bumpIf = function(e) {
      if (hs(this.message, e, this.offset())) {
        for (var s = 0; s < e.length; s++)
          this.bump();
        return !0;
      }
      return !1;
    }, t.prototype.bumpUntil = function(e) {
      var s = this.offset(), i = this.message.indexOf(e, s);
      return i >= 0 ? (this.bumpTo(i), !0) : (this.bumpTo(this.message.length), !1);
    }, t.prototype.bumpTo = function(e) {
      if (this.offset() > e)
        throw Error("targetOffset ".concat(e, " must be greater than or equal to the current offset ").concat(this.offset()));
      for (e = Math.min(e, this.message.length); ; ) {
        var s = this.offset();
        if (s === e)
          break;
        if (s > e)
          throw Error("targetOffset ".concat(e, " is at invalid UTF-16 code unit boundary"));
        if (this.bump(), this.isEOF())
          break;
      }
    }, t.prototype.bumpSpace = function() {
      for (; !this.isEOF() && As(this.char()); )
        this.bump();
    }, t.prototype.peek = function() {
      if (this.isEOF())
        return null;
      var e = this.char(), s = this.offset(), i = this.message.charCodeAt(s + (e >= 65536 ? 2 : 1));
      return i ?? null;
    }, t;
  }()
);
function dt(t) {
  return t >= 97 && t <= 122 || t >= 65 && t <= 90;
}
function Pr(t) {
  return dt(t) || t === 47;
}
function Br(t) {
  return t === 45 || t === 46 || t >= 48 && t <= 57 || t === 95 || t >= 97 && t <= 122 || t >= 65 && t <= 90 || t == 183 || t >= 192 && t <= 214 || t >= 216 && t <= 246 || t >= 248 && t <= 893 || t >= 895 && t <= 8191 || t >= 8204 && t <= 8205 || t >= 8255 && t <= 8256 || t >= 8304 && t <= 8591 || t >= 11264 && t <= 12271 || t >= 12289 && t <= 55295 || t >= 63744 && t <= 64975 || t >= 65008 && t <= 65533 || t >= 65536 && t <= 983039;
}
function As(t) {
  return t >= 9 && t <= 13 || t === 32 || t === 133 || t >= 8206 && t <= 8207 || t === 8232 || t === 8233;
}
function Jr(t) {
  return t >= 33 && t <= 35 || t === 36 || t >= 37 && t <= 39 || t === 40 || t === 41 || t === 42 || t === 43 || t === 44 || t === 45 || t >= 46 && t <= 47 || t >= 58 && t <= 59 || t >= 60 && t <= 62 || t >= 63 && t <= 64 || t === 91 || t === 92 || t === 93 || t === 94 || t === 96 || t === 123 || t === 124 || t === 125 || t === 126 || t === 161 || t >= 162 && t <= 165 || t === 166 || t === 167 || t === 169 || t === 171 || t === 172 || t === 174 || t === 176 || t === 177 || t === 182 || t === 187 || t === 191 || t === 215 || t === 247 || t >= 8208 && t <= 8213 || t >= 8214 && t <= 8215 || t === 8216 || t === 8217 || t === 8218 || t >= 8219 && t <= 8220 || t === 8221 || t === 8222 || t === 8223 || t >= 8224 && t <= 8231 || t >= 8240 && t <= 8248 || t === 8249 || t === 8250 || t >= 8251 && t <= 8254 || t >= 8257 && t <= 8259 || t === 8260 || t === 8261 || t === 8262 || t >= 8263 && t <= 8273 || t === 8274 || t === 8275 || t >= 8277 && t <= 8286 || t >= 8592 && t <= 8596 || t >= 8597 && t <= 8601 || t >= 8602 && t <= 8603 || t >= 8604 && t <= 8607 || t === 8608 || t >= 8609 && t <= 8610 || t === 8611 || t >= 8612 && t <= 8613 || t === 8614 || t >= 8615 && t <= 8621 || t === 8622 || t >= 8623 && t <= 8653 || t >= 8654 && t <= 8655 || t >= 8656 && t <= 8657 || t === 8658 || t === 8659 || t === 8660 || t >= 8661 && t <= 8691 || t >= 8692 && t <= 8959 || t >= 8960 && t <= 8967 || t === 8968 || t === 8969 || t === 8970 || t === 8971 || t >= 8972 && t <= 8991 || t >= 8992 && t <= 8993 || t >= 8994 && t <= 9e3 || t === 9001 || t === 9002 || t >= 9003 && t <= 9083 || t === 9084 || t >= 9085 && t <= 9114 || t >= 9115 && t <= 9139 || t >= 9140 && t <= 9179 || t >= 9180 && t <= 9185 || t >= 9186 && t <= 9254 || t >= 9255 && t <= 9279 || t >= 9280 && t <= 9290 || t >= 9291 && t <= 9311 || t >= 9472 && t <= 9654 || t === 9655 || t >= 9656 && t <= 9664 || t === 9665 || t >= 9666 && t <= 9719 || t >= 9720 && t <= 9727 || t >= 9728 && t <= 9838 || t === 9839 || t >= 9840 && t <= 10087 || t === 10088 || t === 10089 || t === 10090 || t === 10091 || t === 10092 || t === 10093 || t === 10094 || t === 10095 || t === 10096 || t === 10097 || t === 10098 || t === 10099 || t === 10100 || t === 10101 || t >= 10132 && t <= 10175 || t >= 10176 && t <= 10180 || t === 10181 || t === 10182 || t >= 10183 && t <= 10213 || t === 10214 || t === 10215 || t === 10216 || t === 10217 || t === 10218 || t === 10219 || t === 10220 || t === 10221 || t === 10222 || t === 10223 || t >= 10224 && t <= 10239 || t >= 10240 && t <= 10495 || t >= 10496 && t <= 10626 || t === 10627 || t === 10628 || t === 10629 || t === 10630 || t === 10631 || t === 10632 || t === 10633 || t === 10634 || t === 10635 || t === 10636 || t === 10637 || t === 10638 || t === 10639 || t === 10640 || t === 10641 || t === 10642 || t === 10643 || t === 10644 || t === 10645 || t === 10646 || t === 10647 || t === 10648 || t >= 10649 && t <= 10711 || t === 10712 || t === 10713 || t === 10714 || t === 10715 || t >= 10716 && t <= 10747 || t === 10748 || t === 10749 || t >= 10750 && t <= 11007 || t >= 11008 && t <= 11055 || t >= 11056 && t <= 11076 || t >= 11077 && t <= 11078 || t >= 11079 && t <= 11084 || t >= 11085 && t <= 11123 || t >= 11124 && t <= 11125 || t >= 11126 && t <= 11157 || t === 11158 || t >= 11159 && t <= 11263 || t >= 11776 && t <= 11777 || t === 11778 || t === 11779 || t === 11780 || t === 11781 || t >= 11782 && t <= 11784 || t === 11785 || t === 11786 || t === 11787 || t === 11788 || t === 11789 || t >= 11790 && t <= 11798 || t === 11799 || t >= 11800 && t <= 11801 || t === 11802 || t === 11803 || t === 11804 || t === 11805 || t >= 11806 && t <= 11807 || t === 11808 || t === 11809 || t === 11810 || t === 11811 || t === 11812 || t === 11813 || t === 11814 || t === 11815 || t === 11816 || t === 11817 || t >= 11818 && t <= 11822 || t === 11823 || t >= 11824 && t <= 11833 || t >= 11834 && t <= 11835 || t >= 11836 && t <= 11839 || t === 11840 || t === 11841 || t === 11842 || t >= 11843 && t <= 11855 || t >= 11856 && t <= 11857 || t === 11858 || t >= 11859 && t <= 11903 || t >= 12289 && t <= 12291 || t === 12296 || t === 12297 || t === 12298 || t === 12299 || t === 12300 || t === 12301 || t === 12302 || t === 12303 || t === 12304 || t === 12305 || t >= 12306 && t <= 12307 || t === 12308 || t === 12309 || t === 12310 || t === 12311 || t === 12312 || t === 12313 || t === 12314 || t === 12315 || t === 12316 || t === 12317 || t >= 12318 && t <= 12319 || t === 12320 || t === 12336 || t === 64830 || t === 64831 || t >= 65093 && t <= 65094;
}
function gt(t) {
  t.forEach(function(e) {
    if (delete e.location, sr(e) || ir(e))
      for (var s in e.options)
        delete e.options[s].location, gt(e.options[s].value);
    else
      ji(e) && nr(e.style) || (er(e) || tr(e)) && or(e.style) ? delete e.style.location : rr(e) && gt(e.children);
  });
}
function Cr(t, e) {
  e === void 0 && (e = {}), e = I({ shouldParseSkeletons: !0, requiresOtherClause: !0 }, e);
  var s = new Fr(t, e).parse();
  if (s.err) {
    var i = SyntaxError(b[s.err.kind]);
    throw i.location = s.err.location, i.originalMessage = s.err.message, i;
  }
  return e != null && e.captureLocation || gt(s.val), s.val;
}
function _r(t) {
  return Cr(t, { ignoreTag: !0 });
}
const Kr = (t) => {
  const { parameter: e, variants: s } = t;
  if (!e)
    return s.other ?? "";
  if (!Zi(e))
    throw new Error(`Parameter name "${e}" is invalid`);
  const i = [`{${e}, plural,`];
  s.other || (s.other = "");
  let r = !0;
  for (const [n, o] of Object.entries(s)) {
    r && o && (r = !1);
    try {
      _r(`{${e}, plural, other {${o}}}`), i.push(` ${n} {${o}}`);
    } catch {
      i.push(` ${n} {${Ki(o || "")}}`);
    }
  }
  return r ? "" : (i.push("}"), i.join(""));
}, us = {
  0: yt,
  4: Et,
  5: Ss,
  // this also excludes 'offset:x'
  6: Ts
};
function De(t, e) {
  return e.substring(t.from, t.to);
}
function Dr(t, e) {
  let s = t.firstChild;
  do
    if ((s == null ? void 0 : s.type.id) === fi)
      return De(s, e);
  while (s = s == null ? void 0 : s.nextSibling);
  return "";
}
function Te(t) {
  return { variants: { other: t } };
}
const Ar = (t) => {
  let e;
  try {
    e = wt.configure({ strict: !0 }).parse(t);
  } catch {
    return Te(t);
  }
  const s = e.cursor(), i = {}, r = {}, n = Object.keys(us), o = Number(n[n.length - 1]);
  for (let a = 0; a <= o; a++) {
    s.next();
    const l = s.node, x = us[a];
    if (x !== void 0)
      if (x === l.type.id)
        i[l.type.id] = l;
      else
        return Te(t);
  }
  if (i[yt].nextSibling || De(i[Ss], t) !== "plural")
    return Te(t);
  let h = i[Ts];
  do {
    const a = De(h.firstChild, t), l = Dr(h, t);
    if (r[a] !== void 0)
      return Te(t);
    r[a] = l;
  } while (h = h.nextSibling);
  return {
    parameter: De(i[Et], t),
    variants: r
  };
}, jr = (t, e) => e ? Ar(t || "") : { variants: { other: t } }, Nr = [6, 7, 8, 11, 20, 21, 1e6, 0.5, 0.1, 0], Hr = [0, 2, 3, 4, 6], Gr = [10, 11, 20, 100, 0, 0, 0.1, 2, 3, 4], Wr = [
  "zero",
  "one",
  "two",
  "few",
  "many",
  "other"
], en = (t) => {
  const e = new Set(
    new Intl.PluralRules(t).resolvedOptions().pluralCategories
  );
  return Wr.filter((s) => e.has(s));
}, ce = (t, e, s) => {
  const i = new Intl.PluralRules(e);
  return s.find((r) => i.select(r) === t);
}, tn = (t, e) => {
  switch (e) {
    case "zero":
      return ce("zero", t, [0]);
    case "one":
      return ce("one", t, [1]);
    case "two":
      return ce("two", t, [2]);
    case "few":
      return ce("few", t, Hr);
    case "many":
      return ce("many", t, Nr);
    case "other":
      return ce("other", t, Gr);
  }
}, sn = (t) => {
  const e = [
    "ar",
    "arc",
    "dv",
    "fa",
    "ha",
    "he",
    "khw",
    "ks",
    "ku",
    "ps",
    "ur",
    "yi"
  ], s = t.replace(/^([a-zA-Z]+)(.*?)$/, "$1");
  return e.indexOf(s) > -1 ? "rtl" : "ltr";
};
export {
  qr as PlaceholderPlugin,
  Yr as TolgeeHighlight,
  Zi as checkParamNameIsValid,
  Zr as generatePlaceholdersStyle,
  sn as getLanguageDirection,
  Si as getPlaceholders,
  en as getPluralVariants,
  jr as getTolgeeFormat,
  tn as getVariantExample,
  Qr as htmlIsolatesPlugin,
  Kr as tolgeeFormatGenerateIcu,
  wt as tolgeeParser,
  Mr as tolgeeSyntax
};
